/*
 * This file is part of Rahmenwerk.
 * 
 * Rahmenwerk is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License  as 
 * published by the Free Software Foundation, either version 3 of the
 * License.
 * 
 * Rahmenwerk is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with Rahmenwerk.  If not, see <http://www.gnu.org/licenses/>.
 *  
 *  
 * 
 * Copyright (c) 2012 SWARCO TRAFFIC SYSTEMS GmbH.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 * SWARCO TRAFFIC SYSTEMS GmbH - initial API and implementation
 * 
 * 
 * 
 * Contact Information:
 * SWARCO TRAFFIC SYSTEMS GmbH
 * Adolf-Dambach-Strae 
 * D-76571 Gaggenau
 * Phone: +49-7225-64-03
 * Fax: +49-7225-64-300
 * mailto: office.sts@swarco.de
 */
package de.bsvrz.buv.plugin.anlagendarstellung.figures;

import java.util.ArrayList;
import java.util.List;

import org.eclipse.draw2d.ColorConstants;
import org.eclipse.draw2d.Figure;
import org.eclipse.draw2d.Label;
import org.eclipse.draw2d.LineBorder;
import org.eclipse.draw2d.ToolbarLayout;
import org.eclipse.swt.graphics.Color;

/**
 * Figure, welche die Tabelle der Verkehrsdaten reprsentiert.               
 * 
 * @author Pittner
 * 
 */
public class TabellenMqFigure extends Figure
{
  public static Color classColor = new Color(null, 255, 255, 206);

  public static Color lineColor = ColorConstants.gray;

  private Label name = null;

  private List<TabellenMqZeilenFigure> listCompartment = new ArrayList<TabellenMqZeilenFigure>();

  public TabellenMqFigure(Label name, boolean flag)
  {
    ToolbarLayout layout = new ToolbarLayout();
    setLayoutManager(layout);
    setBorder(new LineBorder(lineColor, 1));
    setBackgroundColor(classColor);
    setOpaque(true);

    this.name = name;

    TabellenMqZeilenFigure cf1 = new TabellenMqZeilenFigure(flag);
    TabellenMqZeilenFigure cf2 = new TabellenMqZeilenFigure(flag);

    listCompartment.add(cf1);
    listCompartment.add(cf2);

    add(name);
    add(cf1);
    add(cf2);
  }

  public TabellenMqFigure(boolean flag, int size)
  {
    ToolbarLayout layout = new ToolbarLayout();
    setLayoutManager(layout);
    setBorder(new LineBorder(lineColor, 1));
    setBackgroundColor(classColor);
    setOpaque(true);

    for (int i = 0; i < size; i++)
    {
      TabellenMqZeilenFigure cf = new TabellenMqZeilenFigure(flag);
      listCompartment.add(cf);
      add(cf);
    }
  }

  public Label getName()
  {
    return name;
  }

  public List<TabellenMqZeilenFigure> getListCompartments()
  {
    return listCompartment;
  }

  public void setListCompartments(List<TabellenMqZeilenFigure> listCompartment)
  {
    for (int i = 0; i < this.listCompartment.size(); i++)
    {
      if (this.listCompartment.size() >= i)
      {
        TabellenMqZeilenFigure alt = this.listCompartment.get(i);
        remove(alt);
      }
    }
    for (int i = 0; i < listCompartment.size(); i++)
    {
      TabellenMqZeilenFigure neu = listCompartment.get(i);
      add(neu);
    }

    this.listCompartment = listCompartment;
  }
}
