 
package de.bsvrz.buv.plugin.anlagendarstellung.legende;


/**
 * Anzeigequerschnittdefinition.
 * 
 * @author Pittner
 */
public enum LegendeDefinitionAnzeigeQuerschnittProgramm {

  /** Helligkeit */
  AUTOMATIK_BETRIEB("Automatikbetrieb", "icons/legende/prg1_a_15x15.png"),
	/** Helligkeit */
	HAND_BETRIEB("Handbetrieb", "icons/legende/prg1_h_15x15.png"),
	/** Helligkeit */
	SONDER_PROGRAMM("Sonderprogramm", "icons/legende/prg1_s_15x15.png"),
	/** Helligkeit */
	VOR_ORT_BETRIEB("Vor-Ort-Betrieb", "icons/legende/prg1_v_15x15.png"),
	/** Helligkeit */
	AUTARK_BETRIEB("Autark-Betrieb", "icons/legende/prg1_x_15x15.png"),
	/** Helligkeit */
	TUNNEL_BETRIEB("Tunnel-Betrieb", "icons/legende/prg1_y_15x15.png"),
	/** Helligkeit */
	BLIND_AUTOMATIK_BETRIEB("Blindbetrieb-Automatik", "icons/legende/prg2_a_15x15.png"),
	/** Helligkeit */
	BLIND_HAND_BETRIEB("Blindbetrieb-Hand", "icons/legende/prg2_h_15x15.png"),
	/** Helligkeit */
	BLIND_SONDER_PROGRAMM("Blindbetrieb-Sonderprogramm", "icons/legende/prg2_s_15x15.png");

  public static final String BEZEICHNUNG = "Programm-Status";

  /** Name der Funktionsgruppe. */
	private String name;
	
	/** Farbe der Funktionsgruppe. */
	private String path;

	/**
	 * Privater Konstruktor.
	 * 
	 * @param name
	 *            Name des Zustandes
	 */
	private LegendeDefinitionAnzeigeQuerschnittProgramm(final String name, String path) {
		this.name = name;
		this.path = path;
	}

	/**
	 * Gibt den Namen der Funktionsgruppe zur&uuml;ck.
	 * 
	 * @return Name des Zustandes
	 */
	public String getName() {
		return name;
	}
	
	/**
	 * Gibt den Namen der Funktionsgruppe zur&uuml;ck.
	 * 
	 * @return Name des Zustandes
	 */
	public String getPfad() {
	  return path;
	}
	
	 public String getBezeichnnung()
	  {
	    // TODO Auto-generated method stub
	    return BEZEICHNUNG;
	  }
}
