 
package de.bsvrz.buv.plugin.anlagendarstellung.legende;

import org.eclipse.draw2d.ColorConstants;
import org.eclipse.swt.graphics.Color;

/**
 * Verkehrslagedefinition. Wird fr alle Fahrstreifen, Anschlussstellen und MQ verwendet
 * 
 * @author Pittner
 */
public enum LegendeDefinitionVerkehrsLageParam {
	/** Unbekannt. */
	KEINE_AUSSAGE("keine Verkehrslage-Information", ColorConstants.gray);

//	/** Gest&ouml;rt. */
//	PASSIVIERT("passiviert", ColorConstants.white),
//	
//	/** Gest&ouml;rt. */
//	FREI("frei", ColorConstants.lightGreen),
//	
//	/** Gest&ouml;rt. */
//	LEBHAFT("lebhaft", ColorConstants.green),
//
//	/** Teilgest&ouml;rt. */
//	DICHT("dicht", ColorConstants.yellow),
//	
//	/** Teilgest&ouml;rt. */
//	ZAEHFLIESSEND("zhflieend", ColorConstants.orange),
//
//	/** keine St&ouml;rung. */
//	STAU("Stau", ColorConstants.red);

	public static final String BEZEICHNUNG = "Verkehrslage MARZ";

  /** Name des Zustandes. */
	private String name;
	
	/** Name des Zustandes. */
	private Color color;
 
	
	/**
	 * Privater Konstruktor.
	 * 
	 * @param name
	 *            Name des Zustandes
	 */
	private LegendeDefinitionVerkehrsLageParam(final String name, Color color) {
	  this.name = name;
	  this.color = color;
	}

	/**
	 * Gibt den Namen des Zustandes zur&uuml;ck.
	 * 
	 * @return Name des Zustandes
	 */
	public String getName() {
		return name;
	}
	
	/**
	 * Gibt die Farbe des Zustandes zur&uuml;ck.
	 * 
	 * @return Farbe des Zustandes
	 */
	public Color getColor() {
	  return color;
	}
	
 
	 public String getBezeichnnung()
   {
     // TODO Auto-generated method stub
     return BEZEICHNUNG;
   }
	
}
