/*
 * This file is part of Rahmenwerk.
 * 
 * Rahmenwerk is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License  as 
 * published by the Free Software Foundation, either version 3 of the
 * License.
 * 
 * Rahmenwerk is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with Rahmenwerk.  If not, see <http://www.gnu.org/licenses/>.
 *  
 *  
 * 
 * Copyright (c) 2012 SWARCO TRAFFIC SYSTEMS GmbH.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 * SWARCO TRAFFIC SYSTEMS GmbH - initial API and implementation
 * 
 * 
 * 
 * Contact Information:
 * SWARCO TRAFFIC SYSTEMS GmbH
 * Adolf-Dambach-Strae 
 * D-76571 Gaggenau
 * Phone: +49-7225-64-03
 * Fax: +49-7225-64-300
 * mailto: office.sts@swarco.de
 */
package de.bsvrz.buv.plugin.anlagendarstellung.model;

import org.eclipse.draw2d.geometry.Rectangle;

import de.bsvrz.buv.plugin.anlagendarstellung.status.Status;
import de.bsvrz.buv.plugin.anlagendarstellung.status.StatusEakSmUzVrz;

/**
 * Model Object of a ZusatzElement, wird aus Kompatibilittsgrunden bentigt
 * 
 * @deprecated  
 * @author Pittner
 * 
 */
public class ZusatzElement extends PropertyAwareObject
{
  private String _id;

  private ZusatzElementTyp _typ;

  private ZusatzElementTyp _wert;
 
  private Status _status;

  protected ZusatzElement()
  {
  }

  public ZusatzElement(String id, ZusatzElementTyp typ, ZusatzElementTyp wert)
  {
    this._id = id;
    this._typ = typ;
    this._wert = wert;
    _status = new StatusEakSmUzVrz();
  }

  /**
   * Returns the persistent position and size of the node. The edit part handling this node has the task to translate it
   * into a constraint that enables the draw2D system to place the figure of the node. Therefore, the coordinate system
   * of the rectangle is known only to the edit part (but in fact, in this example it is always the local coordinate
   * system of the figure of the node).
   */
  public Rectangle getConstraint()
  {
    return (Rectangle)getProperty(CONSTRAINT);
  }

  /**
   * Sets the persistent position and size of the node.
   * 
   * @param constraint
   *          The data that enables the edit part handling this node to create a constraint that enables the draw2D
   *          system to place the figure of the node.
   */
  public void setConstraint(Rectangle constraint)
  {
    setProperty(CONSTRAINT, constraint);
  }

  public String getId()
  {
    return _id;
  }

  public void setId(String id)
  {
    _id = id;
  }

  public ZusatzElementTyp getTyp()
  {
    return _typ;
  }

  public void setTyp(ZusatzElementTyp typ)
  {
    _typ = typ;
  }

  public ZusatzElementTyp getWert()
  {
    return _wert;
  }

  public void setWert(ZusatzElementTyp wert)
  {
    _wert = wert;
  }
}
