/*
 * This file is part of Rahmenwerk.
 * 
 * Rahmenwerk is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License  as 
 * published by the Free Software Foundation, either version 3 of the
 * License.
 * 
 * Rahmenwerk is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with Rahmenwerk.  If not, see <http://www.gnu.org/licenses/>.
 *  
 *  
 * 
 * Copyright (c) 2012 SWARCO TRAFFIC SYSTEMS GmbH.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 * SWARCO TRAFFIC SYSTEMS GmbH - initial API and implementation
 * 
 * 
 * 
 * Contact Information:
 * SWARCO TRAFFIC SYSTEMS GmbH
 * Adolf-Dambach-Strae 
 * D-76571 Gaggenau
 * Phone: +49-7225-64-03
 * Fax: +49-7225-64-300
 * mailto: office.sts@swarco.de
 */
package de.bsvrz.buv.plugin.parameter.ufd.haqparam;

import org.eclipse.swt.graphics.Point;

import de.bsvrz.buv.plugin.parameter.ufd.Activator;
import de.bsvrz.buv.plugin.parameter.ufd.common.AbstractAuswahlViewParameter;
import de.bsvrz.buv.plugin.parameter.ufd.nsparam.NSViewParameter;

/**
 * Parameter-Auswahl-View fr Parameter
 * 
 * @author Sans
 *
 */
public class HAQAuswahlViewParameter extends AbstractAuswahlViewParameter
{

  public static String ID = "de.bsvrz.buv.plugin.parameter.ufd.haqparamAuswahlView";

  @Override
  protected String getDescription()
  {
    return "Auswahl AnzeigequerschnittSBA:";
  }

  @Override
  protected String getHelpId()
  {
    return Activator.PLUGIN_ID + ".parameterHAQAuswahl";
  }

  @Override
  protected String getObjectType()
  {
    return "typ.sswSbaAnzeigeQuerschnitt";
  }

  @Override
  public String getViewId()
  {
    return HAQViewParameter.ID;
  }

  @Override
  public Point getViewSize()
  {
    return new Point(770, 680);
  }
  
}
