/*******************************************************************************
 * This file is part of Rahmenwerk.
 * 
 * Rahmenwerk is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License  as 
 * published by the Free Software Foundation, either version 3 of the
 * License.
 * 
 * Rahmenwerk is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with Rahmenwerk.  If not, see <http://www.gnu.org/licenses/>.
 *  
 *  
 * 
 * Copyright (c) 2012 SWARCO TRAFFIC SYSTEMS GmbH.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 * SWARCO TRAFFIC SYSTEMS GmbH - initial API and implementation
 * 
 * 
 * 
 * Contact Information:
 * SWARCO TRAFFIC SYSTEMS GmbH
 * Adolf-Dambach-Strae 
 * D-76571 Gaggenau
 * Phone: +49-7225-64-03
 * Fax: +49-7225-64-300
 * mailto: office.sts@swarco.de
 ******************************************************************************/
package de.bsvrz.buv.plugin.pua.a81.projektInfo;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;

import de.bsvrz.buv.plugin.pua.basis.expose.IPIGanglinienKonvertierung;
import de.bsvrz.buv.plugin.pua.basis.expose.IProjektInfo;

public class ProjektInfoSchaltbildAnzeige extends ProjektInfoAqBefehle implements IPIGanglinienKonvertierung {
  
  protected final static String LIST_DESC = " - AnzInh,Prio,PrgStatus,Quelle,Schaltgrund";

	public ProjektInfoSchaltbildAnzeige() {
		List<String> ausgabeTabelleSpalten = new ArrayList<String>(_ausgabeTabelleSpalten);
		for (int i = 0; i < ausgabeTabelleSpalten.size(); i += 1) {
			String spaltenTextIst = ausgabeTabelleSpalten.get(i);
			String spaltenTextSoll = spaltenTextIst + LIST_DESC;
			_ausgabeTabelleSpalten.set(i, spaltenTextSoll);
		}
	}

  @Override
  public String getWertKonvertiert(String attribut, String wert, String objekt)
  {
      // Wenn Komma-separierte Liste mit 5 Eintrgen
      String[] werteArray = wert.split(",");
      if (werteArray.length == 5) {

        String key = null;
          String value = werteArray[0];
        
        for (Map.Entry<String, String> entry: _bildInhalt.entrySet()) {
          if (entry.getValue().equals(value)) {
            key = entry.getKey();
            break;
          }
        }
        
        if (key != null) {
          Integer result;
          if (key.equals("Dunkel") && "Stau".equals(werteArray[4])) {
            result = _bildInhaltWerte.get("TLS.DunkelStau");
          }
          else {
            result = _bildInhaltWerte.get(key);  
          }
          if (result == null) {
            result = 200;
          }
          return String.valueOf(result);
        }
        else {
          return null;  
        }
        
      }
      else {
        return null;
      }      
  }
  
  @Override
  public String getAttributKonvertiert(String attribut)
  {
    String result = super.getAttributKonvertiert(attribut);
    result = result.replace(LIST_DESC, "");
    return result ;
  }
	
}
