/*
 * This file is part of Rahmenwerk.
 * 
 * Rahmenwerk is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License  as 
 * published by the Free Software Foundation, either version 3 of the
 * License.
 * 
 * Rahmenwerk is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with Rahmenwerk.  If not, see <http://www.gnu.org/licenses/>.
 *  
 *  
 * 
 * Copyright (c) 2012 SWARCO TRAFFIC SYSTEMS GmbH.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 * SWARCO TRAFFIC SYSTEMS GmbH - initial API and implementation
 * 
 * 
 * 
 * Contact Information:
 * SWARCO TRAFFIC SYSTEMS GmbH
 * Adolf-Dambach-Strae 
 * D-76571 Gaggenau
 * Phone: +49-7225-64-03
 * Fax: +49-7225-64-300
 * mailto: office.sts@swarco.de
 */
/*
 * This file is part of Rahmenwerk.
 *
 * Rahmenwerk is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License  as 
 * published by the Free Software Foundation, either version 3 of the
 * License.
 *
 * Rahmenwerk is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with Rahmenwerk.  If not, see <http://www.gnu.org/licenses/>.
 *
 *
 *
 * Copyright (c) 2011 SWARCO TRAFFIC SYSTEMS GmbH.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 * SWARCO TRAFFIC SYSTEMS GmbH - initial API and implementation
 *
 *
 *
 * Contact Information:
 * SWARCO TRAFFIC SYSTEMS GmbH
 * Adolf-Dambach-Strae 
 * D-76571 Gaggenau
 * Phone: +49-7225-64-03
 * Fax: +49-7225-64-300
 * mailto: office.sts@swarco.de
 */

package de.bsvrz.buv.plugin.pua.basis.dav;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

/**
 * Represents our allowable data types
 * 
 * @author Pittner
 * 
 */
public class ProtokollierungsAnfrageTyp
{

  private static List typen = new ArrayList();

  public static ProtokollierungsAnfrageTyp STOERUNG = new ProtokollierungsAnfrageTyp("Strung");

  public static ProtokollierungsAnfrageTyp RUECKMELDUNG = new ProtokollierungsAnfrageTyp("Rckmeldung");

  public static ProtokollierungsAnfrageTyp BEFEHLE = new ProtokollierungsAnfrageTyp("Befehle");

  public static ProtokollierungsAnfrageTyp BETRIEBSMELDUNG = new ProtokollierungsAnfrageTyp("Betriebsmeldung");

  private String typ;

  private ProtokollierungsAnfrageTyp(String type)
  {
    this.typ = type;
    String typeToAdd = this.getType();
    typen.add(typeToAdd);
  }

  /**
   * @return Returns the type.
   */
  public String getType()
  {
    return typ;
  }

  public static boolean hasType(String type)
  {
    return typen.contains(type.toUpperCase());
  }

  public static String getTypes()
  {
    StringBuffer typeBuffer = new StringBuffer();
    for (Iterator iter = typen.iterator(); iter.hasNext();)
    {
      String element = (String)iter.next();
      typeBuffer.append(element).append(", ");
    }
    if (typen.size() >= 1)
    {
      typeBuffer.delete(typeBuffer.length() - 2, typeBuffer.length());
    }
    return typeBuffer.toString();
  }

  /*
   * (non-Javadoc)
   * 
   * @see de.bsvrz.buv.plugin.zustandsdarstellung.status.Status#setStatus(java.lang.String)
   */
  public ProtokollierungsAnfrageTyp setTyp(String s)
  {
    // TODO Auto-generated method stub
    ProtokollierungsAnfrageTyp zet = null;

    if (s.equals(STOERUNG.getType()))
      zet = STOERUNG;
    else if (s.equals(RUECKMELDUNG.getType()))
      zet = RUECKMELDUNG;
    else if (s.equals(BEFEHLE.getType()))
      zet = BEFEHLE;
    else if (s.equals(BETRIEBSMELDUNG.getType()))
      zet = BETRIEBSMELDUNG;
    else
    {

    }

    return zet;
  }

}
