/*
 * This file is part of Rahmenwerk.
 * 
 * Rahmenwerk is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License  as 
 * published by the Free Software Foundation, either version 3 of the
 * License.
 * 
 * Rahmenwerk is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with Rahmenwerk.  If not, see <http://www.gnu.org/licenses/>.
 *  
 *  
 * 
 * Copyright (c) 2012 SWARCO TRAFFIC SYSTEMS GmbH.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 * SWARCO TRAFFIC SYSTEMS GmbH - initial API and implementation
 * 
 * 
 * 
 * Contact Information:
 * SWARCO TRAFFIC SYSTEMS GmbH
 * Adolf-Dambach-Strae 
 * D-76571 Gaggenau
 * Phone: +49-7225-64-03
 * Fax: +49-7225-64-300
 * mailto: office.sts@swarco.de
 */
package de.bsvrz.buv.plugin.pua.basis.expose;

import java.util.ArrayList;
import java.util.Date;
import java.util.HashMap;
import java.util.LinkedHashMap;
import java.util.List;
import java.util.Map;

import de.bsvrz.buv.plugin.pua.basis.DaVKommunikation;
import de.bsvrz.buv.plugin.pua.basis.pua.daten.ProtokollInformationen;
import de.bsvrz.buv.plugin.pua.basis.views.ProtokollAusgabeSicht;
import de.bsvrz.buv.plugin.pua.basis.views.Tools;
import de.bsvrz.dav.daf.main.ClientDavInterface;
import de.bsvrz.dav.daf.main.config.SystemObject;
import de.bsvrz.pua.prot.client.dataobject.ProtocolResultData;
import de.bsvrz.pua.prot.data.ProtocolData;


public class NachbereitungTSFBefehl extends NachbereitungDefault {
	
	ProtokollInformationen _protokollInformationen = null;
	long[] _timeStampArray = null;
	
//	boolean containsValidData(DataInformation info) {
//		boolean result = true;
//		
//		if ((info.archiveInfo & DataInformation.ERASED) == DataInformation.ERASED
//		 || (info.archiveInfo & DataInformation.UNAVAILABLE_BLOCK) == DataInformation.UNAVAILABLE_BLOCK
////		 || (info.dataGap & DataInformation.INDEX_NOT_CONTINUOUS) == DataInformation.INDEX_NOT_CONTINUOUS
////		 || (info.dataGap & DataInformation.INITIALIZATION) == DataInformation.INITIALIZATION
//		 || (info.dataGap & DataInformation.POTENTIAL_DATA_GAP) == DataInformation.POTENTIAL_DATA_GAP
//		 || (info.dataGap & DataInformation.ENDING) == DataInformation.ENDING
////		 || (info.tag | DataInformation.END_OF_INTERVAL) == DataInformation.END_OF_INTERVAL
//		 || (info.noPayload & DataInformation.NO_DATA) == DataInformation.NO_DATA
//		 || (info.noPayload & DataInformation.NO_SOURCE) == DataInformation.NO_SOURCE
//		 || (info.noPayload & DataInformation.NO_RIGHTS) == DataInformation.NO_RIGHTS
//		) {
//			return false;
//		}
//		
//		return result;
//	}

	
	@Override
	public List<String[]> getZellenInhalte(List<SystemObject> objekte, int[] objektZuordnung, 
			ProtocolResultData prd, IProjektInfo projektInfo, ProtokollInformationen protokollInformationen) {
		
		if (projektInfo == null) {
			throw new IllegalArgumentException("ProjektInfo darf nicht null sein");
		}
				
		if (_protokollInformationen != protokollInformationen) {
			_protokollInformationen = protokollInformationen;
			
			_timeStampArray = new long[objektZuordnung.length];
			for (int i = 0; i < _timeStampArray.length; i++) {
				_timeStampArray[i] = -1L;
			}
//			System.out.println("Timestamp Array erzeugt der Grsse " + _timeStampArray.length);
		}
		
		List<String[]> zellenwerteListe = new ArrayList<String[]>();
		
//		System.out.println("DATEN: " + prd);
		
		ClientDavInterface connection = DaVKommunikation.getInstanz().holeDaVVerbindung();
		if (connection != null) {
			List<ProtocolData> dataList = prd.getDataList(connection.getDataModel());
			long timeStamp = prd.getTimeStamp();
		    String zeitStempel = INachbereitung.SDF.format(new Date(timeStamp));
		    Map<String, String[]> zellenwerteMap = new LinkedHashMap<String, String[]>();
		    Map<String, Integer> positionsMap = new HashMap<String, Integer>();
		    
		    int anzahlSpalten = ProtokollAusgabeSicht.ZUSATZ_INFO_ANZAHL + projektInfo.getAnzahlAttribute();
    	  
//		    System.out.println("DATA LIST SIZE " + dataList.size());
//		    System.out.println("STATUS " + prd.status);
//		    System.out.println("VALUES SIZE " + prd.values.length);
//		    System.out.println("DTS SIZE " + prd.archiveTimeStamps.length);
//		    System.out.println("ATS SIZE " + prd.archiveTimeStamps.length);
//		    System.out.println("DIDX SIZE " + prd.dataIndices.length);
		 		    
		    for (int i = 0; i < dataList.size(); i++)
		    {
		    	int objektIndex = objektZuordnung[i];
		    	
//		    	   DataInformation info = prd.dataInformations[objektIndex];
//					  System.out.println(i + " " 
//							  + (prd.values[i].getValue() != null && prd.values[i].getValue().hasValue()) 
//							  + " OBJ (" + objektIndex + "): " + objekte.get(objektIndex).getNameOrPidOrId()
//							  
//								
//								+ " DTS: " + INachbereitung.SDF.format(new Date(prd.dataTimeStamps[objektIndex]))
////							    + " ATS: " + SDF.format(new Date(prd.archiveTimeStamps[objektIndex]))
//							    + " DIDX: " + prd.dataIndices[objektIndex]
//								                                   
////								+ " dataGap: " + info.dataGap + " noPayload: " + info.noPayload
////								+ " archiveInfo: " + info.archiveInfo + " tag: " + info.tag
//					  );
  			
	//			// Prfe ob Daten gltig sind
	//  			if (!containsValidData(prd.dataInformations[objektIndex]))  {
	//  				continue;
	//  			}
	  			  	
			  // Prfe ob Daten vorhanden sind
			  if (prd.values[i].getValue() == null || !prd.values[i].getValue().hasValue()) {
				  continue;
		      }	
	
		      // Prfe Zeitstempel
		      long tsSoll = prd.dataTimeStamps[objektIndex];
		      
		      if (tsSoll < 0L) {
		    	  continue;
		      }
		      
		      long tsIst = _timeStampArray[i];
		      
		      if (tsIst == -1L || tsIst != tsSoll) {
		    	  _timeStampArray[i] = tsSoll;
		      }
		      else {
		    	  // Zeitstempel sind gleich => Duplette
		    	  continue;
		      }
		      
		      if (tsSoll != timeStamp) {
		    	  continue;
		      }
		      		      
//		      DataInformation info = prd.dataInformations[objektIndex];
//			  System.out.println(i + " " 
//					  + (prd.values[i].getValue() != null && prd.values[i].getValue().hasValue()) 
//					  + " OBJ (" + objektIndex + "): " + objekte.get(objektIndex).getNameOrPidOrId()
//					  
//						
//						+ " DTS: " + INachbereitung.SDF.format(new Date(prd.dataTimeStamps[objektIndex]))
////					    + " ATS: " + SDF.format(new Date(prd.archiveTimeStamps[objektIndex]))
//					    + " DIDX: " + prd.dataIndices[objektIndex]
//						                                   
////						+ " dataGap: " + info.dataGap + " noPayload: " + info.noPayload
////						+ " archiveInfo: " + info.archiveInfo + " tag: " + info.tag
//			  );
		    	
		    
    		  
//    		  System.out.println("OBJEKT INDEX DATA[" + i +"]: " + objektIndex);
    		  
    		  SystemObject anfrageObj = objekte.get(objektIndex);
    		  String pid = anfrageObj.getPid();
    		  String[] zellenwerte = zellenwerteMap.get(pid);
    		  
    		  if (zellenwerte == null) {
     	  		zellenwerte = new String[anzahlSpalten];
					zellenwerteMap.put(pid, zellenwerte);
					// Datum + Objektbezeichner
	                zellenwerte[ProtokollAusgabeSicht.ZUSATZ_INFO_DATUMZEIT_INDEX] = zeitStempel;
	                String name = anfrageObj.getNameOrPidOrId();
	                zellenwerte[ProtokollAusgabeSicht.ZUSATZ_INFO_OBJEKTBEZEICHNER_INDEX] = name;
	                positionsMap.put(pid,ProtokollAusgabeSicht.ZUSATZ_INFO_ANZAHL);
    		  }
    		  
    		  int position = positionsMap.get(pid);
    		  ProtocolData protocolData = dataList.get(i);
    		  
    		  if (protocolData.isPlain())
              {
//    			if (protocolData.getName().equals("ID")) {
//    				String text = Tools.toText(protocolData);	
//    				System.out.println("ID: " + text);
//    				String[] components = text.split("#");
//    				if (components.length > 1) {
//    					zellenwerte[position] = components[0];
//    				}
//    				else {
//    					zellenwerte[position] = text;
//    				}
//    			}
//    			else {
    				zellenwerte[position] = Tools.toText(protocolData);	
//    			}
    			 
                if (position < zellenwerte.length) {
                	position++;	
                }
                else {
                	System.err.println("Spaltenberlauf bei Spalte " + i + " Position " + 
                			position + " fr Objekt " + pid);
                }
              }
              else
              {
            	  List<String> zellenwerteFlach = new ArrayList<String>();
                  doZellenwerteAufloesen(protocolData, zellenwerteFlach);
                  // hor9tr: Bugfix - Array und Liste haben nur einen Header aber viele Werte -> Liste von Werten
                  //                  in einen flachen String kopieren und der Spalte des Headers hinzufuegen
                  if((anzahlSpalten - ProtokollAusgabeSicht.ZUSATZ_INFO_ANZAHL) == 1 && zellenwerteFlach.size() > 1)
                  {
                    String zellenwert = zellenwerteFlach.get(0);
                    for(int m = 1; m < zellenwerteFlach.size(); m++)
                    {
                      zellenwert = zellenwert + ", " + zellenwerteFlach.get(m);
                    }
                    zellenwerteFlach.clear();
                    zellenwerteFlach.add(zellenwert);
                  }
                  for (int k = 0; k < zellenwerteFlach.size() && position < anzahlSpalten; k++)
                  {
                    zellenwerte[position] = zellenwerteFlach.get(k);
                    if (position < zellenwerte.length) {
                    	position++;	
                    }
                    else {
                    	System.err.println("Spaltenberlauf bei Spalte " + i + " Position " + 
                    			position + " fr Objekt " + pid);
                    	break;
                    }
                  }
                  
                  if (zellenwerteFlach.size() == 0) // Leere Zelle mit Leerstring belegen und dadurch berspringen
                  {
                    zellenwerte[position] = "";
                    
                    if (position < zellenwerte.length) 
                    {
                      position++;
                    }
                  }
              }
    		  positionsMap.put(pid, position);
          }	
		  
		  zellenwerteListe.addAll(zellenwerteMap.values());  
		      	    
		}  
		return zellenwerteListe;
	}
}
