/*
 * This file is part of Rahmenwerk.
 * 
 * Rahmenwerk is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License  as 
 * published by the Free Software Foundation, either version 3 of the
 * License.
 * 
 * Rahmenwerk is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with Rahmenwerk.  If not, see <http://www.gnu.org/licenses/>.
 *  
 *  
 * 
 * Copyright (c) 2012 SWARCO TRAFFIC SYSTEMS GmbH.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 * SWARCO TRAFFIC SYSTEMS GmbH - initial API and implementation
 * 
 * 
 * 
 * Contact Information:
 * SWARCO TRAFFIC SYSTEMS GmbH
 * Adolf-Dambach-Strae 
 * D-76571 Gaggenau
 * Phone: +49-7225-64-03
 * Fax: +49-7225-64-300
 * mailto: office.sts@swarco.de
 */
package de.bsvrz.buv.plugin.pua.basis.protokolle;

/**
 * Klasse realisiert die Definition der vorbereiteten Protokolle
 * @author Dambach Werke GmbH
 */
public class VorbereiteteProtokolleDefinition
{
  /**
   * Aktion
   */
  private String m_aktion;
  
  /**
   * Skript
   */
  private String m_skript;
  
  /**
   * Aspekt
   */
  private String m_aspekt;
  
  /**
   * Objekttyp
   */
  private String m_objektTyp;
  
  /**
   * Beschriftung
   */
  private String m_titel;
  
  /**
   * Konstruktor der Klasse  
   * @param aktion Aktion
   * @param skript Skript fr die vordefinierten Prokolle
   * @param aspekt Aspekt zur Ausfhrung des Skripts
   * @param objektTyp Typ der Objekte
   * @param titel Titel fr Ausgabe
   */
  public VorbereiteteProtokolleDefinition (String aktion,
                                           String skript,
                                           String aspekt,
                                           String objektTyp,
                                           String titel)
  {
    m_aktion    = aktion;
    m_skript    = skript;
    m_aspekt    = aspekt;
    m_objektTyp = objektTyp;
    m_titel     = titel;
  }

  /**
   * @return liefert die Variable aktion zurck
   */
  public String getAktion()
  {
    return m_aktion;
  }

  /**
   * @param aktion setzt die Variable aktion
   */
  public void setAktion( String aktion )
  {
    m_aktion = aktion;
  }

  /**
   * @return liefert die Variable skript zurck
   */
  public String getSkript()
  {
    return m_skript;
  }

  /**
   * @param skript setzt die Variable skript
   */
  public void setSkript( String skript )
  {
    m_skript = skript;
  }

  /**
   * @return liefert die Variable aspekt zurck
   */
  public String getAspekt()
  {
    return m_aspekt;
  }

  /**
   * @param aspekt setzt die Variable aspekt
   */
  public void setAspekt( String aspekt )
  {
    m_aspekt = aspekt;
  }

  /**
   * @return liefert die Variable objektTyp zurck
   */
  public String getObjektTyp()
  {
    return m_objektTyp;
  }

  /**
   * @param objektTyp setzt die Variable objektTyp
   */
  public void setObjektTyp( String objektTyp )
  {
    m_objektTyp = objektTyp;
  }

  /**
   * @return liefert die Variable titel zurck
   */
  public String getTitel()
  {
    return m_titel;
  }

  /**
   * @param titel setzt die Variable titel
   */
  public void setTitel( String titel )
  {
    m_titel = titel;
  }
}
