/*******************************************************************************
 * This file is part of Rahmenwerk.
 * 
 * Rahmenwerk is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License  as 
 * published by the Free Software Foundation, either version 3 of the
 * License.
 * 
 * Rahmenwerk is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with Rahmenwerk.  If not, see <http://www.gnu.org/licenses/>.
 *  
 *  
 * 
 * Copyright (c) 2012 SWARCO TRAFFIC SYSTEMS GmbH.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 * SWARCO TRAFFIC SYSTEMS GmbH - initial API and implementation
 * 
 * 
 * 
 * Contact Information:
 * SWARCO TRAFFIC SYSTEMS GmbH
 * Adolf-Dambach-Strae 
 * D-76571 Gaggenau
 * Phone: +49-7225-64-03
 * Fax: +49-7225-64-300
 * mailto: office.sts@swarco.de
 ******************************************************************************/
/* Segment 13 Bedienung und Visualisierung, Plug-In Streckenprofil 
 * Copyright (C) 2009-2010 BitCtrl Systems GmbH
 * 
 * This program is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by the Free
 * Software Foundation; either version 2.1 of the License, or (at your option)
 * any later version.
 * 
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
 * details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program; if not, write to the Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 * 
 * Contact Information: 
 * BitCtrl Systems GmbH 
 * Weienfelser Strae 67 
 * 04229 Leipzig 
 * Phone: +49 341-490670 
 * mailto: info@bitctrl.de
 */

package de.bsvrz.buv.plugin.streckenprofil.sts.a8.editor.pages;

import java.beans.PropertyChangeEvent;
import java.beans.PropertyChangeListener;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collection;
import java.util.Date;
import java.util.HashSet;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.List;
import java.util.Set;
import java.util.TreeSet;

import org.eclipse.core.databinding.DataBindingContext;
import org.eclipse.core.databinding.observable.Realm;
import org.eclipse.core.databinding.observable.list.WritableList;
import org.eclipse.core.databinding.observable.set.ComputedSet;
import org.eclipse.core.runtime.IProgressMonitor;
import org.eclipse.core.runtime.Platform;
import org.eclipse.core.runtime.jobs.IJobChangeEvent;
import org.eclipse.core.runtime.jobs.IJobChangeListener;
import org.eclipse.core.runtime.jobs.Job;
import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.databinding.EMFObservables;
import org.eclipse.emf.ecore.util.EContentAdapter;
import org.eclipse.jface.action.Action;
import org.eclipse.jface.action.IToolBarManager;
import org.eclipse.jface.action.ToolBarManager;
import org.eclipse.jface.databinding.viewers.ObservableListContentProvider;
import org.eclipse.jface.databinding.viewers.ViewersObservables;
import org.eclipse.jface.dialogs.IMessageProvider;
import org.eclipse.jface.dialogs.MessageDialog;
import org.eclipse.jface.layout.GridDataFactory;
import org.eclipse.jface.layout.GridLayoutFactory;
import org.eclipse.jface.layout.TreeColumnLayout;
import org.eclipse.jface.viewers.ArrayContentProvider;
import org.eclipse.jface.viewers.CheckStateChangedEvent;
import org.eclipse.jface.viewers.CheckboxTableViewer;
import org.eclipse.jface.viewers.CheckboxTreeViewer;
import org.eclipse.jface.viewers.ColumnWeightData;
import org.eclipse.jface.viewers.ComboViewer;
import org.eclipse.jface.viewers.ICheckStateListener;
import org.eclipse.jface.viewers.ISelection;
import org.eclipse.jface.viewers.ISelectionChangedListener;
import org.eclipse.jface.viewers.IStructuredSelection;
import org.eclipse.jface.viewers.LabelProvider;
import org.eclipse.jface.viewers.SelectionChangedEvent;
import org.eclipse.jface.viewers.StructuredSelection;
import org.eclipse.jface.viewers.Viewer;
import org.eclipse.jface.viewers.ViewerComparator;
import org.eclipse.jface.viewers.ViewerSorter;
import org.eclipse.nebula.widgets.cdatetime.CDT;
import org.eclipse.nebula.widgets.cdatetime.CDateTime;
import org.eclipse.swt.SWT;
import org.eclipse.swt.events.DisposeEvent;
import org.eclipse.swt.events.DisposeListener;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.graphics.Cursor;
import org.eclipse.swt.graphics.Image;
import org.eclipse.swt.graphics.Point;
import org.eclipse.swt.graphics.RGB;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Event;
import org.eclipse.swt.widgets.Group;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Listener;
import org.eclipse.swt.widgets.Scale;
import org.eclipse.swt.widgets.Table;
import org.eclipse.swt.widgets.TableColumn;
import org.eclipse.swt.widgets.TableItem;
import org.eclipse.swt.widgets.ToolBar;
import org.eclipse.swt.widgets.TreeColumn;
import org.eclipse.swt.widgets.TreeItem;
import org.eclipse.swt.widgets.Widget;
import org.eclipse.ui.IPartListener;
import org.eclipse.ui.IWorkbenchPart;
import org.eclipse.ui.PlatformUI;
import org.eclipse.ui.forms.IManagedForm;
import org.eclipse.ui.forms.editor.IFormPage;
import org.eclipse.ui.forms.widgets.ColumnLayout;
import org.eclipse.ui.forms.widgets.ColumnLayoutData;
import org.eclipse.ui.forms.widgets.ExpandableComposite;
import org.eclipse.ui.forms.widgets.FormToolkit;
import org.eclipse.ui.forms.widgets.ScrolledForm;
import org.eclipse.ui.forms.widgets.Section;

import com.bitctrl.lib.eclipse.editors.FormPageWithBorders;

import de.bsvrz.buv.plugin.selektion.SelektionsListener;
import de.bsvrz.buv.plugin.selektion.SelektionsTransfer;
import de.bsvrz.buv.plugin.streckenprofil.sts.a8.Activator;
import de.bsvrz.buv.plugin.streckenprofil.sts.a8.Modell;
import de.bsvrz.buv.plugin.streckenprofil.sts.a8.StreckenprofilTreeCheckStateProvider;
import de.bsvrz.buv.plugin.streckenprofil.sts.a8.StreckenprofilUtil;
import de.bsvrz.buv.plugin.streckenprofil.sts.a8.editor.StreckenprofilEditor;
import de.bsvrz.buv.plugin.streckenprofil.sts.a8.editor.simulation.SimulationBeendenUndVernichtenJob;
import de.bsvrz.buv.plugin.streckenprofil.sts.a8.histdata.DatenZusammenstellung;
import de.bsvrz.buv.plugin.streckenprofil.sts.a8.histdata.HistorischeDatenJob;
import de.bsvrz.buv.plugin.streckenprofil.sts.a8.histdata.IDatenZusammenstellung;
import de.bsvrz.buv.plugin.streckenprofil.sts.a8.model.LinienEigenschaften;
import de.bsvrz.buv.plugin.streckenprofil.sts.a8.model.Strecke;
import de.bsvrz.buv.plugin.streckenprofil.sts.a8.model.StreckenKnoten;
import de.bsvrz.buv.plugin.streckenprofil.sts.a8.model.StreckenZugEintrag;
import de.bsvrz.buv.plugin.streckenprofil.sts.a8.model.StreckenprofilFactory;
import de.bsvrz.buv.plugin.streckenprofil.sts.a8.model.StreckenprofilPackage;
import de.bsvrz.buv.plugin.streckenprofil.sts.a8.model.TypAnzeigen;
import de.bsvrz.buv.plugin.streckenprofil.sts.a8.model.TypDatenQuellen;
import de.bsvrz.buv.plugin.streckenprofil.sts.a8.model.TypPrognoseTyp;
import de.bsvrz.buv.plugin.streckenprofil.sts.a8.model.TypVerkehrsDaten;
import de.bsvrz.buv.plugin.streckenprofil.sts.a8.util.SystemObjektContainerElementComparer;
import de.bsvrz.buv.rw.basislib.kalender.ereignisSystemKalender.DialogEreignisSystemkalenderUebernahme;
import de.bsvrz.buv.rw.basislib.kalender.ereignisSystemKalender.IEintragBereich;
import de.bsvrz.buv.rw.bitctrl.BitCtrlRahmenwerkConstants;
import de.bsvrz.buv.rw.bitctrl.BitCtrlRahmenwerkPlugin;
import de.bsvrz.buv.rw.bitctrl.eclipse.databinding.RichtungTextComputedValue;
import de.bsvrz.buv.rw.bitctrl.startup.StartupPlugin;
import de.bsvrz.dav.daf.main.config.SystemObject;
import de.bsvrz.sys.funclib.bitctrl.modell.tmtmcglobal.attribute.AttTmcRichtung;
import de.bsvrz.sys.funclib.bitctrl.modell.tmverkehrglobal.objekte.Strasse;
import de.bsvrz.sys.funclib.bitctrl.modell.tmverkehrglobal.objekte.StrassenKnoten;
import de.bsvrz.sys.funclib.bitctrl.modell.tmverkehrglobal.objekte.StrassenSegment;
import de.bsvrz.sys.funclib.bitctrl.modell.tmvewsimulationglobal.attribute.AttSimulationsZustand;
import de.bsvrz.sys.funclib.bitctrl.modell.tmvewsimulationglobal.objekte.OfflineSimulation;
import de.bsvrz.sys.funclib.bitctrl.modell.util.cache.AbstractCache;
import de.bsvrz.sys.funclib.bitctrl.modell.util.cache.MqCache;
import de.bsvrz.sys.funclib.bitctrl.modell.util.cache.NetzCache;
import de.bsvrz.sys.funclib.bitctrl.modell.util.cache.NetzCacheExtended;
import de.bsvrz.sys.funclib.bitctrl.modell.util.cache.StreckenAbschnittCache;

/**
 * {@link org.eclipse.ui.forms.editor.FormPage} zur Erstellung eines
 * Streckenprofils. anhand von {@link StreckenKnoten}, die ausgewhlt werden
 * knnen.
 * 
 * @author BitCtrl Systems GmbH, Schnepel/Hoesel
 * @version $Id: StreckenprofilEditorKonfiguration.java 29377 2011-05-17
 *          14:00:51Z hoesel $
 */
public class StreckenprofilEditorKonfiguration extends FormPageWithBorders
		implements PropertyChangeListener, SelektionsListener, IPartListener, IJobChangeListener {

	private static final String ICONS_AKTIONEN_ZEITBEREICH_UEBERNEHMEN_GIF = "icons/aktionen/zeitbereich_uebernehmen.gif";

	/**
	 * Ausfhrliche Beschreibung fr die positive Straenrichtung.
	 */
	private static final String RICHTUNG_POSITIV_TEXT = "positiv (Fahrtrichtung)";

	/**
	 * Ausfhrliche Beschreibung fr die negative Straenrichtung.
	 */
	private static final String RICHTUNG_NEGATIV_TEXT = "negativ (Gegenrichtung)";

	/**
	 * Das Dirty - Flag, das anzeigt, ob der Editor Inhalt gespeichert werden
	 * kann.
	 */
	private boolean dirty;

	/**
	 * Der Messquerschnitt Cache.
	 */
	private final MqCache mqCache;

	/**
	 * Der {@link DataBindingContext} fr diese
	 * {@link org.eclipse.ui.forms.editor.FormPage}.
	 */
	private final DataBindingContext dbc;

	/**
	 * Der Netzcache.
	 */
	private final NetzCache netzCache;

	/**
	 * Der erweiterte Netzcache.
	 */
	private final NetzCacheExtended netzCacheExt;

	/**
	 * Das {@link Modell} des Streckenprofiles.
	 */
	private final Modell model;
	
	/**
	 * Das {@link Modell} des Streckenprofiles.
	 */
	private final StreckenprofilEditor editor;

	/**
	 * Der {@link StreckenAbschnittCache}, der intialisiert sein mu, damit die
	 * Ermittlung der Streckenabschnitte funktioniert.
	 */
	private final StreckenAbschnittCache streckenCache;

	/**
	 * Viewer zur Darstellung des gesamten Streckenzuges als Baum.
	 */
	private CheckboxTreeViewer nodesTable;

	/**
	 * {@link ComboViewer} zum Auswhlen der Strasse des Streckenprofils.
	 */
	private ComboViewer strasseComboViewer;

	/**
	 * Toggle Button zum auswhlen der Richtung "Positive Fahrtrichtung".
	 */
	private Button positiveRichtungButton;

	/**
	 * Toggle Button zum auswhlen der Richtung "Negative Fahrtrichtung".
	 */
	private Button negativeRichtungButton;

	/**
	 * {@link ComboViewer}, der den Begin des Streckenprofils reprsentiert.
	 */
	private ComboViewer startKnotenComboViewer;

	/**
	 * {@link ComboViewer}, der das Ende des Streckenprofils reprsentiert.
	 */
	private ComboViewer endKnotenComboViewer;

	/**
	 * Knopf zum Starten der Offline - Simulation.
	 */
	private ButtonMitFunktionsBerechtigung startSimu;

	/**
	 * Knopf um die Simulation zu pausieren.
	 */
	private ButtonMitFunktionsBerechtigung pauseSimu;

	/**
	 * Knopf zum Beenden der Offline - Simulation.
	 */
	private ButtonMitFunktionsBerechtigung endSimu;

	/**
	 * Widget mit dem die Simulationsgeschwindigkeit eingestellt werden kann.
	 */
	private Scale simulationsGeschwindigkeit;

	/**
	 * Array mit allen mglichen Simulationsgeschwindigkeiten.
	 */
	private final double[] simulationsGeschwidigkeiten = new double[] { 0.0,
			0.125, 0.25, 0.5, 1.0, 2.0, 4.0, 8.0, 16.0, 30.0, 60.0, 600.0 };
	
	private HistorischeDatenJob historischeDatenJob = null;

	/**
	 * {@link Action} zur bernahme der Streckenselektion des
	 * Selektionstransfers.
	 */
	private Action uebernahmeStreckenprofilSelektionAction;

  private CheckboxTableViewer _bildZeichenTableViewer;

	/**
	 * Erzeugt eine neue {@link StreckenprofilEditorKonfiguration} -
	 * {@link org.eclipse.ui.forms.editor.FormPage}.
	 * 
	 * @param editor
	 *            der Editor, in dem die
	 *            {@link org.eclipse.ui.forms.editor.FormPage} verwendet wird.
	 * @param model
	 *            das {@link Modell} des Streckenprofils.
	 */
	public StreckenprofilEditorKonfiguration(final StreckenprofilEditor editor,
			final Modell model) {
		super(editor, StreckenprofilEditorKonfiguration.class.getName(),
				"Konfiguration");
		this.model = model;
		this.editor = editor;
		SelektionsTransfer.getInstanz().addSelektionsListener(this);
		final StartupPlugin startupPlugin = StartupPlugin.getDefault();
		mqCache = startupPlugin.getDefaultMqCache();
		netzCache = startupPlugin.getDefaultNetzCache();
		netzCacheExt = startupPlugin.getDefaultNetzCacheExtended();
		streckenCache = startupPlugin.getDefaultStreckenAbschnittCache();
		mqCache.addPropertyChangeListener(AbstractCache.PROP_STATE, this);
		netzCache.addPropertyChangeListener(AbstractCache.PROP_STATE, this);
		netzCacheExt.addPropertyChangeListener(AbstractCache.PROP_STATE, this);
		streckenCache.addPropertyChangeListener(AbstractCache.PROP_STATE, this);

		dbc = new DataBindingContext();

		PlatformUI.getWorkbench().getActiveWorkbenchWindow().getPartService().addPartListener(this);
		
		model.getEMFModell().getChartProperties().eAdapters()
				.add(new EContentAdapter() {

					/*
					 * (non-Javadoc)
					 * 
					 * @see
					 * org.eclipse.emf.ecore.util.EContentAdapter#notifyChanged
					 * (org. eclipse.emf.common.notify.Notification)
					 */
					@Override
					public void notifyChanged(final Notification notification) {
						super.notifyChanged(notification);
						setDirty(true);
					}

				});

	}

	@Override
	protected void createFormContent(final IManagedForm managedForm) {
		super.createFormContent(managedForm);
		final ScrolledForm form = managedForm.getForm();
		form.setText(getTitle());
		final FormToolkit toolkit = managedForm.getToolkit();
		final Composite formBody = form.getForm().getBody();

		// Online-Hilfe hinzufgen
		PlatformUI
				.getWorkbench()
				.getHelpSystem()
				.setHelp(
						getManagedForm().getForm(),
						Activator.PLUGIN_ID
								+ "."
								+ StreckenprofilEditorKonfiguration.class
										.getSimpleName());

		formBody.setLayout(new GridLayout(3, false));
		erzeugeLageSection(toolkit, formBody);
		erzeugeLinienAuswahlSection(toolkit, formBody);	
		erzeugeAnzeigeTypenAuswahlSection(toolkit, formBody);
		erzeugeZeitmaschinenSection(toolkit, formBody);
		createStreckenzugSection(formBody, toolkit);
		erzeugeLageBinding();
		if (!Activator.getDefault().getObjektFactory().isVerbunden()) {
			form.setMessage(
					"Datenverteilerverbindung noch nicht initialisiert !",
					IMessageProvider.ERROR);
			form.setEnabled(false);
		} else if (!mqCache.isInitialisiert() || !netzCache.isInitialisiert()
				|| !netzCacheExt.isInitialisiert()
				|| !streckenCache.isInitialisiert()) {
			form.setMessage(
					"Bitte warten, das Streckennetz wird initialisiert ....",
					IMessageProvider.INFORMATION);
			form.setEnabled(false);
			form.setBusy(true);
		} else {
			initialisieren();
		}

		form.layout(true, true);

		toolkit.decorateFormHeading(form.getForm());
		final IToolBarManager toolBarManager = form.getToolBarManager();

		uebernahmeStreckenprofilSelektionAction = new Action(
				"Strecken-Selektion bernehmen", Activator.getDefault()
						.getImageRegistry()
						.getDescriptor(Activator.SELEKTIONSTRANFER_GIF)) {

			/*
			 * (non-Javadoc)
			 * 
			 * @see org.eclipse.jface.action.Action#run()
			 */
			@Override
			public void run() {
				final IStructuredSelection s = SelektionsTransfer
						.getInstanz()
						.getDefinierteSelection(
								BitCtrlRahmenwerkConstants.SELECTION_STRECKEN_ZUG);
				if (s != null) {
					model.removeAlleStrecken();
					final Iterator<?> it = s.iterator();
					while (it.hasNext()) {
						final Object o = it.next();
						if (o instanceof StrassenSegment) {
							final StrassenSegment segment = (StrassenSegment) o;
							model.addSegment(segment);
						} else if (o instanceof SystemObject
								&& ((SystemObject) o)
										.isOfType(StrassenSegment.PID)) {
							model.addSegment((StrassenSegment) Activator
									.getDefault().getObjektFactory()
									.getModellobjekt((SystemObject) o));
						} else {
							final Object obj = Platform.getAdapterManager()
									.getAdapter(o, SystemObject.class);
							if (obj instanceof SystemObject
									&& ((SystemObject) obj)
											.isOfType(StrassenSegment.PID)) {
								model.addSegment((StrassenSegment) Activator
										.getDefault().getObjektFactory()
										.getModellobjekt((SystemObject) obj));
							}
						}
					}

					strasseComboViewer.setSelection(new StructuredSelection(
							model.getErsteStrecke()));
					startKnotenComboViewer.setInput(ermittleAlleKnoten(model
							.getErsteStrecke()));
					startKnotenComboViewer
							.setSelection(new StructuredSelection(model
									.getErsterStreckenKnoten()));
					endKnotenComboViewer.setInput(ermittleRestlicheKnoten(
							model.getErsteStrecke(),
							model.getErsterStreckenKnoten()));
					endKnotenComboViewer.setSelection(new StructuredSelection(
							model.getLetzterStreckenKnoten()));

					positiveRichtungButton.setText(RichtungTextComputedValue
							.getRichtungText(netzCache, model.getErsteStrecke()
									.getStrasse(),
									AttTmcRichtung.ZUSTAND_1_POSITIV));
					negativeRichtungButton.setText(RichtungTextComputedValue
							.getRichtungText(netzCache, model.getErsteStrecke()
									.getStrasse(),
									AttTmcRichtung.ZUSTAND_1N_NEGATIV));
					if (AttTmcRichtung.ZUSTAND_1_POSITIV.equals(model
							.getErsteStrecke().getRichtung())) {
						positiveRichtungButton.setSelection(true);
						negativeRichtungButton.setSelection(false);
					} else {
						positiveRichtungButton.setSelection(false);
						negativeRichtungButton.setSelection(true);
					}
				}
			}

		};

		uebernahmeStreckenprofilSelektionAction
				.setToolTipText("Strecken-Selektion bernehmen");
		toolBarManager.add(uebernahmeStreckenprofilSelektionAction);

		toolBarManager.update(true);

	}
	
	
	 /**
   * Erzeugt die {@link Section} zum Auswhlen der Verkehrsdatenquellen und Verkehrsdatentypen.
   * 
   * @param toolkit
   *          das Parent Composite.
   * @param formBody
   *          das Toolkit.
   */
  private void erzeugeAnzeigeTypenAuswahlSection(final FormToolkit toolkit, final Composite formBody)
  {
    final String title = "Auswahl - Anzeigen";
    final Section section = toolkit.createSection(formBody, defaultSectionStyle);
    section.setLayoutData(new GridData(SWT.FILL, SWT.FILL, false, false, 1, 1));
    section.setText(title);
    final Composite client = toolkit.createComposite(section, SWT.NONE);
    toolkit.paintBordersFor(client);
    section.setClient(client);
    client.setLayout(new GridLayout(1, false));
    
    final ColumnLayout tableLayout = new ColumnLayout();
    tableLayout.maxNumColumns = 1;
    tableLayout.minNumColumns = 1;
    
    final Composite zusammenstellungComposite = newPartAndClient(client, toolkit, "Anzeigetyp", new GridData(
        SWT.FILL, SWT.FILL, false, false, 1, 1), false);
    zusammenstellungComposite.setLayout(tableLayout);
    
    final Table datenQuelleTable = new Table(zusammenstellungComposite, SWT.CHECK);
    datenQuelleTable.setLayoutData(new ColumnLayoutData());
    datenQuelleTable.addListener(SWT.Selection,new Listener() {
      public void handleEvent(Event event) {
          // Hier wird das Verhalten umgesetzt, welche die Checkboxen verriegelt
          if( event.detail == SWT.CHECK ) 
          {
              if(event.item.getData() instanceof TypAnzeigen){
                TypAnzeigen typ = (TypAnzeigen)event.item.getData();
                
                if (typ.equals(TypAnzeigen.TYP_B)){
                  Widget widget = event.item;
                  if (widget instanceof TableItem)
                  {
                    TableItem itemEvent = (TableItem)widget;
                    datenQuelleTable.setRedraw(false);                    
                    //wenn Typ-B nicht gechecked, dann ggf. auch beim Typ-C Markierung entfernen  
                    if( !itemEvent.getChecked() ) 
                    {
                      _bildZeichenTableViewer.setChecked(TypAnzeigen.TYP_C, false);
                      model.getAnzeigeEigenschaften().getAnzeigeType().remove(TypAnzeigen.TYP_C);     
                    }                    
                    datenQuelleTable.setRedraw(true);                    
                  }
                }
                else if (typ.equals(TypAnzeigen.TYP_C)){
                  
                  TableItem itemA = datenQuelleTable.getItem(1); 
                 
                 // Typ-C kann nur markiert werden, wenn Typ-C ebefalls markiert ist  
                 if (!itemA.getChecked()){
                   event.detail = SWT.NONE;
                   event.type   = SWT.None;
                   event.doit   = false;
                   try {
                     datenQuelleTable.setRedraw(false);
                     TableItem item = (TableItem)event.item;
                     item.setChecked(! item.getChecked() );
                   } finally {
                     datenQuelleTable.setRedraw(true);
                   }                   
                 }
                }
              }
          }
      }
   });
    
    
    final TableColumn datenQuelleTableColumn = new TableColumn(datenQuelleTable, SWT.NONE);
    
    _bildZeichenTableViewer = new CheckboxTableViewer(datenQuelleTable);
    final ObservableListContentProvider datenQuelleProvider = new ObservableListContentProvider();
    _bildZeichenTableViewer.setContentProvider(datenQuelleProvider);    
    
    _bildZeichenTableViewer.setInput(new WritableList(TypAnzeigen.VALUES, TypAnzeigen.class));        
    datenQuelleTableColumn.pack();
 
    _bildZeichenTableViewer.addCheckStateListener(new ICheckStateListener() {
      
      @Override
      public void checkStateChanged(final CheckStateChangedEvent event)
      {
        if (event.getElement() instanceof TypAnzeigen)
        {
          final TypAnzeigen typ = (TypAnzeigen)event.getElement();
          if(event.getChecked())          
            model.getAnzeigeEigenschaften().getAnzeigeType().add(typ);
          else{
            model.getAnzeigeEigenschaften().getAnzeigeType().remove(typ);             
          }
          
          setDirty(true);
          
        }
      }
    });
    
 
    dbc.bindSet(ViewersObservables.observeCheckedElements(_bildZeichenTableViewer, TypVerkehrsDaten.class),
        new ComputedSet() {

          @Override
          protected Set<TypAnzeigen> calculate()
          {
            final Set<TypAnzeigen> result = new HashSet<TypAnzeigen>();
            for (final TypAnzeigen lp : model.getAnzeigeEigenschaften().getAnzeigeType())
            {
              if (lp != null)
              {
                result.add(lp);
              }
            }
            return result;
          }
        });
  }

	/*
	 * (non-Javadoc)
	 * 
	 * @see org.eclipse.ui.forms.editor.FormPage#setFocus()
	 */
	@Override
	public void setFocus() {
		getManagedForm().getForm().setFocus();
	}

	
	private void wechsleZuChart() {
	  Display.getCurrent().asyncExec(new Runnable() {
      
      @Override
      public void run()
      {
        editor.setActivePage(StreckenprofilEditorStreckenProfil2.class.getName());
        IFormPage page = editor.getActivePageInstance();
        if (page instanceof StreckenprofilEditorStreckenProfil2)
        {
          StreckenprofilEditorStreckenProfil2 page2 = (StreckenprofilEditorStreckenProfil2)page;
          page2.getChartComposite().initChart();          
        }           
      }
    });
	}
	
	
	/**
	 * Erzeugt die {@link Section} zum Starten und Stoppen der Offline
	 * Simulation.
	 * 
	 * @param toolkit
	 *            das Toolkit.
	 * @param formBody
	 *            das parent Composite.
	 */
	private void erzeugeZeitmaschinenSection(final FormToolkit toolkit,
			final Composite formBody) {

		final String title = "Historische Daten - Zeitraum";
		final Section section = toolkit.createSection(formBody,
				defaultSectionStyle);
		section.setText(title);
		final Composite client = toolkit.createComposite(section, SWT.NONE);
		toolkit.paintBordersFor(client);
		section.setClient(client);
		section.setLayoutData(new GridData(SWT.FILL, SWT.FILL, false, false));
		client.setLayout(new GridLayout(2, false));

		GridData gd;
		final Label vonLabel = new Label(client, SWT.NONE);
		vonLabel.setText("von:");
		gd = new GridData(SWT.CENTER, SWT.CENTER, false, false);
		vonLabel.setLayoutData(gd);

		final CDateTime vonDatumZeit = new CDateTime(client, CDT.SPINNER
				| CDT.DROP_DOWN | CDT.DATE_MEDIUM | CDT.TIME_MEDIUM
				| CDT.CLOCK_24_HOUR | CDT.CLOCK_DISCRETE);
		vonDatumZeit.setSelection(model.getChartProperties()
				.getHistorieStartZeitpunkt());
		GridDataFactory.fillDefaults().grab(true, false).applyTo(vonDatumZeit);
		vonDatumZeit.addSelectionListener(new SelectionAdapter() {
			@Override
			public void widgetSelected(final SelectionEvent e) {
				model.getChartProperties().setHistorieStartZeitpunkt(
						vonDatumZeit.getSelection());
				setDirty(true);
			}
		});
		final Button button = toolkit.createButton(client, "", SWT.PUSH);
		button.setToolTipText("bernimm den Zeitbereich eines Kalendereintrags");
		Image img = BitCtrlRahmenwerkPlugin.getDefault().getImageRegistry()
				.get(ICONS_AKTIONEN_ZEITBEREICH_UEBERNEHMEN_GIF);
		if (img == null) {
			img = BitCtrlRahmenwerkPlugin
					.getDefault()
					.getImageDescriptor(
							ICONS_AKTIONEN_ZEITBEREICH_UEBERNEHMEN_GIF)
					.createImage();
			BitCtrlRahmenwerkPlugin.getDefault().getImageRegistry()
					.put(ICONS_AKTIONEN_ZEITBEREICH_UEBERNEHMEN_GIF, img);
		}
		button.setImage(img);
		GridDataFactory.swtDefaults().span(new Point(2, 1)).applyTo(button);
		button.addSelectionListener(new SelectionAdapter() {

			@Override
			public void widgetSelected(final SelectionEvent e) {
				final DialogEreignisSystemkalenderUebernahme dialog = new DialogEreignisSystemkalenderUebernahme(
						getSite().getShell());
				final LinkedList<IEintragBereich> bereiche = dialog.oeffnen();
				if (bereiche != null && !bereiche.isEmpty()) {
					final IEintragBereich ersterBereich = bereiche.get(0);
					final Date newDate = new Date(ersterBereich.getVon());
					vonDatumZeit.setSelection(newDate);
					model.getChartProperties().setHistorieStartZeitpunkt(
							newDate);
					setDirty(true);
				}
			}

		});

		final Label bisLabel = new Label(client, SWT.NONE);
		bisLabel.setText("bis:");
		gd = new GridData(SWT.CENTER, SWT.CENTER, false, false);
		bisLabel.setLayoutData(gd);

		final CDateTime bisDatumZeit = new CDateTime(client, CDT.SPINNER
				| CDT.DROP_DOWN | CDT.DATE_MEDIUM | CDT.TIME_MEDIUM
				| CDT.CLOCK_24_HOUR | CDT.CLOCK_DISCRETE);
		bisDatumZeit.setSelection(model.getChartProperties()
				.getHistorieStartZeitpunkt());
		GridDataFactory.fillDefaults().grab(true, false).applyTo(bisDatumZeit);
		bisDatumZeit.addSelectionListener(new SelectionAdapter() {
			@Override
			public void widgetSelected(final SelectionEvent e) {
				model.getChartProperties().setHistorieEndZeitpunkt(
						bisDatumZeit.getSelection());
				setDirty(true);
			}
		});
		final Button buttonBis = toolkit.createButton(client, "", SWT.PUSH);
		buttonBis
				.setToolTipText("bernimm den Zeitbereich eines Kalendereintrags");
		buttonBis.setImage(img);
		GridDataFactory.swtDefaults().span(new Point(2, 1)).applyTo(button);
		buttonBis.addSelectionListener(new SelectionAdapter() {

			@Override
			public void widgetSelected(final SelectionEvent e) {
				final DialogEreignisSystemkalenderUebernahme dialog = new DialogEreignisSystemkalenderUebernahme(
						getSite().getShell());
				final LinkedList<IEintragBereich> bereiche = dialog.oeffnen();
				if (bereiche != null && !bereiche.isEmpty()) {
					final IEintragBereich ersterBereich = bereiche.get(0);
					final Date newDate = new Date(ersterBereich.getVon());
					bisDatumZeit.setSelection(newDate);
					model.getChartProperties().setHistorieEndZeitpunkt(newDate);
					setDirty(true);
				}
			}

		});

		final Composite buttonComposite = new Composite(client, SWT.NONE);
		buttonComposite.setLayoutData(new GridData(SWT.FILL, SWT.FILL, false,
				false, 2, 1));
//		buttonComposite.setLayout(new GridLayout(4, true));
		buttonComposite.setLayout(new GridLayout(3, true));
		startSimu = new ButtonMitFunktionsBerechtigung(buttonComposite,
				SWT.PUSH);
		startSimu.setToolTipText("Simulation starten");
		startSimu.setLayoutData(new GridData(SWT.FILL, SWT.FILL, false, false));
		final Image imgStart = Activator.getDefault().getImageRegistry()
				.get(Activator.ICONS_ICON_SIM_START_GIF);
		startSimu.setImage(imgStart);
		startSimu.addSelectionListener(new SelectionAdapter() {

			@Override
			public void widgetSelected(final SelectionEvent e) {
//				final OfflineSimulation sim = ((StreckenprofilEditor) getEditor())
//						.getAktuelleSimulation();
//				if (sim == null) {
					// neue Simulation starten
//					AtlStartInfo startInfo = Activator.getDefault()
//							.ermittleSimulationStartInfo();
//					if (startInfo == null || startInfo.getRechner() == null
//							|| startInfo.getStartskript() == null) {
//						final StartStoppBlockAuswahlDialog d = new StartStoppBlockAuswahlDialog(
//								startSimu.getShell());
//						d.open();
//						startInfo = Activator.getDefault()
//								.ermittleSimulationStartInfo();
//						if (startInfo == null || startInfo.getRechner() == null
//								|| startInfo.getStartskript() == null) {
//							// StartStopp nicht parametriert
//							return;
//						}
//					}
			  
			    if (historischeDatenJob == null) {
  				 	Date ende = model.getChartProperties()
  							.getHistorieEndZeitpunkt();
  					Date start = model.getChartProperties()
  							.getHistorieStartZeitpunkt();
  					if (start == null || ende == null || !start.before(ende)) {
  						MessageDialog.openError(
  								startSimu.getShell(),
  								"Fehlerhafte Eingabe der Zeitspanne",
  								"Der Endzeitpunkt fr die Abfrage eines historischen Zeitraumes muss nach dem jeweiligen Startzeitpunkt liegen.");
  					}
  					else {
  					  IDatenZusammenstellung datenZusammenstellung = new DatenZusammenstellung(model);
  					  if (datenZusammenstellung.getDaten().isEmpty()) {
  					    MessageDialog.openError(
  	                startSimu.getShell(),
  	                "Fehlerhafte Auswahl der Daten",
  	                "Es ist keine nutzbaren Daten fr eine historische Anfrage angegeben.");					    
  					  }
  					  else {
  					    wechsleZuChart();
  					    
  					    historischeDatenJob = new HistorischeDatenJob(start, ende, datenZusammenstellung, 
  					        getEditor(), null);
  	            historischeDatenJob.addJobChangeListener(StreckenprofilEditorKonfiguration.this);
  	            
  	            historischeDatenJob.addPropertyChangeListener(StreckenprofilEditorKonfiguration.this);
  	            
  	            double simuSpeed = simulationsGeschwidigkeiten[simulationsGeschwindigkeit.getSelection()];
  	            historischeDatenJob.setSimulationsGeschwindigkeit(simuSpeed);
	            
  	            ((StreckenprofilEditor)getEditor()).setSimulationAktiv(true);
  	            
  	            historischeDatenJob.setUser(true);
  	            historischeDatenJob.schedule();
  	            
					  }
//					  
//						final SimulationErzeugenUndStartenJob j = new SimulationErzeugenUndStartenJob(
//								(StreckenprofilEditor) getEditor(), model);
//						j.setSimulationsGeschwindigkeit(simulationsGeschwidigkeiten[simulationsGeschwindigkeit
//								.getSelection()]);
//						j.setUser(true);
//						j.schedule();
					}
				}
			  else if (historischeDatenJob.isPaused()){
					// Pause -> Start
			    wechsleZuChart();
			    
          double simuSpeed = simulationsGeschwidigkeiten[simulationsGeschwindigkeit.getSelection()];
          historischeDatenJob.setSimulationsGeschwindigkeit(simuSpeed);

			    historischeDatenJob.setPaused(false);
//					final SimulationFortsetzenJob job = new SimulationFortsetzenJob(
//							sim);
//					job.setSimulationsGeschwindigkeit(simulationsGeschwidigkeiten[simulationsGeschwindigkeit
//							.getSelection()]);
//					job.setUser(true);
//					job.schedule();
				}
			}
		});

		pauseSimu = new ButtonMitFunktionsBerechtigung(buttonComposite,
				SWT.PUSH);
		pauseSimu.setToolTipText("Simulation pausieren");
		pauseSimu.setLayoutData(new GridData(SWT.FILL, SWT.FILL, false, false));
		pauseSimu.setImage(Activator.getDefault().getImageRegistry()
				.get(Activator.ICON_SIM_PAUSE_GIF));
		pauseSimu.setEnabled(false);
		pauseSimu.addSelectionListener(new SelectionAdapter() {

			@Override
			public void widgetSelected(final SelectionEvent e) {
//				final OfflineSimulation sim = ((StreckenprofilEditor) getEditor())
//						.getAktuelleSimulation();
//				final SimulationsPausierenJob j = new SimulationsPausierenJob(
//						sim);
//				j.setUser(true);
//				j.schedule();
			  if (historischeDatenJob != null && !historischeDatenJob.isPaused()) {
			    historischeDatenJob.setPaused(true);
			  }
			}

		});

		endSimu = new ButtonMitFunktionsBerechtigung(buttonComposite, SWT.PUSH);
		endSimu.setToolTipText("Simulation beenden");
		endSimu.setImage(Activator.getDefault().getImageRegistry()
				.get(Activator.ICON_SIM_STOP_GIF));
		endSimu.setLayoutData(new GridData(SWT.FILL, SWT.FILL, false, false));
		endSimu.setEnabled(false);
		endSimu.addSelectionListener(new SelectionAdapter() {

			@Override
			public void widgetSelected(final SelectionEvent e) {
//				final OfflineSimulation sim = ((StreckenprofilEditor) getEditor())
//						.getAktuelleSimulation();
//				final SimulationBeendenUndVernichtenJob j = new SimulationBeendenUndVernichtenJob(
//						sim);
//				j.setUser(true);
//				j.schedule();
			  if (historischeDatenJob != null) {
          historischeDatenJob.removePropertyChangeListener(StreckenprofilEditorKonfiguration.this);
          historischeDatenJob.removeJobChangeListener(StreckenprofilEditorKonfiguration.this);
          Job job = historischeDatenJob;
          historischeDatenJob = null;
          job.cancel();
        }
	      ((StreckenprofilEditor)getEditor()).setSimulationAktiv(false);
		    startSimu.setEnabled(true);
        endSimu.setEnabled(false);
        pauseSimu.setEnabled(false);
        simulationsGeschwindigkeit.setEnabled(true);

			}

		});

//		final Button einstellungen = new Button(buttonComposite, SWT.PUSH);
//		einstellungen.setText("Einstellungen");
//		einstellungen.setLayoutData(new GridData(SWT.FILL, SWT.FILL, false,
//				false));
//		einstellungen.addSelectionListener(new SelectionAdapter() {
//
//			@Override
//			public void widgetSelected(final SelectionEvent e) {
//				final StartStoppBlockAuswahlDialog d = new StartStoppBlockAuswahlDialog(
//						einstellungen.getShell());
//				d.open();
//
//			}
//		});

		final int nColumns = simulationsGeschwidigkeiten.length;
		final Group simGeschwGroup = new Group(buttonComposite, SWT.NONE);
		simGeschwGroup.setLayoutData(new GridData(SWT.FILL, SWT.FILL, false,
				false, 4, 1));
		simGeschwGroup.setLayout(new GridLayout(nColumns, false));
		simGeschwGroup.setText("Simulationsgeschwindigkeit:");

		// Zeile 2
		simulationsGeschwindigkeit = new Scale(simGeschwGroup, SWT.HORIZONTAL);
		simulationsGeschwindigkeit.setMinimum(0);
		simulationsGeschwindigkeit.setMaximum(nColumns - 1);
		simulationsGeschwindigkeit.setIncrement(1);
		simulationsGeschwindigkeit.setPageIncrement(2);
		simulationsGeschwindigkeit.setSelection(1);
		for (final double d : simulationsGeschwidigkeiten) {
			simulationsGeschwindigkeit.setData(String.valueOf(d), d);
		}
		gd = new GridData(SWT.FILL, SWT.FILL, true, false);
		gd.horizontalSpan = nColumns;
		// gd.horizontalAlignment = SWT.LEFT;
		simulationsGeschwindigkeit.setLayoutData(gd);

		// Sliderbeschriftung
		int loop;
		for (loop = 0; loop < nColumns; ++loop) {
			final Label label = new Label(simGeschwGroup, SWT.NONE);
			gd = new GridData(SWT.FILL, SWT.FILL, true, false);
			gd.horizontalSpan = 1;
			gd.horizontalAlignment = SWT.CENTER;
			label.setLayoutData(gd);
			if (loop % 2 == 0 || loop == 0) {
				final int zehntel = (((int) (simulationsGeschwidigkeiten[loop] * 10.F)) + 10) % 10;
				String formatString = "%.2f";
				if (zehntel == 0) {
					formatString = "%.0f";
				}
				label.setText(String.format(formatString,
						simulationsGeschwidigkeiten[loop]));
			} else if (loop == (nColumns - 1)) {
				label.setText("MAX");
				gd.horizontalAlignment = SWT.RIGHT;
				label.setLayoutData(gd);
			} else {
				label.setText("");
			}
		}

	}

	/**
	 * Erzeugt die {@link Section} zum Auswhlen der Verkehrsdatenquellen und
	 * Verkehrsdatentypen.
	 * 
	 * @param toolkit
	 *            das Parent Composite.
	 * @param formBody
	 *            das Toolkit.
	 */
	private void erzeugeLinienAuswahlSection(final FormToolkit toolkit,
			final Composite formBody) {
		final String title = "Auswahl - Verkehrsdaten";
		final Section section = toolkit.createSection(formBody,
				defaultSectionStyle);
		section.setLayoutData(new GridData(SWT.FILL, SWT.FILL, false, false, 1,
				2));
		section.setText(title);
		final Composite client = toolkit.createComposite(section, SWT.NONE);
		toolkit.paintBordersFor(client);
		section.setClient(client);
		client.setLayout(new GridLayout(2, false));

		final ColumnLayout tableLayout = new ColumnLayout();
		tableLayout.maxNumColumns = 1;
		tableLayout.minNumColumns = 1;

		final Composite zusammenstellungComposite = newPartAndClient(client,
				toolkit, "Verkehrsdatenquelle", new GridData(SWT.FILL,
						SWT.FILL, false, false, 1, 1), false);
		zusammenstellungComposite.setLayout(tableLayout);

		final Composite verkehrsDatenComposite = newPartAndClient(client,
				toolkit, "Verkehrsdatentyp", new GridData(SWT.FILL, SWT.FILL,
						false, false, 1, 1), false);
		verkehrsDatenComposite.setLayout(tableLayout);

		final Table datenQuelleTable = new Table(zusammenstellungComposite,
				SWT.CHECK);
		datenQuelleTable.setLayoutData(new ColumnLayoutData());
		final TableColumn datenQuelleTableColumn = new TableColumn(
				datenQuelleTable, SWT.NONE);

		final CheckboxTableViewer datenQuellenTableViewer = new CheckboxTableViewer(
				datenQuelleTable);
		final ObservableListContentProvider datenQuelleProvider = new ObservableListContentProvider();
		datenQuellenTableViewer.setContentProvider(datenQuelleProvider);

		datenQuellenTableViewer.setInput(new WritableList(Arrays
				.asList(TypDatenQuellen.values()), TypDatenQuellen.class));
		datenQuelleTableColumn.pack();

		final Table verkehrsDatenTable = new Table(verkehrsDatenComposite,
				SWT.CHECK);
		verkehrsDatenTable.setLayoutData(new ColumnLayoutData());
		final TableColumn verkehrsDatenTableColumn = new TableColumn(
				verkehrsDatenTable, SWT.NONE);
		final CheckboxTableViewer verkehrsDatenTableViewer = new CheckboxTableViewer(
				verkehrsDatenTable);
		final ObservableListContentProvider verkehrsDatenProvider = new ObservableListContentProvider();
		verkehrsDatenTableViewer.setContentProvider(verkehrsDatenProvider);
		verkehrsDatenTableViewer.setInput(new WritableList(Arrays
				.asList(TypVerkehrsDaten.values()), TypVerkehrsDaten.class));
		verkehrsDatenTableColumn.pack();

		final Composite prognoseTypComposite = newPartAndClient(client,
				toolkit, "Streckenprofil Aspekt", new GridData(SWT.FILL,
						SWT.FILL, false, false, 1, 1), false);
		prognoseTypComposite.setLayout(tableLayout);
		final ComboViewer prognoseTypenCombo = new ComboViewer(
				prognoseTypComposite, SWT.READ_ONLY);
		prognoseTypenCombo.getControl().setLayoutData(new ColumnLayoutData());
		final ObservableListContentProvider prognoseTypenProvider = new ObservableListContentProvider();
		prognoseTypenCombo.setContentProvider(prognoseTypenProvider);
		prognoseTypenCombo.setLabelProvider(new PrognoseTypLabelProvider());
		prognoseTypenCombo.setInput(new WritableList(Arrays
				.asList(TypPrognoseTyp.values()), TypPrognoseTyp.class));

		// initialisieren
		prognoseTypenCombo.setSelection(new StructuredSelection(model
				.getChartProperties().getTypPrognoseTyp()));
		dbc.bindValue(
				ViewersObservables.observeSingleSelection(prognoseTypenCombo),
				EMFObservables.observeValue(
						model.getChartProperties(),
						StreckenprofilPackage.Literals.DIAGRAMM_EIGENSCHAFTEN__TYP_PROGNOSE_TYP));

		datenQuellenTableViewer
				.addCheckStateListener(new ICheckStateListener() {

					@Override
					public void checkStateChanged(
							final CheckStateChangedEvent event) {
						if (event.getElement() instanceof TypDatenQuellen) {
							final TypDatenQuellen datenquelle = (TypDatenQuellen) event
									.getElement();
							if (event.getChecked()) {

								for (final Object obj : verkehrsDatenTableViewer
										.getCheckedElements()) {
									if (obj instanceof TypVerkehrsDaten) {
										final LinienEigenschaften lpNeu = StreckenprofilFactory.eINSTANCE
												.createLinienEigenschaften();
										final RGB farbe = StreckenprofilUtil
												.getNaechsteFarbe();
										lpNeu.setTypDatenQuelle(datenquelle);
										lpNeu.setRgb(farbe);
										lpNeu.setKnotenFarbe(farbe);
										lpNeu.setTypVerkehrsDaten((TypVerkehrsDaten) obj);
										model.getLineProperties().add(lpNeu);
										setDirty(true);
									}
								}
							} else {
								final Collection<LinienEigenschaften> lpEntfernen = new ArrayList<LinienEigenschaften>();
								for (final LinienEigenschaften lpAlt : model
										.getLineProperties()) {
									if (datenquelle.equals(lpAlt
											.getTypDatenQuelle())) {
										lpEntfernen.add(lpAlt);
									}
									setDirty(true);
								}
								model.getLineProperties()
										.removeAll(lpEntfernen);
							}
						}
					}
				});

		dbc.bindSet(ViewersObservables.observeCheckedElements(
				datenQuellenTableViewer, TypDatenQuellen.class),
				new ComputedSet() {

					@Override
					protected Set<TypDatenQuellen> calculate() {
						final Set<TypDatenQuellen> result = new HashSet<TypDatenQuellen>();
						for (final LinienEigenschaften lp : model
								.getLineProperties()) {
							if (lp != null && lp.getTypDatenQuelle() != null) {
								result.add(lp.getTypDatenQuelle());
							}
						}
						return result;
					}
				});

		verkehrsDatenTableViewer
				.addCheckStateListener(new ICheckStateListener() {

					@Override
					public void checkStateChanged(
							final CheckStateChangedEvent event) {
						if (event.getElement() instanceof TypVerkehrsDaten) {
							final TypVerkehrsDaten verkehrsDaten = (TypVerkehrsDaten) event
									.getElement();
							if (event.getChecked()) {

								for (final Object obj : datenQuellenTableViewer
										.getCheckedElements()) {
									if (obj instanceof TypDatenQuellen) {
										final LinienEigenschaften lpNeu = StreckenprofilFactory.eINSTANCE
												.createLinienEigenschaften();
										final RGB farbe = StreckenprofilUtil
												.getNaechsteFarbe();
										lpNeu.setRgb(farbe);
										lpNeu.setKnotenFarbe(farbe);
										lpNeu.setTypVerkehrsDaten(verkehrsDaten);
										lpNeu.setTypDatenQuelle((TypDatenQuellen) obj);
										model.getLineProperties().add(lpNeu);
										setDirty(true);
									}
								}
							} else {
								final Collection<LinienEigenschaften> lpEntfernen = new ArrayList<LinienEigenschaften>();
								for (final LinienEigenschaften lpAlt : model
										.getLineProperties()) {
									if (verkehrsDaten.equals(lpAlt
											.getTypVerkehrsDaten())) {
										lpEntfernen.add(lpAlt);
									}
									setDirty(true);
								}
								model.getLineProperties()
										.removeAll(lpEntfernen);
							}

						}
					}
				});

		dbc.bindSet(ViewersObservables.observeCheckedElements(
				verkehrsDatenTableViewer, TypVerkehrsDaten.class),
				new ComputedSet() {

					@Override
					protected Set<TypVerkehrsDaten> calculate() {
						final Set<TypVerkehrsDaten> result = new HashSet<TypVerkehrsDaten>();
						for (final LinienEigenschaften lp : model
								.getLineProperties()) {
							if (lp != null && lp.getTypVerkehrsDaten() != null) {
								result.add(lp.getTypVerkehrsDaten());
							}
						}
						return result;
					}
				});

	}

	/**
	 * Erzeugt die Lage-Section.
	 * 
	 * @param toolkit
	 *            das aktuelle FormToolkit
	 * @param parent
	 *            das Parent-Composite
	 * 
	 * @return die Section
	 */
	protected Section erzeugeLageSection(final FormToolkit toolkit,
			final Composite parent) {

		final Section section = toolkit.createSection(parent,
				Section.DESCRIPTION | ExpandableComposite.TITLE_BAR
						| ExpandableComposite.EXPANDED);
		GridDataFactory.fillDefaults().applyTo(section);
		section.setText("Streckenprofil - Lage");

		final Composite composite = toolkit.createComposite(section);
		section.setClient(composite);

		GridLayoutFactory.fillDefaults().numColumns(5).equalWidth(false)
				.spacing(10, 10).applyTo(composite);

		// (1.1) Strae
		toolkit.createLabel(composite, "Strae:");
		strasseComboViewer = new ComboViewer(composite, SWT.READ_ONLY);
		strasseComboViewer
				.setComparer(new SystemObjektContainerElementComparer());
		strasseComboViewer.setContentProvider(new ArrayContentProvider());
		strasseComboViewer.getCombo().setVisibleItemCount(7);
		strasseComboViewer.setLabelProvider(new LabelProvider() {

			/*
			 * (non-Javadoc)
			 * 
			 * @see
			 * org.eclipse.jface.viewers.LabelProvider#getText(java.lang.Object)
			 */
			@Override
			public String getText(final Object element) {
				if (element instanceof Strecke) {
					return ((Strecke) element).getName();
				}
				return super.getText(element);
			}
		});
		strasseComboViewer.setSorter(new ViewerSorter() {

			/*
			 * (non-Javadoc)
			 * 
			 * @see
			 * org.eclipse.jface.viewers.ViewerComparator#compare(org.eclipse
			 * .jface.viewers.Viewer, java.lang.Object, java.lang.Object)
			 */
			@Override
			public int compare(final Viewer viewer, final Object e1,
					final Object e2) {
				if (e1 instanceof Strecke && e2 instanceof Strecke) {
					return StartupPlugin
							.getDefault()
							.getDefaultNetzCacheExtended()
							.compareStrassen(((Strecke) e1).getModellObjekt(),
									((Strecke) e2).getModellObjekt());
				} else {
					return super.compare(viewer, e1, e2);
				}
			}

		});
		strasseComboViewer.setInput(ermittleAlleStrecken());

		GridDataFactory.fillDefaults().align(SWT.FILL, SWT.FILL).span(4, 1)
				.grab(true, false).applyTo(strasseComboViewer.getCombo());

		// (1.2) Richtung
		GridDataFactory.swtDefaults().span(1, 2)
				.applyTo(toolkit.createLabel(composite, "Richtung:"));
		positiveRichtungButton = toolkit.createButton(composite,
				RICHTUNG_POSITIV_TEXT, SWT.RADIO);

		GridDataFactory.fillDefaults().span(4, 1).indent(5, 0)
				.align(SWT.FILL, SWT.FILL).applyTo(positiveRichtungButton);
		negativeRichtungButton = toolkit.createButton(composite,
				RICHTUNG_NEGATIV_TEXT, SWT.RADIO);

		GridDataFactory.fillDefaults().indent(5, 0).align(SWT.FILL, SWT.FILL)
				.span(4, 1).applyTo(negativeRichtungButton);

		// (2.1) Startknoten
		toolkit.createLabel(composite, "von:");
		startKnotenComboViewer = new ComboViewer(composite, SWT.READ_ONLY);
		startKnotenComboViewer
				.setComparer(new SystemObjektContainerElementComparer());
		startKnotenComboViewer.getCombo().setVisibleItemCount(7);
		startKnotenComboViewer.setLabelProvider(new LabelProvider() {

			/*
			 * (non-Javadoc)
			 * 
			 * @see
			 * org.eclipse.jface.viewers.LabelProvider#getText(java.lang.Object)
			 */
			@Override
			public String getText(final Object element) {
				if (element instanceof StreckenKnoten) {
					return ((StreckenKnoten) element).getName();
				}
				return super.getText(element);
			}

		});
		startKnotenComboViewer.setContentProvider(new ArrayContentProvider());
		GridDataFactory.fillDefaults().align(SWT.FILL, SWT.FILL).span(4, 1)
				.grab(true, false).applyTo(startKnotenComboViewer.getCombo());

		// (3.1) Endknoten
		toolkit.createLabel(composite, "bis:");
		endKnotenComboViewer = new ComboViewer(composite, SWT.READ_ONLY);
		endKnotenComboViewer
				.setComparer(new SystemObjektContainerElementComparer());
		endKnotenComboViewer.getCombo().setVisibleItemCount(7);
		endKnotenComboViewer.setLabelProvider(new LabelProvider() {
			/*
			 * (non-Javadoc)
			 * 
			 * @see
			 * org.eclipse.jface.viewers.LabelProvider#getText(java.lang.Object)
			 */
			@Override
			public String getText(final Object element) {
				if (element instanceof StreckenKnoten) {
					return ((StreckenKnoten) element).getName();
				}
				return super.getText(element);
			}

		});
		endKnotenComboViewer.setContentProvider(new ArrayContentProvider());

		GridDataFactory.fillDefaults().align(SWT.FILL, SWT.FILL).span(4, 1)
				.grab(true, false).applyTo(endKnotenComboViewer.getCombo());

		return section;
	}

	/**
	 * Erzeugt alle Bindings und Listener usw. fr die Lage-Section
	 */
	private void erzeugeLageBinding() {

		positiveRichtungButton.addSelectionListener(new SelectionAdapter() {
			@Override
			public void widgetSelected(final SelectionEvent e) {
				final Button b = (Button) e.getSource();
				if (b.getSelection()
						&& !AttTmcRichtung.ZUSTAND_1_POSITIV.equals(model
								.getErsteStrecke().getRichtung())) {
					model.removeAlleStrecken();
					final Object strassenObj = ((StructuredSelection) strasseComboViewer
							.getSelection()).getFirstElement();
					if (strassenObj instanceof Strecke) {
						final Strecke s = (Strecke) strassenObj;
						s.setRichtung(AttTmcRichtung.ZUSTAND_1_POSITIV);
						final List<StreckenKnoten> knoten = ermittleAlleKnoten(s);
						if (!knoten.isEmpty()) {
							model.addStreckenKnoten(s, knoten.iterator().next());
							startKnotenComboViewer.setInput(knoten);
							endKnotenComboViewer
									.setInput(ermittleRestlicheKnoten(s, knoten
											.iterator().next()));
							setDirty(true);
						}
					}
				}
			}
		});

		negativeRichtungButton.addSelectionListener(new SelectionAdapter() {
			@Override
			public void widgetSelected(final SelectionEvent e) {
				final Button b = (Button) e.getSource();
				if (b.getSelection()
						&& !AttTmcRichtung.ZUSTAND_1N_NEGATIV.equals(model
								.getErsteStrecke().getRichtung())) {
					model.removeAlleStrecken();
					final Object strassenObj = ((StructuredSelection) strasseComboViewer
							.getSelection()).getFirstElement();
					if (strassenObj instanceof Strecke) {
						final Strecke s = (Strecke) strassenObj;
						s.setRichtung(AttTmcRichtung.ZUSTAND_1N_NEGATIV);
						final List<StreckenKnoten> knoten = ermittleAlleKnoten(s);
						if (!knoten.isEmpty()) {
							model.addStreckenKnoten(s, knoten.iterator().next());
							startKnotenComboViewer.setInput(knoten);

							endKnotenComboViewer
									.setInput(ermittleRestlicheKnoten(s, knoten
											.iterator().next()));
							setDirty(true);
						}
					}
				}
			}
		});

		strasseComboViewer.addSelectionChangedListener(new ISelectionChangedListener() {
      @Override
      public void selectionChanged(final SelectionChangedEvent event)
      {
        final ISelection s = event.getSelection();
        if (s instanceof StructuredSelection)
        {
          final Object firstObj = ((StructuredSelection)s).getFirstElement();
          if (firstObj instanceof Strecke)
          {
            if (model.getErsteStrecke() == null
                || !((Strecke)firstObj).getModellObjekt().equals(model.getErsteStrecke().getModellObjekt()))
            {
              model.removeAlleStrecken();
              ((Strecke)firstObj).setRichtung(AttTmcRichtung.ZUSTAND_1_POSITIV);
              final List<StreckenKnoten> knoten = ermittleAlleKnoten((Strecke)firstObj);
              
              System.out.println("Knoten: " + knoten.size());              

              final List<StreckenKnoten> restlicheKnoten = ermittleRestlicheKnoten(((Strecke)firstObj), knoten
                  .iterator().next());
              if (!knoten.isEmpty() && !restlicheKnoten.isEmpty())
              {
                startKnotenComboViewer.setInput(knoten);
                endKnotenComboViewer.setInput(restlicheKnoten);
                startKnotenComboViewer.setSelection(new StructuredSelection(knoten.iterator().next()));

                endKnotenComboViewer.setSelection(new StructuredSelection(restlicheKnoten.iterator().next()));
                positiveRichtungButton.setText(RichtungTextComputedValue.getRichtungText(netzCache, ((Strecke)firstObj)
                    .getStrasse(), AttTmcRichtung.ZUSTAND_1_POSITIV));
                negativeRichtungButton.setText(RichtungTextComputedValue.getRichtungText(netzCache, ((Strecke)firstObj)
                    .getStrasse(), AttTmcRichtung.ZUSTAND_1N_NEGATIV));
                setDirty(true);
              }
            }
          }
        }

      }
    });
		startKnotenComboViewer
				.addSelectionChangedListener(new ISelectionChangedListener() {

					@Override
					public void selectionChanged(
							final SelectionChangedEvent event) {
						final ISelection s = event.getSelection();
						if (s instanceof StructuredSelection) {
							final Object firstObj = ((StructuredSelection) s)
									.getFirstElement();
							if (firstObj instanceof StreckenKnoten) {
								final StreckenKnoten knoten = (StreckenKnoten) firstObj;

								if (model.getErsterStreckenKnoten() == null
										|| !knoten.getModellObjekt().equals(
												model.getErsterStreckenKnoten()
														.getModellObjekt())) {
									final Object obj = ((StructuredSelection) strasseComboViewer
											.getSelection()).getFirstElement();
									if (obj instanceof Strecke) {
										final Strecke strecke = (Strecke) obj;
										model.removeAlleStrecken();
										model.addStreckenKnoten(strecke, knoten);
										endKnotenComboViewer
												.setInput(ermittleRestlicheKnoten(
														strecke, knoten));
										setDirty(true);
									}
								}
							}
						}

					}
				});

		endKnotenComboViewer
				.addSelectionChangedListener(new ISelectionChangedListener() {

					@Override
					public void selectionChanged(
							final SelectionChangedEvent event) {
						Realm.getDefault().asyncExec(new Runnable() {

							@Override
							public void run() {
								final ISelection s = event.getSelection();
								if (s instanceof StructuredSelection) {
									final Object firstObj = ((StructuredSelection) s)
											.getFirstElement();
									if (firstObj instanceof StreckenKnoten) {
										final StreckenKnoten knoten = (StreckenKnoten) firstObj;

										if (model.getLetzterStreckenKnoten() == null
												|| !knoten
														.getModellObjekt()
														.equals(model
																.getLetzterStreckenKnoten()
																.getModellObjekt())) {
											final Object objStrasse = ((StructuredSelection) strasseComboViewer
													.getSelection())
													.getFirstElement();
											final Object objStartKnoten = ((StructuredSelection) startKnotenComboViewer
													.getSelection())
													.getFirstElement();
											if (knoten instanceof StreckenKnoten
													&& objStrasse instanceof Strecke
													&& objStartKnoten instanceof StreckenKnoten) {
												final Strecke strecke = (Strecke) objStrasse;
												final StreckenKnoten startKnoten = (StreckenKnoten) objStartKnoten;
												model.removeAlleStrecken();
												model.addFirstStreckenKnoten(
														startKnoten, strecke);
												model.addStreckenKnoten(
														strecke, knoten);
												setDirty(true);
											}
										}
									}
								}
							}
						});
					}
				});

	}

	/**
	 * Erzeugt die Tabelle, in der der aktuell ausgewhlte Streckenzug
	 * dargstellt wird.
	 * 
	 * @param formBody
	 *            das Parent Composite.
	 * @param toolkit
	 *            das Toolkit.
	 */
	private void createStreckenzugSection(final Composite formBody,
			final FormToolkit toolkit) {

		final Section sectionStreckenZug = toolkit.createSection(formBody,
				defaultSectionStyle);
		GridDataFactory.fillDefaults().grab(true, true).hint(1, 200).span(3, 1)
				.applyTo(sectionStreckenZug);
		sectionStreckenZug.setText("Streckenzug");
		final Composite streckeClient = toolkit.createComposite(
				sectionStreckenZug, SWT.NONE);
		toolkit.paintBordersFor(streckeClient);
		sectionStreckenZug.setClient(streckeClient);
		streckeClient.setLayout(new GridLayout());
		final Composite treeComp = toolkit.createComposite(streckeClient);
		treeComp.setLayoutData(GridDataFactory.fillDefaults().grab(true, true)
				.minSize(400, 200).create());
		nodesTable = new CheckboxTreeViewer(toolkit.createTree(treeComp,
				SWT.MULTI | SWT.BORDER | SWT.CHECK | SWT.FULL_SELECTION
						| SWT.VIRTUAL));
		final TreeColumnLayout layout = new TreeColumnLayout();
		treeComp.setLayout(layout);
		nodesTable.getTree().setHeaderVisible(true);
		final TreeColumn strecke = new TreeColumn(nodesTable.getTree(),
				SWT.CHECK);
		strecke.setText("Strecke");
		layout.setColumnData(strecke, new ColumnWeightData(75, true));
		final TreeColumn streckenkilometer = new TreeColumn(
				nodesTable.getTree(), SWT.RIGHT);
		streckenkilometer.setText("Streckenkilometer");
		layout.setColumnData(streckenkilometer, new ColumnWeightData(25, true));

		final TreeColumn laenge = new TreeColumn(nodesTable.getTree(),
				SWT.RIGHT);
		laenge.setText("Lnge");
		layout.setColumnData(laenge, new ColumnWeightData(25, true));
		nodesTable.setContentProvider(new StreckenZugTreeContentProvider());
		nodesTable.setLabelProvider(new StreckenZugTreeLabelProvider());
		nodesTable.setAutoExpandLevel(2);
		nodesTable.setComparator(new ViewerComparator() {

			/*
			 * (non-Javadoc)
			 * 
			 * @see
			 * org.eclipse.jface.viewers.ViewerComparator#compare(org.eclipse
			 * .jface.viewers.Viewer, java.lang.Object, java.lang.Object)
			 */
			@Override
			public int compare(final Viewer viewer, final Object e1,
					final Object e2) {
				if (e1 instanceof StreckenZugEintrag
						&& e1 instanceof StreckenZugEintrag) {
					return Double.compare(
							((StreckenZugEintrag) e1).getWegBisher(),
							((StreckenZugEintrag) e2).getWegBisher());
				}
				return 0;
			}

		});
		if (mqCache.isInitialisiert() && netzCache.isInitialisiert()
				&& netzCacheExt.isInitialisiert()) {
			// Tabelle initialisiern, ansonsten spter
			nodesTable.setInput(model.getStreckenZug());
		}

		model.getEMFModell().eAdapters().add(new EContentAdapter() {

			/*
			 * (non-Javadoc)
			 * 
			 * @see
			 * org.eclipse.emf.ecore.util.EContentAdapter#notifyChanged(org.
			 * eclipse.emf.common.notify.Notification)
			 */
			@Override
			public void notifyChanged(final Notification notification) {
				super.notifyChanged(notification);
				if (StreckenprofilPackage.Literals.ACTIVATEABLE_CONTAINER__ACTIVATEABLES
						.equals(notification.getFeature())) {
					if (nodesTable != null
							&& !nodesTable.getControl().isDisposed()) {
						final Object neuerWert = notification.getNewValue();
						if (neuerWert != null
								&& model.getErsteStrecke() != null) {
							for (final Strecke s : model.getStrecken()) {
								nodesTable.setExpandedState(s, true);
							}
						}
					}

				}
			}

		});

		nodesTable
				.setCheckStateProvider(new StreckenprofilTreeCheckStateProvider(
						nodesTable, model));

		getSite().setSelectionProvider(nodesTable);
		createSectionToolbar(sectionStreckenZug);

	}

	/**
	 * Erzeugt den Toolbar der Objektdarstellung in der angegebenen Sektion.
	 * 
	 * @param sektion
	 *            die Sektion, in der der Toolbar angezeigt werden soll
	 */
	private void createSectionToolbar(final Section sektion) {
		final ToolBarManager toolBarManager = new ToolBarManager(SWT.FLAT);
		final ToolBar toolbar = toolBarManager.createControl(sektion);
		final Cursor handCursor = new Cursor(Display.getCurrent(),
				SWT.CURSOR_HAND);
		toolbar.setCursor(handCursor);
		toolbar.addDisposeListener(new DisposeListener() {
			@Override
			public void widgetDisposed(final DisposeEvent e) {
				if (!handCursor.isDisposed()) {
					handCursor.dispose();
				}
			}
		});

		toolBarManager.add(new Action("Alles Aufklappen", Activator
				.getDefault().getImageDescriptor(Activator.ICON_EXPAND_ALL)) {

			/*
			 * (non-Javadoc)
			 * 
			 * @see org.eclipse.jface.action.Action#run()
			 */
			@Override
			public void run() {
				super.run();
				if (nodesTable != null) {
					nodesTable.expandAll();
          // Tree tree = nodesTable.getTree();
          // TreeItem[] items = tree.getItems();
          // int cnt = 0;
          // ausgabeRekursiv(items, cnt);               
				}
			}

		});
		toolBarManager.update(true);
		sektion.setTextClient(toolbar);
	}

	/**
	 * Ermittelt alle {@link Strecke}n aus dem Netz.
	 * 
	 * @return Menge aller Strecken des Streckennetzes.
	 */
	private Set<Strecke> ermittleAlleStrecken() {
		if (!netzCache.isInitialisiert()) {
			return null;
		}
		return createStrecken(netzCache.getStrassen());
	}

	/**
	 * Ermittelt alle nachfolgenden Knoten fr die Knoten - Tabelle, die noch
	 * nicht besucht wurden.
	 * 
	 * @param s
	 *            Die {@link Strecke}, deren {@link StreckenKnoten} ermittelt
	 *            werden sollen.
	 * @return Ein Liste aller {@link StreckenKnoten}, der bergebenen
	 *         {@link Strecke}.
	 */
	private List<StreckenKnoten> ermittleAlleKnoten(final Strecke s) {
		if (s != null && netzCacheExt.isInitialisiert()) {
			Strasse strasse = s.getModellObjekt();
			final AttTmcRichtung richtung = s.getRichtung();
			if (strasse == null) {
				strasse = s.getModellObjekt();
			}
			final List<StreckenKnoten> result = new ArrayList<StreckenKnoten>();
			for (final StrassenKnoten kn : netzCacheExt.getStrassenKnoten(
					strasse, richtung)) {
				final StreckenKnoten knoten = StreckenprofilFactory.eINSTANCE
						.createStreckenKnoten();
				knoten.setStrassenKnoten(kn);
				result.add(knoten);

			}
			return result;
		} else {
			return null;
		}
	}

	/**
	 * Ermittelt alle nachfolgenden Knoten fr die Knoten - Tabelle, die noch
	 * nicht besucht wurden.
	 * 
	 * @param knoten
	 *            der Knoten dessen Nachfolger gesucht werden.
	 * @param strecke
	 *            die Strecke deren Knoten gesucht werden.
	 * @return Liste aller restliche {@link StreckenKnoten}.
	 */
	private List<StreckenKnoten> ermittleRestlicheKnoten(final Strecke strecke,
			final StreckenKnoten knoten) {
		List<StreckenKnoten> result = null;
		if (strecke != null) {
			Strasse strasse = strecke.getModellObjekt();
			final AttTmcRichtung richtung = strecke.getRichtung();
			if (strasse == null) {
				strasse = model.getErsteStrecke().getModellObjekt();
			}
			if (knoten != null) {

				result = new ArrayList<StreckenKnoten>();
				for (final StrassenKnoten kn : streckenCache
						.getNachfolgerStrassenKnoten(strasse, richtung,
								knoten.getModellObjekt())) {
					final StreckenKnoten neuerKnoten = StreckenprofilFactory.eINSTANCE
							.createStreckenKnoten();
					neuerKnoten.setStrassenKnoten(kn);
					result.add(neuerKnoten);

				}
			}
		}
		return result;
	}

	/**
	 * Erzeugt die Menge aller Strecken der Strasse.
	 * 
	 * @param strassen
	 *            die Strasse.
	 * @return die Menge aller Strecken der Strasse.
	 */
	protected Set<Strecke> createStrecken(final Set<Strasse> strassen) {
		if (!netzCacheExt.isInitialisiert()) {
			return null;
		}
		final Set<Strecke> ret = new TreeSet<Strecke>();
		for (final Strasse strasse : strassen) {
			final Strecke strecke = StreckenprofilFactory.eINSTANCE
					.createStrecke();
			strecke.setStrasse(strasse);
			if (netzCacheExt.istRichtungDefiniert(strasse,
					AttTmcRichtung.ZUSTAND_1_POSITIV)) {
				strecke.setRichtung(AttTmcRichtung.ZUSTAND_1_POSITIV);
			} else {
				strecke.setRichtung(AttTmcRichtung.ZUSTAND_1N_NEGATIV);
			}
			ret.add(strecke);
		}
		return ret;
	}

	@Override
	public void propertyChange(final PropertyChangeEvent arg0) {
		if (AbstractCache.PROP_STATE.equals(arg0.getPropertyName())) {
			if (netzCacheExt.isInitialisiert()
					&& streckenCache.isInitialisiert()
					&& netzCache.isInitialisiert() && mqCache.isInitialisiert()) {
				if (getManagedForm() != null
						&& getManagedForm().getForm() != null
						&& !getManagedForm().getForm().isDisposed()) {
					// seid ihr (Caches) alle da ? - JA
					getManagedForm().getForm().getDisplay()
							.asyncExec(new Runnable() {

								@Override
								public void run() {

									getManagedForm().getForm().setEnabled(true);
									getManagedForm().getForm().setBusy(false);
									getManagedForm().getForm().setMessage(null,
											IMessageProvider.NONE);
									initialisieren();
																	
								}
							});
				}
			}
		}
		
		Display.getDefault().asyncExec(new Runnable() {

		  @Override
      public void run() {
        if (historischeDatenJob != null && arg0.getSource() == historischeDatenJob) {
          if (HistorischeDatenJob.PROP_ZUSTAND.equals(arg0.getPropertyName())) {
            if (arg0.getNewValue().equals(HistorischeDatenJob.ZUSTAND_ARCHIVE_REQUEST)) {
              startSimu.setEnabled(false);
              endSimu.setEnabled(true);
              pauseSimu.setEnabled(false);
              simulationsGeschwindigkeit.setEnabled(false);  
            }
            else if (arg0.getNewValue().equals(HistorischeDatenJob.ZUSTAND_DATA_PROCESSING)) {
              startSimu.setEnabled(false);
              endSimu.setEnabled(true);
              pauseSimu.setEnabled(true);
              simulationsGeschwindigkeit.setEnabled(false);
            } 
            else if (arg0.getNewValue().equals(HistorischeDatenJob.ZUSTAND_PAUSE_STATE)) {
              startSimu.setEnabled(true);
              endSimu.setEnabled(true);
              pauseSimu.setEnabled(false);
              simulationsGeschwindigkeit.setEnabled(true);  
            }
            else if (arg0.getNewValue().equals(HistorischeDatenJob.ZUSTAND_IDLE_STATE)) {
              startSimu.setEnabled(false);
              endSimu.setEnabled(true);
              pauseSimu.setEnabled(false);
              simulationsGeschwindigkeit.setEnabled(false);
            }
          }
        }
      }
	
		});

	}
	
	void ausgabeRekursiv(TreeItem[] items, int cnt){
	  if (items != null && items.length > 0){
	    for (TreeItem treeItem : items)
	    {	   
	      String s = "";
	      for (int i = 0; i < cnt; i++)
	      {	      
	        s+= "  ";
	      }
	      System.out.println(s + " " + treeItem.getText(0));
	      items = treeItem.getItems();
	      if (items != null && items.length > 0)
	        ausgabeRekursiv(items, ++cnt); 
	      else{
	        cnt--;
	      }
	    }	    
	  }else{
	   cnt--;
	  }
	}
	
	/**
	 * Initialisieren der FormPage.
	 */
	private void initialisieren() {
		if (nodesTable != null) {
			nodesTable.setInput(model.getStreckenZug());
		}
		strasseComboViewer.setInput(ermittleAlleStrecken());
		if (model.getErsteStrecke() != null) {
			strasseComboViewer.setSelection(new StructuredSelection(model
					.getErsteStrecke()));
			startKnotenComboViewer.setInput(ermittleAlleKnoten(model
					.getErsteStrecke()));
			startKnotenComboViewer.setSelection(new StructuredSelection(model
					.getErsterStreckenKnoten()));
			endKnotenComboViewer.setInput(ermittleRestlicheKnoten(
					model.getErsteStrecke(), model.getErsterStreckenKnoten()));
			endKnotenComboViewer.setSelection(new StructuredSelection(model
					.getLetzterStreckenKnoten()));
			positiveRichtungButton.setText(RichtungTextComputedValue
					.getRichtungText(netzCache, model.getErsteStrecke()
							.getStrasse(), AttTmcRichtung.ZUSTAND_1_POSITIV));
			negativeRichtungButton.setText(RichtungTextComputedValue
					.getRichtungText(netzCache, model.getErsteStrecke()
							.getStrasse(), AttTmcRichtung.ZUSTAND_1N_NEGATIV));
			if (AttTmcRichtung.ZUSTAND_1_POSITIV.equals(model.getErsteStrecke()
					.getRichtung())) {
				positiveRichtungButton.setSelection(true);
				negativeRichtungButton.setSelection(false);
			} else {
				positiveRichtungButton.setSelection(false);
				negativeRichtungButton.setSelection(true);
			}
		}

	}

	@Override
	public void dispose() {
		SelektionsTransfer.getInstanz().removeSelektionsListener(this);
		mqCache.removePropertyChangeListener(this);
		netzCache.removePropertyChangeListener(this);
		netzCacheExt.removePropertyChangeListener(this);
		streckenCache.removePropertyChangeListener(this);
		super.dispose();
	}

	/**
	 * Liefert das Modell des Streckenprofils.
	 * 
	 * @return the model
	 */
	public final Modell getModel() {
		return model;
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see org.eclipse.ui.forms.editor.FormPage#isDirty()
	 */
	@Override
	public boolean isDirty() {
		return dirty;
	}

	/**
	 * Setzt das lokale Dirty - Flag.
	 * 
	 * @param newDirtyFlag
	 *            der neue dirty - Zustand des Editors.
	 */
	protected void setDirty(final boolean newDirtyFlag) {
		dirty = newDirtyFlag;
		firePropertyChange(PROP_DIRTY);
		if (getManagedForm() != null) {
			getManagedForm().getForm().getDisplay().asyncExec(new Runnable() {

				@Override
				public void run() {
					getManagedForm().dirtyStateChanged();
				}
			});

		}
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see
	 * org.eclipse.ui.forms.editor.FormPage#doSave(org.eclipse.core.runtime.
	 * IProgressMonitor)
	 */
	@Override
	public void doSave(final IProgressMonitor monitor) {
		super.doSave(monitor);
		setDirty(false);
	}

	/**
	 * Setzt die Aktivierungzustnde der Buttons zum Starten und Stoppen der
	 * Offline Simulation.
	 * 
	 * @param neuerZustand
	 *            der neue Simulationszustand.
	 */
	public void setSimulationsZustand(final AttSimulationsZustand neuerZustand) {
		if (startSimu != null && !startSimu.isDisposed() && endSimu != null
				&& !endSimu.isDisposed()) {
			startSimu.getDisplay().asyncExec(new Runnable() {

				@Override
				public void run() {
					if (AttSimulationsZustand.ZUSTAND_0_NEU
							.equals(neuerZustand)) {
						startSimu.setEnabled(false);
						// startSimu.setSelection(true);
						endSimu.setEnabled(false);
						pauseSimu.setEnabled(false);
						simulationsGeschwindigkeit.setEnabled(false);
					} else if (AttSimulationsZustand.ZUSTAND_1_VORSTART
							.equals(neuerZustand)) {
						startSimu.setEnabled(false);
						endSimu.setEnabled(false);
						pauseSimu.setEnabled(false);
						simulationsGeschwindigkeit.setEnabled(false);
					} else if (AttSimulationsZustand.ZUSTAND_2_START
							.equals(neuerZustand)) {
						startSimu.setEnabled(false);
						endSimu.setEnabled(true);
						pauseSimu.setEnabled(true);
						simulationsGeschwindigkeit.setEnabled(false);
					} else if (AttSimulationsZustand.ZUSTAND_3_STOP
							.equals(neuerZustand)) {
						startSimu.setEnabled(true);
						endSimu.setEnabled(false);
						pauseSimu.setEnabled(false);
						simulationsGeschwindigkeit.setEnabled(true);
						final OfflineSimulation sim = ((StreckenprofilEditor) getEditor())
								.getAktuelleSimulation();
						if (sim != null) {
							final SimulationBeendenUndVernichtenJob job = new SimulationBeendenUndVernichtenJob(
									sim);
							job.schedule();
						}
					} else if (AttSimulationsZustand.ZUSTAND_4_GELOESCHT
							.equals(neuerZustand)) {
						startSimu.setEnabled(true);
						endSimu.setEnabled(false);
						pauseSimu.setEnabled(false);
						simulationsGeschwindigkeit.setEnabled(true);
					} else if (AttSimulationsZustand.ZUSTAND_5_PAUSE
							.equals(neuerZustand)) {
						startSimu.setEnabled(true);
						endSimu.setEnabled(true);
						pauseSimu.setEnabled(true);
						simulationsGeschwindigkeit.setEnabled(true);
					} else if (AttSimulationsZustand.ZUSTAND_6_EINZELSCHRITT
							.equals(neuerZustand)) {
						startSimu.setEnabled(false);
						endSimu.setEnabled(false);
						pauseSimu.setEnabled(false);
						simulationsGeschwindigkeit.setEnabled(true);
					}
				}
			});
		}
	}

	@Override
	public boolean aktuelleSelektionBeobachten() {
		return false;
	}

	@Override
	public boolean definierteSelektionenBeobachten(final String... namen) {
		for (final String name : namen) {
			if (BitCtrlRahmenwerkConstants.SELECTION_STRECKEN_ZUG.equals(name)) {
				return true;
			}
		}
		return false;
	}

	@Override
	public boolean vorigeSelektionBeobachten() {
		return false;
	}

	@Override
	public void selectionChanged(final IWorkbenchPart part,
			final ISelection selection) {
		// nix
	}
	
	// Interface IPArtListener
	@Override
  public void partOpened(IWorkbenchPart part) {
  }
  
  @Override
  public void partDeactivated(IWorkbenchPart part) {
  }
  
  @Override
  public void partClosed(IWorkbenchPart part) {
    if (part == getEditor()) {
      if (historischeDatenJob != null) {
        historischeDatenJob.cancel();
      }
    }
  }
  
  @Override
  public void partBroughtToTop(IWorkbenchPart part) {
  }
  
  @Override
  public void partActivated(IWorkbenchPart part) {
  }

  //Interface IJobChangeListener
  
  @Override
  public void aboutToRun(IJobChangeEvent event) {
  }

  @Override
  public void awake(IJobChangeEvent event) {
  }

  @Override
  public void done(IJobChangeEvent event) {
    
    
    Display.getDefault().asyncExec(new Runnable() {

      @Override
      public void run()
      {
        if (historischeDatenJob != null /*&& event.getJob() == historischeDatenJob*/) {
          historischeDatenJob.removePropertyChangeListener(StreckenprofilEditorKonfiguration.this);
          historischeDatenJob.removeJobChangeListener(StreckenprofilEditorKonfiguration.this);
          Activator.getDefault().getLogger().info("Job " + historischeDatenJob + " beendet");
          historischeDatenJob = null;
          
          if (!startSimu.isDisposed())
            startSimu.setEnabled(false);
          if (!endSimu.isDisposed())
            endSimu.setEnabled(true);
          if (!pauseSimu.isDisposed())
            pauseSimu.setEnabled(false);
          if (!simulationsGeschwindigkeit.isDisposed())
            simulationsGeschwindigkeit.setEnabled(false);
         
        }
        
      }
      
    });

  }

  @Override
  public void running(IJobChangeEvent event) {
  }

  @Override
  public void scheduled(IJobChangeEvent event) {
  }

  @Override
  public void sleeping(IJobChangeEvent event) {
  }

}
