/*
 * This file is part of Rahmenwerk.
 * 
 * Rahmenwerk is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License  as 
 * published by the Free Software Foundation, either version 3 of the
 * License.
 * 
 * Rahmenwerk is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with Rahmenwerk.  If not, see <http://www.gnu.org/licenses/>.
 *  
 *  
 * 
 * Copyright (c) 2012 SWARCO TRAFFIC SYSTEMS GmbH.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 * SWARCO TRAFFIC SYSTEMS GmbH - initial API and implementation
 * 
 * 
 * 
 * Contact Information:
 * SWARCO TRAFFIC SYSTEMS GmbH
 * Adolf-Dambach-Strae 
 * D-76571 Gaggenau
 * Phone: +49-7225-64-03
 * Fax: +49-7225-64-300
 * mailto: office.sts@swarco.de
 */
package de.bsvrz.sba.plugin.navigator.navigatoreinstellungen;

import java.util.List;

import org.eclipse.core.runtime.preferences.AbstractPreferenceInitializer;
import org.eclipse.jface.preference.IPreferenceStore;

import de.bsvrz.buv.rw.basislib.berechtigung.DaVKommunikation;
import de.bsvrz.buv.rw.rw.dav.DaVVerbindung;
import de.bsvrz.dav.daf.main.ClientDavInterface;
import de.bsvrz.dav.daf.main.config.SystemObject;
import de.bsvrz.dav.daf.main.config.SystemObjectType;
import de.bsvrz.sba.plugin.navigator.Activator;

/**
 * Initialisierung der Einstellungen fr TKA Basis
 * 
 * @author Sans
 * 
 */
public class PreferenceInitializer extends AbstractPreferenceInitializer
{
	@Override
	public void initializeDefaultPreferences()
	{	  
		IPreferenceStore preferences = Activator.getDefault().getPreferenceStore();
		final String idInitial = Activator.PLUGIN_ID + ":" + "initial";
		
		if (!preferences.contains(idInitial)){
		  /**
		   * Default-Wert fr die Abfrage beim bernehmen
		   */	
		  String[] ss = Navigatorkategorien.NAVIGATORKATEGORIE;
		  
		  int i = 1;
		  
		  for (String s : ss)
		  {		   		  
		    preferences.setDefault( Activator.PLUGIN_ID + ":" + s, i++ );                
		  }
		  
		  ClientDavInterface _connection = DaVVerbindung.getInstanz().getDaVVerbindung();
		  SystemObjectType type = _connection.getDataModel().getType("typ.konfigurationsBereich");
		  List<SystemObject> elements = type.getElements();
		  for (SystemObject so : elements)
		  {
		    preferences.setDefault( Activator.PLUGIN_ID + ":" + so.getPid(), true);        
		  }		  
		  
		  preferences.setDefault(idInitial, true);
		}
		
	}	
		
}
