package de.bsvrz.sba.plugin.parameter.steuerungskern.actions;

import de.bsvrz.sba.plugin.parameter.steuerungskern.konfig.Konfig;
import de.bsvrz.sba.plugin.parameter.steuerungskern.view.allgemein.OpenVersorgungsViews;
import de.bsvrz.sba.plugin.parameter.steuerungskern.view.allgemein.OpenViewAuswahlAnzeigeQuerschnitte;
import de.bsvrz.sba.plugin.parameter.steuerungskern.view.allgemein.OpenViewAuswahlAnzeigen;
import de.bsvrz.sba.plugin.parameter.steuerungskern.view.allgemein.OpenViewAuswahlParameter;
import de.bsvrz.sba.plugin.parameter.steuerungskern.view.allgemein.PA;

/**
 * Klasse ffnet die Versorgungsviews der einzelnen Parameter. Knnen fr eine Parameterart mehrere Arten
 * von Parametern versorgt werden (Anlagen-, Anzeigequerschnitt oder Anzeigen spezifische Parameter), so
 * werden die entsprechenden Auswahldialoge vorher geffnet.
 * @author ObertM
 *
 */
public class OpenParameterViews
{
	/**
	 * Merker mit dem es mglich ist nur die Anlagen spezifischen Parameter zu versorgen
	 */
	private static boolean _oeffneNurAnlagenParameter = false;

	/**
	 * Methode ffnet die View mit allen Auswahlmglichkeiten
	 * @param parameterArt Kennung welche Parameterart geffnet werden soll
	 */
  public static void oeffne (String parameterArt)
  {
  	oeffne (parameterArt, PA.ANLAGE | PA.QUERSCHNITT | PA.ANZEIGE);
  }

  /**
   * Methode ffnet die View mit der Option zu whlen ob die Anlagen- Anzeigequerschnitt- oder
   * Anzeigen spezifische Parameter versorgt werden sollen.
   * @param parameterArt Parameterart  
   * @param auswahl Auswahl ob welche Parameter versorgt werden sollen (Veroderung von {@link PA})
   */
  public static void oeffne (String parameterArt, int auswahl)
  {
		String pidSBA = Konfig.getInstance().getPidSBA();

		/*
		 * Spezialfall: nur Anlagen spezifische Parameter zulassen 
		 */
		if (_oeffneNurAnlagenParameter)
		{
			if ((auswahl & PA.ANLAGE) == PA.ANLAGE)
				auswahl = PA.ANLAGE;
		}
		
		/*
		 * Prfen ob Auswahldialog geffnet werden muss
		 */
		
		if ((auswahl == PA.ANLAGE) || (auswahl == PA.QUERSCHNITT) || (auswahl == PA.ANZEIGE))
		{
			if (auswahl == PA.ANLAGE)
	  	  OpenVersorgungsViews.openView(parameterArt, pidSBA);
			else if (auswahl == PA.QUERSCHNITT)
				OpenViewAuswahlAnzeigeQuerschnitte.openView( parameterArt );
			else if (auswahl == PA.ANZEIGE)
				OpenViewAuswahlAnzeigen.openView( parameterArt );
		}
		
		/*
		 * Auswahldialog ffnen
		 */
		else
		{
	    OpenViewAuswahlParameter.openView(parameterArt, auswahl);
		}
  }
}
