package de.bsvrz.sba.plugin.parameter.steuerungskern.dialog;

import java.util.ArrayList;
import java.util.List;

import de.bsvrz.sba.plugin.parameter.steuerungskern.konfig.VerwaltungWvzInhalte;

/**
 * Klasse definiert alle im System bentigten Anzeigeinhalte auf Basis der Bildinhalte der WvzInhalte
 * @author ObertM
 *
 */
public class AnzeigeInhaltTyp
{
	/**
	 * Liste mit allen Typen
	 */
	private static List<AnzeigeInhaltTyp> typen = new ArrayList<AnzeigeInhaltTyp>();

	//-------------------------------------------------------------------------------------
	// Sonderinhalte
	//-------------------------------------------------------------------------------------
	
	public static AnzeigeInhaltTyp INAKTIV           = new AnzeigeInhaltTyp("Inaktiv");
	public static AnzeigeInhaltTyp DONT_CARE         = new AnzeigeInhaltTyp("DontCare");
	public static AnzeigeInhaltTyp BELIEBIG          = new AnzeigeInhaltTyp("Beliebig");
	public static AnzeigeInhaltTyp BEIBEHALTEN       = new AnzeigeInhaltTyp("Beibehalten");

	//-------------------------------------------------------------------------------------
	// "normale" Inhalte
	//-------------------------------------------------------------------------------------

	public static AnzeigeInhaltTyp DUNKEL            = new AnzeigeInhaltTyp("Dunkel");
	public static AnzeigeInhaltTyp DUNKEL_STAU       = new AnzeigeInhaltTyp("TLS.DunkelStau");
	public static AnzeigeInhaltTyp DUNKEL_HP         = new AnzeigeInhaltTyp("DunkelHP");
	
	public static AnzeigeInhaltTyp TLS_GELBES_BLINKLICHT            = new AnzeigeInhaltTyp("TLS.GelbesBlinklicht");
	public static AnzeigeInhaltTyp TLS_GELBES_BLINKLICHT_SYNCHRON   = new AnzeigeInhaltTyp("TLS.GelbesBlinklichtSynchron");
	public static AnzeigeInhaltTyp TLS_GELBES_BLINKLICHT_ASYNCHRON  = new AnzeigeInhaltTyp("TLS.GelbesBlinklichtAsynchron");

	public static AnzeigeInhaltTyp TLS_500M          = new AnzeigeInhaltTyp("TLS.500Meter");
	public static AnzeigeInhaltTyp TLS_1000M         = new AnzeigeInhaltTyp("TLS.1000Meter");
	public static AnzeigeInhaltTyp TLS_1500M         = new AnzeigeInhaltTyp("TLS.1500Meter");
	public static AnzeigeInhaltTyp TLS_2000M         = new AnzeigeInhaltTyp("TLS.2000Meter");
	public static AnzeigeInhaltTyp TLS_2500M         = new AnzeigeInhaltTyp("TLS.2500Meter");
	public static AnzeigeInhaltTyp TLS_3000M         = new AnzeigeInhaltTyp("TLS.3000Meter");
	
	public static AnzeigeInhaltTyp TLS_1KM           = new AnzeigeInhaltTyp("TLS.1Kilometer");
	public static AnzeigeInhaltTyp TLS_1KOMMA5KM     = new AnzeigeInhaltTyp("TLS.1Komma5Kilometer");
	public static AnzeigeInhaltTyp TLS_2KM           = new AnzeigeInhaltTyp("TLS.2Kilometer");
	public static AnzeigeInhaltTyp TLS_2KOMMA5KM     = new AnzeigeInhaltTyp("TLS.2Komma5Kilometer");
	public static AnzeigeInhaltTyp TLS_3KM           = new AnzeigeInhaltTyp("TLS.3Kilometer");

	public static AnzeigeInhaltTyp TLS_AUF_500M      = new AnzeigeInhaltTyp("TLS.Auf500Meter");
	public static AnzeigeInhaltTyp TLS_AUF_1000M     = new AnzeigeInhaltTyp("TLS.Auf1000Meter");
	public static AnzeigeInhaltTyp TLS_AUF_1500M     = new AnzeigeInhaltTyp("TLS.Auf1500Meter");
	public static AnzeigeInhaltTyp TLS_AUF_2000M     = new AnzeigeInhaltTyp("TLS.Auf2000Meter");
	public static AnzeigeInhaltTyp TLS_AUF_2500M     = new AnzeigeInhaltTyp("TLS.Auf2500Meter");

	public static AnzeigeInhaltTyp TLS_7KOMMA5TONNEN = new AnzeigeInhaltTyp("TLS.7Komma5Tonnen");
	public static AnzeigeInhaltTyp TLS_GLAETTE       = new AnzeigeInhaltTyp("TLS.-asGlaette");

	public static AnzeigeInhaltTyp TLS_BAUSTELLE                     = new AnzeigeInhaltTyp("TLS.Baustelle");
	public static AnzeigeInhaltTyp TLS_ENDE_ALLER_STRECKENVERBOTE    = new AnzeigeInhaltTyp("TLS.EndeAllerStreckenverbote");
	public static AnzeigeInhaltTyp TLS_UEBERHOLVERBOT_ALLGEMEIN      = new AnzeigeInhaltTyp("TLS.UeberholverbotAllgemein");
	public static AnzeigeInhaltTyp TLS_UEBERHOLVERBOT_LKW            = new AnzeigeInhaltTyp("TLS.UeberholverbotLkw");
	public static AnzeigeInhaltTyp TLS_ENDE_UEBERHOLVERBOT_ALLGEMEIN = new AnzeigeInhaltTyp("TLS.EndeUeberholverbotAllgemein");
	public static AnzeigeInhaltTyp TLS_ENDE_UEBERHOLVERBOT_LKW       = new AnzeigeInhaltTyp("TLS.EndeUeberholverbotLkw");
	
	public static AnzeigeInhaltTyp TLS_ENDE_ZULAESSIGE_HOECHST_40  = new AnzeigeInhaltTyp("TLS.EndeZulaessigeHoechst40");
	public static AnzeigeInhaltTyp TLS_ENDE_ZULAESSIGE_HOECHST_50  = new AnzeigeInhaltTyp("TLS.EndeZulaessigeHoechst50");
	public static AnzeigeInhaltTyp TLS_ENDE_ZULAESSIGE_HOECHST_60  = new AnzeigeInhaltTyp("TLS.EndeZulaessigeHoechst60");
	public static AnzeigeInhaltTyp TLS_ENDE_ZULAESSIGE_HOECHST_80  = new AnzeigeInhaltTyp("TLS.EndeZulaessigeHoechst80");
	public static AnzeigeInhaltTyp TLS_ENDE_ZULAESSIGE_HOECHST_100 = new AnzeigeInhaltTyp("TLS.EndeZulaessigeHoechst100");
	public static AnzeigeInhaltTyp TLS_ENDE_ZULAESSIGE_HOECHST_120 = new AnzeigeInhaltTyp("TLS.EndeZulaessigeHoechst120");
	public static AnzeigeInhaltTyp TLS_ENDE_ZULAESSIGE_HOECHST_130 = new AnzeigeInhaltTyp("TLS.EndeZulaessigeHoechst130");

	public static AnzeigeInhaltTyp TLS_ZULAESSIGE_HOECHST_40  = new AnzeigeInhaltTyp("TLS.ZulaessigeHoechst40");
	public static AnzeigeInhaltTyp TLS_ZULAESSIGE_HOECHST_50  = new AnzeigeInhaltTyp("TLS.ZulaessigeHoechst50");
	public static AnzeigeInhaltTyp TLS_ZULAESSIGE_HOECHST_60  = new AnzeigeInhaltTyp("TLS.ZulaessigeHoechst60");
	public static AnzeigeInhaltTyp TLS_ZULAESSIGE_HOECHST_80  = new AnzeigeInhaltTyp("TLS.ZulaessigeHoechst80");
	public static AnzeigeInhaltTyp TLS_ZULAESSIGE_HOECHST_100 = new AnzeigeInhaltTyp("TLS.ZulaessigeHoechst100");
	public static AnzeigeInhaltTyp TLS_ZULAESSIGE_HOECHST_120 = new AnzeigeInhaltTyp("TLS.ZulaessigeHoechst120");
	public static AnzeigeInhaltTyp TLS_ZULAESSIGE_HOECHST_130 = new AnzeigeInhaltTyp("TLS.ZulaessigeHoechst130");
	
	public static AnzeigeInhaltTyp TLS_FAHRSTREIFEN_GESPERRT             = new AnzeigeInhaltTyp("TLS.FahrstreifenGesperrt");
	public static AnzeigeInhaltTyp TLS_FAHRSTREIFEN_WECHSELN_NACH_LINKS  = new AnzeigeInhaltTyp("TLS.FahrstreifenWechselnNachLinks");
	public static AnzeigeInhaltTyp TLS_FAHRSTREIFEN_WECHSELN_NACH_RECHTS = new AnzeigeInhaltTyp("TLS.FahrstreifenWechselnNachRechts");
	public static AnzeigeInhaltTyp TLS_FAHRSTREIFEN_HALTEN               = new AnzeigeInhaltTyp("TLS.FahrstreifenHalten");

	public static AnzeigeInhaltTyp TLS_GEFAHRENSTELLE  = new AnzeigeInhaltTyp("TLS.Gefahrenstelle");
	public static AnzeigeInhaltTyp TLS_GLAETTEGEFAHR   = new AnzeigeInhaltTyp("TLS.Glaettegefahr");
	public static AnzeigeInhaltTyp TLS_NAESSE          = new AnzeigeInhaltTyp("TLS.Naesse");
	public static AnzeigeInhaltTyp TLS_NEBEL           = new AnzeigeInhaltTyp("TLS.Nebel");
	public static AnzeigeInhaltTyp TLS_SCHLEUDERGEFAHR = new AnzeigeInhaltTyp("TLS.Schleudergefahr");
	public static AnzeigeInhaltTyp TLS_SICHT           = new AnzeigeInhaltTyp("TLS.Sicht");
	public static AnzeigeInhaltTyp TLS_STAU            = new AnzeigeInhaltTyp("TLS.Stau");
	public static AnzeigeInhaltTyp TLS_STAUGEFAHR      = new AnzeigeInhaltTyp("TLS.Staugefahr");
	public static AnzeigeInhaltTyp TLS_UNFALL          = new AnzeigeInhaltTyp("TLS.Unfall");
	public static AnzeigeInhaltTyp TLS_SMOG            = new AnzeigeInhaltTyp("TLS.Smog");

	public static AnzeigeInhaltTyp TLS_TIERE     = new AnzeigeInhaltTyp("TLS.Tiere");
	public static AnzeigeInhaltTyp TLS_KONTROLLE = new AnzeigeInhaltTyp("TLS.Kontrolle");
	public static AnzeigeInhaltTyp TLS_OELSPUR   = new AnzeigeInhaltTyp("TLS.Oelspur");

	/*
	 * BAQ
	 */
	public static AnzeigeInhaltTyp BAQ_BA_LKW      = new AnzeigeInhaltTyp("TLS.BlockabfertigungLkw");
	public static AnzeigeInhaltTyp BAQ_BA_LKW_STOP = new AnzeigeInhaltTyp("TLS.BlockabfertigungLkwStop");

	/*
	 * TAQ
	 */
	public static AnzeigeInhaltTyp TAQ_NEUTRAL         = new AnzeigeInhaltTyp("TLS.Neutral");
	public static AnzeigeInhaltTyp TAQ_NEUTRAL_S3      = new AnzeigeInhaltTyp("TLS.Unbeklebt");
	public static AnzeigeInhaltTyp TAQ_BEFAHREN        = new AnzeigeInhaltTyp("TLS.SeitenstreifenBefahren");
	public static AnzeigeInhaltTyp TAQ_NICHT_BEFAHREN  = new AnzeigeInhaltTyp("TLS.SeitenstreifenNichtBefahren");
	public static AnzeigeInhaltTyp TAQ_RAEUMEN         = new AnzeigeInhaltTyp("TLS.SeitenstreifenRaeumen");
	
	/*
	 * WAQ
	 */
	public static AnzeigeInhaltTyp WAQ_SEITE_1       = new AnzeigeInhaltTyp("TLS.PrismaSeite1");
	public static AnzeigeInhaltTyp WAQ_SEITE_2       = new AnzeigeInhaltTyp("TLS.PrismaSeite2");
	public static AnzeigeInhaltTyp WAQ_SEITE_3       = new AnzeigeInhaltTyp("TLS.PrismaSeite3");
	public static AnzeigeInhaltTyp WAQ_SEITE_4       = new AnzeigeInhaltTyp("TLS.PrismaSeite4");

	/*
	 * BAG
	 */
	public static AnzeigeInhaltTyp BAG_LKW           = new AnzeigeInhaltTyp("TLS.NurLkwUndKraftomnibus");

	//-------------------------------------------------------------------------------------
	// "invertierte" Inhalte
	//-------------------------------------------------------------------------------------

	public static AnzeigeInhaltTyp NICHT_DUNKEL            = new AnzeigeInhaltTyp("!Dunkel");
	public static AnzeigeInhaltTyp NICHT_DUNKEL_STAU       = new AnzeigeInhaltTyp("!TLS.DunkelStau");
	public static AnzeigeInhaltTyp NICHT_DUNKEL_HP         = new AnzeigeInhaltTyp("!DunkelHP");
	
	public static AnzeigeInhaltTyp NICHT_TLS_GELBES_BLINKLICHT            = new AnzeigeInhaltTyp("!TLS.GelbesBlinklicht");
	public static AnzeigeInhaltTyp NICHT_TLS_GELBES_BLINKLICHT_SYNCHRON   = new AnzeigeInhaltTyp("!TLS.GelbesBlinklichtSynchron");
	public static AnzeigeInhaltTyp NICHT_TLS_GELBES_BLINKLICHT_ASYNCHRON  = new AnzeigeInhaltTyp("!TLS.GelbesBlinklichtAsynchron");

	public static AnzeigeInhaltTyp NICHT_TLS_500M          = new AnzeigeInhaltTyp("!TLS.500Meter");
	public static AnzeigeInhaltTyp NICHT_TLS_1000M         = new AnzeigeInhaltTyp("!TLS.1000Meter");
	public static AnzeigeInhaltTyp NICHT_TLS_1500M         = new AnzeigeInhaltTyp("!TLS.1500Meter");
	public static AnzeigeInhaltTyp NICHT_TLS_2000M         = new AnzeigeInhaltTyp("!TLS.2000Meter");
	public static AnzeigeInhaltTyp NICHT_TLS_2500M         = new AnzeigeInhaltTyp("!TLS.2500Meter");
	public static AnzeigeInhaltTyp NICHT_TLS_3000M         = new AnzeigeInhaltTyp("!TLS.3000Meter");
	
	public static AnzeigeInhaltTyp NICHT_TLS_1KM           = new AnzeigeInhaltTyp("!TLS.1Kilometer");
	public static AnzeigeInhaltTyp NICHT_TLS_1KOMMA5KM     = new AnzeigeInhaltTyp("!TLS.1Komma5Kilometer");
	public static AnzeigeInhaltTyp NICHT_TLS_2KM           = new AnzeigeInhaltTyp("!TLS.2Kilometer");
	public static AnzeigeInhaltTyp NICHT_TLS_2KOMMA5KM     = new AnzeigeInhaltTyp("!TLS.2Komma5Kilometer");
	public static AnzeigeInhaltTyp NICHT_TLS_3KM           = new AnzeigeInhaltTyp("!TLS.3Kilometer");

	public static AnzeigeInhaltTyp NICHT_TLS_AUF_500M      = new AnzeigeInhaltTyp("!TLS.Auf500Meter");
	public static AnzeigeInhaltTyp NICHT_TLS_AUF_1000M     = new AnzeigeInhaltTyp("!TLS.Auf1000Meter");
	public static AnzeigeInhaltTyp NICHT_TLS_AUF_1500M     = new AnzeigeInhaltTyp("!TLS.Auf1500Meter");
	public static AnzeigeInhaltTyp NICHT_TLS_AUF_2000M     = new AnzeigeInhaltTyp("!TLS.Auf2000Meter");
	public static AnzeigeInhaltTyp NICHT_TLS_AUF_2500M     = new AnzeigeInhaltTyp("!TLS.Auf2500Meter");

	public static AnzeigeInhaltTyp NICHT_TLS_7KOMMA5TONNEN = new AnzeigeInhaltTyp("!TLS.7Komma5Tonnen");
	public static AnzeigeInhaltTyp NICHT_TLS_GLAETTE       = new AnzeigeInhaltTyp("!TLS.-asGlaette");

	public static AnzeigeInhaltTyp NICHT_TLS_BAUSTELLE                     = new AnzeigeInhaltTyp("!TLS.Baustelle");
	public static AnzeigeInhaltTyp NICHT_TLS_ENDE_ALLER_STRECKENVERBOTE    = new AnzeigeInhaltTyp("!TLS.EndeAllerStreckenverbote");
	public static AnzeigeInhaltTyp NICHT_TLS_UEBERHOLVERBOT_ALLGEMEIN      = new AnzeigeInhaltTyp("!TLS.UeberholverbotAllgemein");
	public static AnzeigeInhaltTyp NICHT_TLS_UEBERHOLVERBOT_LKW            = new AnzeigeInhaltTyp("!TLS.UeberholverbotLkw");
	public static AnzeigeInhaltTyp NICHT_TLS_ENDE_UEBERHOLVERBOT_ALLGEMEIN = new AnzeigeInhaltTyp("!TLS.EndeUeberholverbotAllgemein");
	public static AnzeigeInhaltTyp NICHT_TLS_ENDE_UEBERHOLVERBOT_LKW       = new AnzeigeInhaltTyp("!TLS.EndeUeberholverbotLkw");
	
	public static AnzeigeInhaltTyp NICHT_TLS_ENDE_ZULAESSIGE_HOECHST_40  = new AnzeigeInhaltTyp("!TLS.EndeZulaessigeHoechst40");
	public static AnzeigeInhaltTyp NICHT_TLS_ENDE_ZULAESSIGE_HOECHST_50  = new AnzeigeInhaltTyp("!TLS.EndeZulaessigeHoechst50");
	public static AnzeigeInhaltTyp NICHT_TLS_ENDE_ZULAESSIGE_HOECHST_60  = new AnzeigeInhaltTyp("!TLS.EndeZulaessigeHoechst60");
	public static AnzeigeInhaltTyp NICHT_TLS_ENDE_ZULAESSIGE_HOECHST_80  = new AnzeigeInhaltTyp("!TLS.EndeZulaessigeHoechst80");
	public static AnzeigeInhaltTyp NICHT_TLS_ENDE_ZULAESSIGE_HOECHST_100 = new AnzeigeInhaltTyp("!TLS.EndeZulaessigeHoechst100");
	public static AnzeigeInhaltTyp NICHT_TLS_ENDE_ZULAESSIGE_HOECHST_120 = new AnzeigeInhaltTyp("!TLS.EndeZulaessigeHoechst120");
	public static AnzeigeInhaltTyp NICHT_TLS_ENDE_ZULAESSIGE_HOECHST_130 = new AnzeigeInhaltTyp("!TLS.EndeZulaessigeHoechst130");

	public static AnzeigeInhaltTyp NICHT_TLS_ZULAESSIGE_HOECHST_40  = new AnzeigeInhaltTyp("!TLS.ZulaessigeHoechst40");
	public static AnzeigeInhaltTyp NICHT_TLS_ZULAESSIGE_HOECHST_50  = new AnzeigeInhaltTyp("!TLS.ZulaessigeHoechst50");
	public static AnzeigeInhaltTyp NICHT_TLS_ZULAESSIGE_HOECHST_60  = new AnzeigeInhaltTyp("!TLS.ZulaessigeHoechst60");
	public static AnzeigeInhaltTyp NICHT_TLS_ZULAESSIGE_HOECHST_80  = new AnzeigeInhaltTyp("!TLS.ZulaessigeHoechst80");
	public static AnzeigeInhaltTyp NICHT_TLS_ZULAESSIGE_HOECHST_100 = new AnzeigeInhaltTyp("!TLS.ZulaessigeHoechst100");
	public static AnzeigeInhaltTyp NICHT_TLS_ZULAESSIGE_HOECHST_120 = new AnzeigeInhaltTyp("!TLS.ZulaessigeHoechst120");
	public static AnzeigeInhaltTyp NICHT_TLS_ZULAESSIGE_HOECHST_130 = new AnzeigeInhaltTyp("!TLS.ZulaessigeHoechst130");
	
	public static AnzeigeInhaltTyp NICHT_TLS_FAHRSTREIFEN_GESPERRT             = new AnzeigeInhaltTyp("!TLS.FahrstreifenGesperrt");
	public static AnzeigeInhaltTyp NICHT_TLS_FAHRSTREIFEN_WECHSELN_NACH_LINKS  = new AnzeigeInhaltTyp("!TLS.FahrstreifenWechselnNachLinks");
	public static AnzeigeInhaltTyp NICHT_TLS_FAHRSTREIFEN_WECHSELN_NACH_RECHTS = new AnzeigeInhaltTyp("!TLS.FahrstreifenWechselnNachRechts");
	public static AnzeigeInhaltTyp NICHT_TLS_FAHRSTREIFEN_HALTEN               = new AnzeigeInhaltTyp("!TLS.FahrstreifenHalten");

	public static AnzeigeInhaltTyp NICHT_TLS_GEFAHRENSTELLE  = new AnzeigeInhaltTyp("!TLS.Gefahrenstelle");
	public static AnzeigeInhaltTyp NICHT_TLS_GLAETTEGEFAHR   = new AnzeigeInhaltTyp("!TLS.Glaettegefahr");
	public static AnzeigeInhaltTyp NICHT_TLS_NAESSE          = new AnzeigeInhaltTyp("!TLS.Naesse");
	public static AnzeigeInhaltTyp NICHT_TLS_NEBEL           = new AnzeigeInhaltTyp("!TLS.Nebel");
	public static AnzeigeInhaltTyp NICHT_TLS_SCHLEUDERGEFAHR = new AnzeigeInhaltTyp("!TLS.Schleudergefahr");
	public static AnzeigeInhaltTyp NICHT_TLS_SICHT           = new AnzeigeInhaltTyp("!TLS.Sicht");
	public static AnzeigeInhaltTyp NICHT_TLS_STAU            = new AnzeigeInhaltTyp("!TLS.Stau");
	public static AnzeigeInhaltTyp NICHT_TLS_STAUGEFAHR      = new AnzeigeInhaltTyp("!TLS.Staugefahr");
	public static AnzeigeInhaltTyp NICHT_TLS_UNFALL          = new AnzeigeInhaltTyp("!TLS.Unfall");
	public static AnzeigeInhaltTyp NICHT_TLS_SMOG            = new AnzeigeInhaltTyp("!TLS.Smog");

	public static AnzeigeInhaltTyp NICHT_TLS_TIERE     = new AnzeigeInhaltTyp("!TLS.Tiere");
	public static AnzeigeInhaltTyp NICHT_TLS_KONTROLLE = new AnzeigeInhaltTyp("!TLS.Kontrolle");
	public static AnzeigeInhaltTyp NICHT_TLS_OELSPUR   = new AnzeigeInhaltTyp("!TLS.Oelspur");

	/*
	 * BAQ
	 */
	public static AnzeigeInhaltTyp NICHT_BAQ_BA_LKW      = new AnzeigeInhaltTyp("!TLS.BlockabfertigungLkw");
	public static AnzeigeInhaltTyp NICHT_BAQ_BA_LKW_STOP = new AnzeigeInhaltTyp("!TLS.BlockabfertigungLkwStop");

	/*
	 * TAQ
	 */
	public static AnzeigeInhaltTyp NICHT_TAQ_NEUTRAL         = new AnzeigeInhaltTyp("!TLS.Neutral");
	public static AnzeigeInhaltTyp NICHT_TAQ_NEUTRAL_S3      = new AnzeigeInhaltTyp("!TLS.Unbeklebt");
	public static AnzeigeInhaltTyp NICHT_TAQ_BEFAHREN        = new AnzeigeInhaltTyp("!TLS.SeitenstreifenBefahren");
	public static AnzeigeInhaltTyp NICHT_TAQ_NICHT_BEFAHREN  = new AnzeigeInhaltTyp("!TLS.SeitenstreifenNichtBefahren");
	public static AnzeigeInhaltTyp NICHT_TAQ_RAEUMEN         = new AnzeigeInhaltTyp("!TLS.SeitenstreifenRaeumen");
	
	/*
	 * WAQ
	 */
	public static AnzeigeInhaltTyp NICHT_WAQ_SEITE_1       = new AnzeigeInhaltTyp("!TLS.PrismaSeite1");
	public static AnzeigeInhaltTyp NICHT_WAQ_SEITE_2       = new AnzeigeInhaltTyp("!TLS.PrismaSeite2");
	public static AnzeigeInhaltTyp NICHT_WAQ_SEITE_3       = new AnzeigeInhaltTyp("!TLS.PrismaSeite3");
	public static AnzeigeInhaltTyp NICHT_WAQ_SEITE_4       = new AnzeigeInhaltTyp("!TLS.PrismaSeite4");

	/*
	 * BAG
	 */
	public static AnzeigeInhaltTyp NICHT_BAG_LKW           = new AnzeigeInhaltTyp("!TLS.NurLkwUndKraftomnibus");
	
  /**
   * Bildinhalt
   */
	private String _bildInhalt;

	private AnzeigeInhaltTyp(String inhalt)
	{
		this._bildInhalt = inhalt;
		typen.add(this);
	}

	/**
	 * Methode liefert den Bildinhalt
	 * @return Bildinhalt
	 */
	public String getBildInhalt()
	{
		return _bildInhalt;
	}

	/**
	 * Methode liefert die Information ob der Anzeigeinhalt negiert ist
	 * @return Ergebnis der Prfung
	 */
	public boolean isNegiert ()
	{
		return getBildInhalt().startsWith("!");
	}
	
	/**
	 * Methode liefert den AnzeigeInhaltTyp zu einem Bildinhalt oder der Pid eines WvzInhalts.
	 * @param inhaltOderPidWvzInhalt Inhalt oder Pid
	 * @return AnzeigeInhaltTyp
	 */
  public static AnzeigeInhaltTyp getTyp (String inhaltOderPidWvzInhalt)
  {
  	/*
  	 * Prfen ob ein Bildinhalt bergeben wurde
  	 */
  	for (AnzeigeInhaltTyp typ : typen)
  		if (typ.getBildInhalt().equals(inhaltOderPidWvzInhalt))
  			return typ;
  		
  	/*
  	 * Prfen ob die Pid eines WVZInhalts bergeben wurde 
  	 */
//  	System.out.println("AnzeigeInhaltTyp.getTyp() ---> " + inhaltOderPidWvzInhalt);
  	
  	AnzeigeInhaltTyp ait = VerwaltungWvzInhalte.getInstance().getAnzeigeInhaltTyp(inhaltOderPidWvzInhalt);
  	
    return ait;
  }
}