package de.bsvrz.sba.plugin.parameter.steuerungskern.parameter.abhaengigkeiten;

import java.util.Observable;
import java.util.Observer;

import org.eclipse.swt.SWT;
import org.eclipse.swt.graphics.Image;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Combo;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Control;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Spinner;

/**
 * Tabellen Modell fr die Parameter Abhngigkeiten
 * @author ObertM
 *
 */
public class TableModel extends Observable implements Observer
{
	/**
	 * Merker zum Lschen der Zeile
	 */
	private Composite _loeschen;
	
  /**
   * Hauptanzeige
   */
  private Composite _hauptAnzeige;
  
  /**
   * Abhngige Anzeige
   */
  private Composite _abhaengigeAnzeige;

  /**
   * Konstruktor der Klasse
   * @param loeschen Lschen
   * @param hauptAnzeige Hauptanzeige
   * @param abhaengigeAnzeige abhngige Anzeige
   */
  public TableModel(Composite loeschen, Composite hauptAnzeige, Composite abhaengigeAnzeige)
  {
  	this._loeschen = loeschen;
  	this._hauptAnzeige = hauptAnzeige;
  	this._abhaengigeAnzeige = abhaengigeAnzeige;
  }

  public String getSelectedLoeschen()
  {
    return getSelectedWert(_loeschen);    
  }

  public void setSelectedLoeschen(String selWert)
  {
    setSelectedWert(_loeschen, selWert, null);
  }

  public String getSelectedHauptAnzeige ()
  {
    return getSelectedWert(_hauptAnzeige);    
  }

  public void setSelectedHauptAnzeige (String selWert)
  {
    setSelectedWert(_hauptAnzeige, selWert, null);
  }
  
  public String getSelectedAbhaenigeAnzeige ()
  {
    return getSelectedWert(_abhaengigeAnzeige);    
  }

  public void setSelectedAbhaenigeAnzeige (String selWert)
  {
    setSelectedWert(_abhaengigeAnzeige, selWert, null);
  }

  public String getSelectedWert(Composite c)
  {
    Control control = c.getChildren()[0];
    if ( control instanceof Spinner )
    {
      Spinner sp = (Spinner)control;
      int spSel = sp.getSelection();
      return String.valueOf(spSel);
    }
    else if ( control instanceof Combo )
    {
      Combo cb = (Combo)control;
      String cbSel = cb.getItem( cb.getSelectionIndex() );
      return cbSel;
    }
    else if ( control instanceof Button )
    {
      if ( (control.getStyle() & SWT.CHECK) != 0 )
      {
        Button ch = (Button)control;
        boolean chSel = ch.getSelection();
        return String.valueOf(chSel);
      }
      else
        return "";
    }
    else if ( control instanceof Label )
    {
      Label im = (Label)control;
      String imSel = (String)im.getData();
      return imSel;
    }
    else
      return "";
  }

  public void setSelectedWert(Composite c, String selWert, Image selImage)
  {
    Control control = c.getChildren()[0];
    if ( control instanceof Spinner )
    {
      Spinner sp = (Spinner)control;
      try
      {
        sp.setSelection(Integer.valueOf( selWert ));
      }
      catch (NumberFormatException e)
      {
        e.printStackTrace();
      }
    }
    else if ( control instanceof Combo )
    {
      Combo cb = (Combo)control;
      for (int k = 0; k < cb.getItemCount(); k++)
      {
        if (selWert.equals(cb.getItem( k )))
          cb.select(k);      
      }
    }
    else if ( control instanceof Button )
    {
      if ( (control.getStyle() & SWT.CHECK) != 0 )
      {
        Button ch = (Button)control;
        ch.setSelection( Boolean.valueOf( selWert ) );
      }
    }
    else if ( control instanceof Label )
    {
        Label im = (Label)control;
        im.setData( selWert );
        im.setImage( selImage ); 
    }
  }

  @Override
  public void update(Observable o, Object arg)
  {
    fireEvent();
  }

  public void fireEvent()
  {
    setChanged();
    notifyObservers();
  }

	/**
   * Methode liefert loeschen zurck
   * @return loeschen
   */
  public Composite getLoeschen()
  {
  	return _loeschen;
  }

	/**
   * Methode setzt die Variable loeschen
   * @param loeschen zu bernehmender Wert fr loeschen
   */
  public void setLoeschen(Composite loeschen)
  {
  	_loeschen = loeschen;
  }

	/**
   * Methode liefert hauptAnzeige zurck
   * @return hauptAnzeige
   */
  public Composite getHauptAnzeige()
  {
  	return _hauptAnzeige;
  }

	/**
   * Methode setzt die Variable hauptAnzeige
   * @param hauptAnzeige zu bernehmender Wert fr hauptAnzeige
   */
  public void setHauptAnzeige(Composite hauptAnzeige)
  {
  	_hauptAnzeige = hauptAnzeige;
  }

	/**
   * Methode liefert abhaengigeAnzeige zurck
   * @return abhaengigeAnzeige
   */
  public Composite getAbhaengigeAnzeige()
  {
  	return _abhaengigeAnzeige;
  }

	/**
   * Methode setzt die Variable abhaengigeAnzeige
   * @param abhaengigeAnzeige zu bernehmender Wert fr abhaengigeAnzeige
   */
  public void setAbhaengigeAnzeige(Composite abhaengigeAnzeige)
  {
  	_abhaengigeAnzeige = abhaengigeAnzeige;
  }
}
