package de.bsvrz.sba.plugin.parameter.steuerungskern.parameter.aufhebungen.aufhebung;

import de.bsvrz.dav.daf.main.config.Aspect;
import de.bsvrz.sba.plugin.parameter.steuerungskern.daten.WVZInhalt;

/**
 * Klasse enthlt eine Regel fr die Regelklasse "Aufhebungen", Regel "Aufhebung".<br>  
 * @author Dambach Werke GmbH
 */
public class RegelAufhebungNeu
{
  /**
   * Regelspezifischer Schaltgrund
   */
  private Aspect m_schaltgrundRegel;
  
  /**
   * Anzeigeninhalt (in der Regel: "X")
   */
  private WVZInhalt m_anzeigenInhalt = new WVZInhalt();
  
  /**
   * Angeforderter Inhalt (in der Regel: "A")
   */
  private WVZInhalt m_angefordeterInhalt = new WVZInhalt();
  
  /**
   * Zeitpunkt t1 (relativer Offset zu t0)
   */
  private long m_t1;
  
  /**
   * Zeitpunkt t2 (relativer Offset zu t0)
   */
  private long m_t2;
  
  /**
   * Parameterloser Konstruktor der Klasse
   */
  public RegelAufhebungNeu ()
  {
  }

  /**
   * Konstruktor der Klasse
   * @param schaltgrund Schaltgrund der Regel
   * @param anzeigenInhalt zu prfender Anzeigeninhalt
   * @param angeforderterInhalt angeforderter Anzeigeninhalt
   * @param t1 Zeitpunkt t1
   * @param t2 Zeitpunkt t2
   */
  public RegelAufhebungNeu (Aspect schaltgrund, WVZInhalt anzeigenInhalt, WVZInhalt angeforderterInhalt, long t1, long t2)
  {
    m_schaltgrundRegel = schaltgrund;
    m_anzeigenInhalt = anzeigenInhalt;
    m_angefordeterInhalt = angeforderterInhalt;
    m_t1 = t1;
    m_t2 = t2;
  }
  
	/**
   * Methode liefert schaltgrundRegel zurck
   * @return schaltgrundRegel
   */
  public Aspect getSchaltgrundRegel()
  {
  	return m_schaltgrundRegel;
  }

	/**
   * Methode setzt die Variable schaltgrundRegel
   * @param schaltgrundRegel zu bernehmender Wert fr schaltgrundRegel
   */
  public void setSchaltgrundRegel(Aspect schaltgrundRegel)
  {
  	m_schaltgrundRegel = schaltgrundRegel;
  }

	/**
   * Methode liefert anzeigenInhalt zurck
   * @return anzeigenInhalt
   */
  public WVZInhalt getAnzeigenInhalt()
  {
  	return m_anzeigenInhalt;
  }

	/**
   * Methode setzt die Variable anzeigenInhalt
   * @param anzeigenInhalt zu bernehmender Wert fr anzeigenInhalt
   */
  public void setAnzeigenInhalt(WVZInhalt anzeigenInhalt)
  {
  	m_anzeigenInhalt = anzeigenInhalt;
  }

	/**
   * Methode liefert angefordeterInhalt zurck
   * @return angefordeterInhalt
   */
  public WVZInhalt getAngefordeterInhalt()
  {
  	return m_angefordeterInhalt;
  }

	/**
   * Methode setzt die Variable angefordeterInhalt
   * @param angefordeterInhalt zu bernehmender Wert fr angefordeterInhalt
   */
  public void setAngefordeterInhalt(WVZInhalt angefordeterInhalt)
  {
  	m_angefordeterInhalt = angefordeterInhalt;
  }

	/**
   * Methode liefert t1 zurck
   * @return t1
   */
  public long getT1()
  {
  	return m_t1;
  }

	/**
   * Methode setzt die Variable t1
   * @param t1 zu bernehmender Wert fr t1
   */
  public void setT1(long t1)
  {
  	m_t1 = t1;
  }

	/**
   * Methode liefert t2 zurck
   * @return t2
   */
  public long getT2()
  {
  	return m_t2;
  }

	/**
   * Methode setzt die Variable t2
   * @param t2 zu bernehmender Wert fr t2
   */
  public void setT2(long t2)
  {
  	m_t2 = t2;
  }

	/* (non-Javadoc)
   * @see java.lang.Object#toString()
   */
  @Override
  public String toString()
  {
  	String s = "";
  	
  	s += "Anzeigeninhalt: ";
  	if (getAnzeigenInhalt() != null)
  		s += getAnzeigenInhalt().toString();
  	else
  		s += "null";
  	s += "\n";
  	
  	s += "Angefordeter Inhalt: ";
  	if (getAngefordeterInhalt() != null)
  		s += getAngefordeterInhalt().toString();
  	else
  		s += "null";
  	s += "\n";
  	
  	s += "T1: " + getT1() + "\n";
  	s += "T2: " + getT2	() + "\n";
  	
	  return super.toString();
  }
  
  
}
