package de.bsvrz.sba.plugin.parameter.steuerungskern.parameter.ausfallbehandlung.ausschaltregel;

import de.bsvrz.dav.daf.main.config.Aspect;
import de.bsvrz.dav.daf.main.config.SystemObject;
import de.bsvrz.sba.plugin.parameter.steuerungskern.daten.WVZInhalt;

/**
 * Klasse enthlt eine Regel fr die Regelklasse "Ausschaltregel", 
 * Regel "Ausschaltregel".<br> 
 * @author Dambach-Werke GmbH
 * @author Matthias Obert
 */
public class RegelAusschaltRegelNeu
{
  /**
   * Regelspezifischer Schaltgrund
   */
  private Aspect m_schaltgrundRegel;
  
  /**
   * Anzeigeninhalt (in der Regel: "X")
   */
  private WVZInhalt m_anzeigenInhalt = new WVZInhalt();

  /**
   * Anzeigetyp der geschaltet werden soll (in der Regel "A")
   */
  private SystemObject m_anzeigeTyp;
  
  /**
   * Angeforderter Inhalt (in Regel "Y")
   */
  private WVZInhalt m_angeforderterInhalt = new WVZInhalt();

  /**
   * Prioritt (in der Regel "Z")
   */
  private int m_prioritaet;


  public RegelAusschaltRegelNeu (WVZInhalt anzeigenInhalt, SystemObject anzeigeTyp, WVZInhalt angefordeterInhalt, int prioritaet, Aspect schaltgrund )
  {
  	m_anzeigenInhalt = anzeigenInhalt;
  	m_anzeigeTyp = anzeigeTyp;
  	m_angeforderterInhalt = angefordeterInhalt;
  	m_prioritaet = prioritaet;
  	m_schaltgrundRegel = schaltgrund;
  }


	/**
   * Methode liefert schaltgrundRegel zurck
   * @return schaltgrundRegel
   */
  public Aspect getSchaltgrundRegel()
  {
  	return m_schaltgrundRegel;
  }


	/**
   * Methode setzt die Variable schaltgrundRegel
   * @param schaltgrundRegel zu bernehmender Wert fr schaltgrundRegel
   */
  public void setSchaltgrundRegel(Aspect schaltgrundRegel)
  {
  	m_schaltgrundRegel = schaltgrundRegel;
  }


	/**
   * Methode liefert anzeigenInhalt zurck
   * @return anzeigenInhalt
   */
  public WVZInhalt getAnzeigenInhalt()
  {
  	return m_anzeigenInhalt;
  }


	/**
   * Methode setzt die Variable anzeigenInhalt
   * @param anzeigenInhalt zu bernehmender Wert fr anzeigenInhalt
   */
  public void setAnzeigenInhalt(WVZInhalt anzeigenInhalt)
  {
  	m_anzeigenInhalt = anzeigenInhalt;
  }


	/**
   * Methode liefert anzeigeTyp zurck
   * @return anzeigeTyp
   */
  public SystemObject getAnzeigeTyp()
  {
  	return m_anzeigeTyp;
  }


	/**
   * Methode setzt die Variable anzeigeTyp
   * @param anzeigeTyp zu bernehmender Wert fr anzeigeTyp
   */
  public void setAnzeigeTyp(SystemObject anzeigeTyp)
  {
  	m_anzeigeTyp = anzeigeTyp;
  }


	/**
   * Methode liefert angeforderterInhalt zurck
   * @return angeforderterInhalt
   */
  public WVZInhalt getAngeforderterInhalt()
  {
  	return m_angeforderterInhalt;
  }


	/**
   * Methode setzt die Variable angeforderterInhalt
   * @param angeforderterInhalt zu bernehmender Wert fr angeforderterInhalt
   */
  public void setAngeforderterInhalt(WVZInhalt angeforderterInhalt)
  {
  	m_angeforderterInhalt = angeforderterInhalt;
  }


	/**
   * Methode liefert prioritaet zurck
   * @return prioritaet
   */
  public int getPrioritaet()
  {
  	return m_prioritaet;
  }


	/**
   * Methode setzt die Variable prioritaet
   * @param prioritaet zu bernehmender Wert fr prioritaet
   */
  public void setPrioritaet(int prioritaet)
  {
  	m_prioritaet = prioritaet;
  }
  
  
}
