package de.bsvrz.sba.plugin.parameter.steuerungskern.parameter.laengsquerabgleich.monotonieKreuzPfeil;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;
import java.util.Vector;

import de.bsvrz.dav.daf.main.config.Aspect;
import de.bsvrz.sba.plugin.parameter.steuerungskern.daten.WVZInhalt;
import de.bsvrz.sba.plugin.parameter.steuerungskern.daten.Richtung.ArbeitsRichtungVN;
import de.bsvrz.sba.plugin.parameter.steuerungskern.dialog.AnzeigeElementFigure;
import de.bsvrz.sba.plugin.parameter.steuerungskern.dialog.AnzeigeInhaltTyp;
import de.bsvrz.sba.plugin.parameter.steuerungskern.konfig.VerwaltungWvzInhalte;
import de.bsvrz.sba.plugin.parameter.steuerungskern.projektspezifischeEinstellungen.AnzeigeElementTyp;

/**
 * Klasse zum Erzeugen der Defaultwerte fr die Regel "Monotonie Kreuz/Pfeil"
 * @author ObertM
 *
 */
public class DefaultWerte
{
	/**
   * Methode generiert automatisch die Defaultwerte
   */
  public Vector<RegelMonotonieKreuzPfeil> getDefaultWerte (int anzBilderProZeile)
  {
  	List<AnzeigeInhaltTyp> geschwindigkeiten = Arrays.asList(
  				AnzeigeInhaltTyp.TLS_ZULAESSIGE_HOECHST_40,
  				AnzeigeInhaltTyp.TLS_ZULAESSIGE_HOECHST_50,
  				AnzeigeInhaltTyp.TLS_ZULAESSIGE_HOECHST_60,
  				AnzeigeInhaltTyp.TLS_ZULAESSIGE_HOECHST_80,
  				AnzeigeInhaltTyp.TLS_ZULAESSIGE_HOECHST_100,
  				AnzeigeInhaltTyp.TLS_ZULAESSIGE_HOECHST_120,
  				AnzeigeInhaltTyp.TLS_ZULAESSIGE_HOECHST_130);

  	List<AnzeigeInhaltTyp> sperrung = Arrays.asList(
  				AnzeigeInhaltTyp.TLS_FAHRSTREIFEN_GESPERRT,
  				AnzeigeInhaltTyp.TLS_FAHRSTREIFEN_WECHSELN_NACH_RECHTS);

  	List<WVZInhalt> aitX = new ArrayList<WVZInhalt>();
  	List<WVZInhalt> aitY = new ArrayList<WVZInhalt>();
  	List<WVZInhalt> aitZ = new ArrayList<WVZInhalt>();

	  VerwaltungWvzInhalte verw = VerwaltungWvzInhalte.getInstance();
  	
  	List<AnzeigeInhaltTyp> vorhanden = AnzeigeElementFigure.createAnzeigeInhalte(AnzeigeElementTyp.WZG_A);

  	for (AnzeigeInhaltTyp ait : geschwindigkeiten)
  		if (vorhanden.contains(ait))
  			aitX.add(verw.getWvzInhalt(AnzeigeElementTyp.WZG_A, ait ));

  	for (AnzeigeInhaltTyp ait : sperrung)
  		if (vorhanden.contains(ait))
  			aitY.add(verw.getWvzInhalt(AnzeigeElementTyp.WZG_A, ait ));

  	for (AnzeigeInhaltTyp ait : geschwindigkeiten)
  		if (vorhanden.contains(ait))
  			aitZ.add(verw.getWvzInhalt(AnzeigeElementTyp.WZG_A, ait ));

		Vector<RegelMonotonieKreuzPfeil> regeln = new Vector<RegelMonotonieKreuzPfeil>();
		
		RegelMonotonieKreuzPfeil r = new RegelMonotonieKreuzPfeil();
		
  	Aspect schaltgrund = VerwaltungParaMonotonieKreuzPfeil.getInstance().getSchaltgrundAllgemein();

  	r.setSchaltgrundRegel(schaltgrund);
		r.setRichtungLaengs(ArbeitsRichtungVN.NACHFOLGER);
		r.setRichtungQuer(ArbeitsRichtungVN.NACHFOLGER);
		r.setAnzeigenInhalt(aitX);
		r.setAnzeigenInhaltVorgaengerNachfolgerLaengs(aitY);
		r.setAnzeigenInhaltVorgaengerNachfolgerQuer(aitZ);
		
		regeln.add(r);
		
		return regeln;
  }
}
