package de.bsvrz.sba.plugin.parameter.steuerungskern.parameter.laengsquerabgleich.trichterung;

import java.util.List;
import java.util.Vector;

import de.bsvrz.dav.daf.main.config.Aspect;
import de.bsvrz.sba.plugin.parameter.steuerungskern.daten.Richtung;
import de.bsvrz.sba.plugin.parameter.steuerungskern.daten.WVZInhalt;
import de.bsvrz.sba.plugin.parameter.steuerungskern.daten.Richtung.ArbeitsRichtungVN;
import de.bsvrz.sba.plugin.parameter.steuerungskern.dialog.AnzeigeElementFigure;
import de.bsvrz.sba.plugin.parameter.steuerungskern.dialog.AnzeigeInhaltTyp;
import de.bsvrz.sba.plugin.parameter.steuerungskern.konfig.VerwaltungWvzInhalte;
import de.bsvrz.sba.plugin.parameter.steuerungskern.projektspezifischeEinstellungen.AnzeigeElementTyp;

public class DefaultWerte
{
  /**
   * Methode generiert automatisch alle Regeln fr eine 20km/h Geschwindigkeitsdiffernze
   */
  public Vector<RegelTrichterung> getRegelnGeschwDiff20 ()
  {
  	AnzeigeInhaltTyp km40    = AnzeigeInhaltTyp.TLS_ZULAESSIGE_HOECHST_40;
  	AnzeigeInhaltTyp km50    = AnzeigeInhaltTyp.TLS_ZULAESSIGE_HOECHST_50;
  	AnzeigeInhaltTyp km60    = AnzeigeInhaltTyp.TLS_ZULAESSIGE_HOECHST_60;
  	AnzeigeInhaltTyp km80    = AnzeigeInhaltTyp.TLS_ZULAESSIGE_HOECHST_80;
  	AnzeigeInhaltTyp km100   = AnzeigeInhaltTyp.TLS_ZULAESSIGE_HOECHST_100;
  	AnzeigeInhaltTyp km120   = AnzeigeInhaltTyp.TLS_ZULAESSIGE_HOECHST_120;
  	AnzeigeInhaltTyp km130   = AnzeigeInhaltTyp.TLS_ZULAESSIGE_HOECHST_130;

  	AnzeigeInhaltTyp kreuz   = AnzeigeInhaltTyp.TLS_FAHRSTREIFEN_GESPERRT;
  	AnzeigeInhaltTyp pfl     = AnzeigeInhaltTyp.TLS_FAHRSTREIFEN_WECHSELN_NACH_LINKS;
  	AnzeigeInhaltTyp pfr     = AnzeigeInhaltTyp.TLS_FAHRSTREIFEN_WECHSELN_NACH_RECHTS;
  	AnzeigeInhaltTyp stau    = AnzeigeInhaltTyp.TLS_STAU;

		Vector<RegelTrichterung> regeln = new Vector<RegelTrichterung>();
	  
	  List<AnzeigeInhaltTyp> moeglicheBilder = AnzeigeElementFigure.createAnzeigeInhalte(AnzeigeElementTyp.WZG_A);

	  /*
	   * 40 km/h
	   */
	  moeglicheBilder.remove(kreuz);
	  moeglicheBilder.remove(pfl);
	  moeglicheBilder.remove(pfr);
	  moeglicheBilder.remove(stau);
	  
	  moeglicheBilder.remove(km40);
	  moeglicheBilder.remove(km50);
	  moeglicheBilder.remove(km60);

	  regeln.addAll( erzeugeRegeln (moeglicheBilder, km40, km60));

	  /*
	   * 50 km/h
	   */
	  moeglicheBilder.remove(km60);
	  regeln.addAll( erzeugeRegeln (moeglicheBilder, km50, km60));

	  /*
	   * 60 km/h
	   */
	  moeglicheBilder.remove(km80);
	  regeln.addAll( erzeugeRegeln (moeglicheBilder, km60, km80));

	  /*
	   * 80 km/h
	   */
	  moeglicheBilder.remove(km100);
	  regeln.addAll( erzeugeRegeln (moeglicheBilder, km80, km100));

	  /*
	   * 100 km/h
	   */
	  moeglicheBilder.remove(km120);
	  regeln.addAll( erzeugeRegeln (moeglicheBilder, km100, km120));

	  return regeln;
  }

  /**
   * Methode generiert automatisch alle Regeln fr eine 40km/h Geschwindigkeitsdiffernze
   */
  public Vector<RegelTrichterung> getRegelnGeschwDiff40 ()
  {
  	AnzeigeInhaltTyp km40    = AnzeigeInhaltTyp.TLS_ZULAESSIGE_HOECHST_40;
  	AnzeigeInhaltTyp km50    = AnzeigeInhaltTyp.TLS_ZULAESSIGE_HOECHST_50;
  	AnzeigeInhaltTyp km60    = AnzeigeInhaltTyp.TLS_ZULAESSIGE_HOECHST_60;
  	AnzeigeInhaltTyp km80    = AnzeigeInhaltTyp.TLS_ZULAESSIGE_HOECHST_80;
  	AnzeigeInhaltTyp km100   = AnzeigeInhaltTyp.TLS_ZULAESSIGE_HOECHST_100;
  	AnzeigeInhaltTyp km120   = AnzeigeInhaltTyp.TLS_ZULAESSIGE_HOECHST_120;
  	AnzeigeInhaltTyp km130   = AnzeigeInhaltTyp.TLS_ZULAESSIGE_HOECHST_130;

  	AnzeigeInhaltTyp kreuz   = AnzeigeInhaltTyp.TLS_FAHRSTREIFEN_GESPERRT;
  	AnzeigeInhaltTyp pfl     = AnzeigeInhaltTyp.TLS_FAHRSTREIFEN_WECHSELN_NACH_LINKS;
  	AnzeigeInhaltTyp pfr     = AnzeigeInhaltTyp.TLS_FAHRSTREIFEN_WECHSELN_NACH_RECHTS;
  	AnzeigeInhaltTyp stau    = AnzeigeInhaltTyp.TLS_STAU;


		Vector<RegelTrichterung> regeln = new Vector<RegelTrichterung>();
	  
	  List<AnzeigeInhaltTyp> moeglicheBilder = AnzeigeElementFigure.createAnzeigeInhalte(AnzeigeElementTyp.WZG_A);
	  /*
	   * 40 km/h
	   */
	  moeglicheBilder.remove(kreuz);
	  moeglicheBilder.remove(pfl);
	  moeglicheBilder.remove(pfr);
	  moeglicheBilder.remove(stau);
	  
	  moeglicheBilder.remove(km40);
	  moeglicheBilder.remove(km50);
	  moeglicheBilder.remove(km60);
	  moeglicheBilder.remove(km80);

	  regeln.addAll( erzeugeRegeln (moeglicheBilder, km40, km80));

	  /*
	   * 50 km/h
	   */
	  regeln.addAll( erzeugeRegeln (moeglicheBilder, km50, km80));

	  /*
	   * 60 km/h
	   */
	  moeglicheBilder.remove(km100);
	  regeln.addAll( erzeugeRegeln (moeglicheBilder, km60, km100));

	  /*
	   * 80 km/h
	   */
	  moeglicheBilder.remove(km120);
	  regeln.addAll( erzeugeRegeln (moeglicheBilder, km80, km120));

	  return regeln;
  }

  private Vector<RegelTrichterung> erzeugeRegeln(
      List<AnzeigeInhaltTyp> moeglicheBilder, AnzeigeInhaltTyp x,
      AnzeigeInhaltTyp z)
  {
  	Aspect schaltgrund = VerwaltungParaTrichterung.getInstance().getSchaltgrundAllgemein();
  	ArbeitsRichtungVN richtung = Richtung.ArbeitsRichtungVN.VORGAENGER;

	  Vector<RegelTrichterung> regeln = new Vector<RegelTrichterung>();
	  
    VerwaltungWvzInhalte verw = VerwaltungWvzInhalte.getInstance();
	  for (AnzeigeInhaltTyp ait : moeglicheBilder)
	  {
	    WVZInhalt x1 = verw.getWvzInhalt (AnzeigeElementTyp.WZG_A, x.getBildInhalt());
	    WVZInhalt y1 = verw.getWvzInhalt (AnzeigeElementTyp.WZG_A, ait.getBildInhalt());
	    WVZInhalt z1 = verw.getWvzInhalt (AnzeigeElementTyp.WZG_A, z.getBildInhalt());

	    if (x1 != null && y1 != null && z1 != null)
	    {
    	  RegelTrichterung r = new RegelTrichterung(schaltgrund, richtung, x1, y1, z1);
    	  regeln.add(r);
	    }
	  }
	  
	  return regeln;
  }

}
