package de.bsvrz.sba.plugin.parameter.steuerungskern.parameter.laengsquerabgleich.zusammenfassungEnde;

import java.util.List;
import java.util.Vector;

import de.bsvrz.buv.rw.rw.dav.DaVVerbindung;
import de.bsvrz.dav.daf.main.Data.Array;
import de.bsvrz.dav.daf.main.config.Aspect;
import de.bsvrz.dav.daf.main.config.SystemObject;
import de.bsvrz.sba.plugin.parameter.steuerungskern.daten.WVZInhalt;
import de.bsvrz.sba.plugin.parameter.steuerungskern.projektspezifischeEinstellungen.AnzeigeElementTyp;

public class ListeMitRegeln
{
  /**
   * Liste mit den Parametern
   */
  private Vector<RegelZusammenfassungEnde> m_parameter = new Vector<RegelZusammenfassungEnde>();

  /**
   * Parameterloser Konstruktor der Klasse
   */
  public ListeMitRegeln()
  {
  }

  /**
   * Methode zum Lschen der Parameter
   */
  public void clear()
  {
    m_parameter.clear();
  }

//  /**
//   * Methode fgt eine Regel hinzu
//   * @param anzeigeTypA
//   * @param anzeigeTypB
//   * @param prioA
//   * @param prioB
//   * @param inhalteA
//   * @param inhalteB
//   * @param angeforderterInhaltA
//   * @param angeforderterInhaltB
//   * @param schaltgrund
//   */
//  public void addRegel( SystemObject anzeigeTypA, SystemObject anzeigeTypB, int prioA, int prioB,
//      List<WVZInhalt> inhalteA, List<WVZInhalt> inhalteB, WVZInhalt angeforderterInhaltA,
//      WVZInhalt angeforderterInhaltB, Aspect schaltgrund )
//  {
//    RegelZusammenfassungEnde r = new RegelZusammenfassungEnde();
//
//    r.setSchaltgrundRegel( schaltgrund );
////    r.setAnzeigeTypA( anzeigeTypA );
////    r.setAnzeigeTypB( anzeigeTypB );
//    r.setPrioritaetA( prioA );
//    r.setPrioritaetB( prioB );
//    r.setAnzeigenInhaltA( inhalteA );
//    r.setAnzeigenInhaltB( inhalteB );
//    r.setAngeforderterInhaltA( angeforderterInhaltA );
//    r.setAngeforderterInhaltB( angeforderterInhaltB );
//
//    addRegel( r );
//  }

  /**
   * Methode fgt eine Regel hinzu
   * @param prioA
   * @param prioB
   * @param inhalteA
   * @param inhalteB
   * @param angeforderterInhaltA
   * @param angeforderterInhaltB
   * @param schaltgrund
   */
  public void addRegel( int prioA, int prioB,
      List<WVZInhalt> inhalteA, List<WVZInhalt> inhalteB, WVZInhalt angeforderterInhaltA,
      WVZInhalt angeforderterInhaltB, Aspect schaltgrund )
  {
    RegelZusammenfassungEnde r = new RegelZusammenfassungEnde();

    r.setSchaltgrundRegel( schaltgrund );
    r.setPrioritaetA( prioA );
    r.setPrioritaetB( prioB );
    r.setAnzeigenInhaltA( inhalteA );
    r.setAnzeigenInhaltB( inhalteB );
    r.setAngeforderterInhaltA( angeforderterInhaltA );
    r.setAngeforderterInhaltB( angeforderterInhaltB );

    addRegel( r );
  }

  public void addRegel( RegelZusammenfassungEnde r )
  {
    synchronized (m_parameter)
    {
      m_parameter.add( r );
    }
  }

  /**
   * Methode liefert die Variable parameter zurck
   * 
   * @return Variable parameter
   */
  public Vector<RegelZusammenfassungEnde> getParameter()
  {
    Vector<RegelZusammenfassungEnde> v = new Vector<RegelZusammenfassungEnde>();
    synchronized (m_parameter)
    {
      for (RegelZusammenfassungEnde r : m_parameter)
        v.add( r );
    }
    return v;
  }

  /**
   * Methode zum Auswerten der Regeln der Attributliste
   * 'atl.sswSbaRegelZusammenfassungAufhebung'
   * 
   * @param a
   *          Daten vom DaV
   * @param schaltgrundAllgemein
   * 					Schaltgrund
   */
  public void auswerteAttributgruppe( Array a, Aspect schaltgrundAllgemein)
  {
    int anzahl = a.getLength();

    synchronized (m_parameter)
    {
      m_parameter.clear();
      for (int x = 0; x < anzahl; ++x)
      {
        RegelZusammenfassungEnde r = new RegelZusammenfassungEnde();
        r.auswerteAttributgruppe( a.getItem( x ), schaltgrundAllgemein );

        m_parameter.add( r );
      }
    }
  }

  /**
   * Methode liefert den Inahlt der Klasse als String
   */
  public String toString()
  {
    String s = "";

    synchronized (m_parameter)
    {
      s += "Regeln:\n";
      for (RegelZusammenfassungEnde r : m_parameter)
        s += r.toString() + "\n";
    }

    return s;
  }

	public void setParameter(Vector<RegelZusammenfassungEnde> regeln)
  {
		synchronized (m_parameter)
    {
	    m_parameter.clear();
	    m_parameter.addAll(regeln);
    }
  }
}
