package de.bsvrz.sba.plugin.parameter.steuerungskern.parameter.verriegelung.spezielleVerriegelungsMatrix;

import java.util.ArrayList;
import java.util.List;
import java.util.Observable;
import java.util.Observer;
import java.util.Vector;

import org.eclipse.jface.viewers.CellLabelProvider;
import org.eclipse.jface.viewers.IStructuredContentProvider;
import org.eclipse.jface.viewers.TableViewer;
import org.eclipse.jface.viewers.TableViewerColumn;
import org.eclipse.jface.viewers.Viewer;
import org.eclipse.jface.viewers.ViewerCell;
import org.eclipse.swt.SWT;
import org.eclipse.swt.custom.TableEditor;
import org.eclipse.swt.events.MouseAdapter;
import org.eclipse.swt.events.MouseEvent;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.events.SelectionListener;
import org.eclipse.swt.layout.FillLayout;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.layout.RowLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Combo;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Event;
import org.eclipse.swt.widgets.Group;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Listener;
import org.eclipse.swt.widgets.Table;
import org.eclipse.swt.widgets.TableItem;

import de.bsvrz.dav.daf.main.config.Aspect;
import de.bsvrz.dav.daf.main.config.SystemObject;
import de.bsvrz.sba.plugin.parameter.steuerungskern.daten.WVZInhalt;
import de.bsvrz.sba.plugin.parameter.steuerungskern.konfig.Konfig;
import de.bsvrz.sba.plugin.parameter.steuerungskern.konfig.VerwaltungWvzInhalte;
import de.bsvrz.sba.plugin.parameter.steuerungskern.parameter.verriegelung.allgemein.Design;
import de.bsvrz.sba.plugin.parameter.steuerungskern.parameter.verriegelung.allgemein.EVA;
import de.bsvrz.sba.plugin.parameter.steuerungskern.parameter.verriegelung.allgemein.Spalte;
import de.bsvrz.sba.plugin.parameter.steuerungskern.parameter.verriegelung.allgemein.TableModelVerriegelung;
import de.bsvrz.sba.plugin.parameter.steuerungskern.parameter.verriegelung.allgemeineVerriegelungsMatrix.CompositeA;
import de.bsvrz.sba.plugin.parameter.steuerungskern.parameter.verriegelung.allgemeineVerriegelungsMatrix.CompositeABlinkerBC;
import de.bsvrz.sba.plugin.parameter.steuerungskern.parameter.verriegelung.allgemeineVerriegelungsMatrix.CompositeAD;
import de.bsvrz.sba.plugin.parameter.steuerungskern.parameter.verriegelung.allgemeineVerriegelungsMatrix.CompositeBC;
import de.bsvrz.sba.plugin.parameter.steuerungskern.parameter.verriegelung.allgemeineVerriegelungsMatrix.CompositeBlinkerBC;
import de.bsvrz.sba.plugin.parameter.steuerungskern.parameter.verriegelung.allgemeineVerriegelungsMatrix.CompositeBlinkerTAQ;
import de.bsvrz.sba.plugin.parameter.steuerungskern.parameter.verriegelung.allgemeineVerriegelungsMatrix.CompositeTAQ;
import de.bsvrz.sba.plugin.parameter.steuerungskern.projektspezifischeEinstellungen.AnzeigeElementTyp;
import de.bsvrz.sba.plugin.parameter.steuerungskern.tools.Tools;

/**
 * Darstellung des Fensters zur Versorgung der Parameter
 */
public class CompositeSVM extends Composite implements ICompositeParameterSpezielleVerriegelungsMatrix
{
	/**
	 * Aktuelles Composite
	 */
  private Composite _composite;

  /**
   * WVZ Inhalt "beliebig"
   */
  WVZInhalt _beliebig = VerwaltungWvzInhalte.getInstance().getBeliebig();
  
  /**
   * Composite der Tabelle
   */
  private Composite _compositeTabelle;

  /**
   * Gruppe mit den Regeln
   */
  private Group _groupRegeln;

  /**
   * Tabelviewer der Tabelle
   */
  private TableViewer _tvAnzeige;

  /**
   * Aktuelle Parameter
   */
  private ListeMitRegeln _aktuelleParameter;

  /**
   * Composite fr die Buttons
   */
	private Composite _compositeButtons;

	/**
	 * Button Hinzufgen
	 */
	private Button _buttonHinzufuegen;

	/**
	 * Button Lschen
	 */
	private Button _buttonLoeschen;

	/**
	 * Tabellenmodell
	 */
	private TableModelVerriegelung [] _tableModel;
	
	/**
	 * Modell des Anzeigequerschnitts
	 */
	//private IAnzeigeQuerschnittTyp _aqTyp;

	/**
	 * Systemobjekt des Anzeigequerschnitts
	 */
	private SystemObject _systemObject;

	private Button _buttonAlleLoeschen;

	/**
	 * Breite der Spalten mit den WVZ Inhalten
	 */
	private int _breiteSpalte = 60;

	private Design _design;

  /**
   * Konstruktor der Klasse
   * @param parent Parent Composite
   * @param style Stil des Fenstern
   * @param aktuell Aktuelle Parameter
   * @param typ Typ des Anzeigequerschnitts
   */
  public CompositeSVM (Composite parent, int style, ListeMitRegeln aktuell, String pidAnzeigeQuerschnitt, Design design)
  {
    super (parent, style);
    
    this._aktuelleParameter = erzeugeKopie(aktuell);
    
  	_systemObject = Konfig.getInstance().getAnzeigeQuerschnittByPid (pidAnzeigeQuerschnitt);
  	
  	_design = design;

//   	_aqTyp = VerwaltungAnzeigeQuerschnitte.getInstance().getAnzeigeQuerschnitt(_systemObject);
    
    initialize();
  }

  /**
   * Methode legt eine Arbeitskopie der akutellen Daten an
   * @param aktuell aktuelle Daten
   * @return Arbeitskopie
   */
  private ListeMitRegeln erzeugeKopie(ListeMitRegeln aktuell)
  {
	  ListeMitRegeln kopie = new ListeMitRegeln();
	  
	  if (aktuell != null)
	  {
	    Vector<RegelSpezielleVerriegelungsMatrix> parameter = aktuell.getParameter();
	    for (RegelSpezielleVerriegelungsMatrix regel : parameter)
	  	  kopie.addRegel(regel.getVerriegelungen(), regel.getSchaltgrundRegel());
	  }
	  
	  return kopie;
  }

  /**
   * Fhrt die Basis-Initialisierung des Composites durch
   */
  private void initialize()
  {
    GridData gridData1 = new GridData();
    gridData1.horizontalAlignment = GridData.FILL;
    gridData1.grabExcessHorizontalSpace = true;
    gridData1.grabExcessVerticalSpace = true;
    gridData1.heightHint = -1;
    gridData1.widthHint = -1;
    gridData1.horizontalIndent = 0;
    gridData1.verticalAlignment = GridData.FILL;
    
    setLayout(new GridLayout(1, false));
    setLayoutData(gridData1);
    
    _composite = new Composite(this, SWT.NONE);
    _composite.setLayout(new GridLayout(1, false));
    _composite.setLayoutData(gridData1);
 
    erzeugeGruppeRegeln();
    
    Table table = _tvAnzeige.getTable();
    _tableModel = createModel1(table);
    
    if ( _tableModel != null )
      _tvAnzeige.setInput(_tableModel); 
    
    createButtons();
    
    updateData(_aktuelleParameter);
  }
  
  /**
   * Methode bernimmt die Daten und zeigt diese in der Tabelle an
   */
  private void updateData (ListeMitRegeln parameter)
  {
  	updateDataTyp1 (parameter);
    
  	_buttonAlleLoeschen.setEnabled (parameter.getParameter().size() != 0);
  	pruefeObLoeschenAngewaehlt();

  }

  /**
   * Methode bernimmt die Daten und zeigt diese in der Tabelle an fr einen
   * Anzeigequerschnitt vom Typ 1
   */
  private void updateDataTyp1 (ListeMitRegeln parameter)
  {
  	int anzahlParameter = parameter.getParameter().size();
  	
  	erzeugeTabellenModell (anzahlParameter);
  	
  	for (int j=0; j<anzahlParameter; ++j)
  	{
      TableModelVerriegelung tm = _tableModel [j];    	
    	RegelSpezielleVerriegelungsMatrix aktuell = parameter.getParameter().get(j);
    	
    	/*
    	 * Lschen
    	 */
    	tm.setSelectedLoeschen("false");
    	
    	/*
    	 * Schaltgrund
    	 */
    	
    	if (aktuell.getSchaltgrundRegel() == null)
    	{
    	  tm.setSelectedSchaltgrund("");
    	}
    	else
    	{
  	    tm.setSelectedSchaltgrund(aktuell.getSchaltgrundRegel().getName());
    	}
    	
  	  /*
  	   * Definition der Reihenfolge der Anzeigen (muss bereinstimmen mit der
  	   * Vorgnger/Nachfolger Beziehung in Querrichtung
  	   */
  	  Vector<VersorgungsElement> elemente = new Vector<VersorgungsElement>();
  	  
//  	  SystemObject[] a       = _aqTyp.getSystemObjekteTypA();
//  	  SystemObject[] b       = _aqTyp.getSystemObjekteTypB();
//  	  SystemObject[] c       = _aqTyp.getSystemObjekteTypC();
//  	  SystemObject[] d       = _aqTyp.getSystemObjekteTypD();
//  	  SystemObject[] t       = _aqTyp.getSystemObjekteTypTAQ();
//  	  SystemObject[] blinker = _aqTyp.getSystemObjekteTypBlinker();
  	  
  	  for (Spalte s : _design.getSpalten())
  	  {
  	  	if (s.getEva() == EVA.A)
  	  	{
  	      elemente.add (new VersorgungsElement((Label) tm.getA (s.getIndex()).getA(), s.getAnzeige(_systemObject, 0), AnzeigeElementTyp.WZG_A));
  	  	}

  	  	if (s.getEva() == EVA.AD)
  	  	{
  	      elemente.add (new VersorgungsElement((Label) tm.getAD (s.getIndex()).getA(), s.getAnzeige(_systemObject, 0), AnzeigeElementTyp.WZG_A));
  	      elemente.add (new VersorgungsElement((Label) tm.getAD (s.getIndex()).getD(), s.getAnzeige(_systemObject, 1), AnzeigeElementTyp.WZG_D));
  	  	}

  	  	if (s.getEva() == EVA.BC)
  	  	{
  	  	  elemente.add (new VersorgungsElement((Label) tm.getBC(s.getIndex()).getB(), s.getAnzeige(_systemObject, 0), AnzeigeElementTyp.WZG_B));
  	  	  elemente.add (new VersorgungsElement((Label) tm.getBC(s.getIndex()).getC(), s.getAnzeige(_systemObject, 1), AnzeigeElementTyp.WZG_C));
  	  	}
  	  	
  	  	if (s.getEva() == EVA.BLINKER_BC)
  	  	{
	  	    elemente.add (new VersorgungsElement((Label) tm.getBlinkerBC(s.getIndex()).getBlinker(),  s.getAnzeige(_systemObject, 0), AnzeigeElementTyp.BLINKER));
	  	    elemente.add (new VersorgungsElement((Label) tm.getBlinkerBC(s.getIndex()).getB(),        s.getAnzeige(_systemObject, 1), AnzeigeElementTyp.WZG_B));
	  	    elemente.add (new VersorgungsElement((Label) tm.getBlinkerBC(s.getIndex()).getC(),        s.getAnzeige(_systemObject, 2), AnzeigeElementTyp.WZG_C));
  	  	}
  	  	
  	  	if (s.getEva() == EVA.A_BLINKER_BC)
  	  	{
  	  	  elemente.add (new VersorgungsElement((Label) tm.getABlinkerBC(s.getIndex()).getA(),        s.getAnzeige(_systemObject, 0), AnzeigeElementTyp.WZG_A));
  	  	  elemente.add (new VersorgungsElement((Label) tm.getABlinkerBC(s.getIndex()).getBlinker(),  s.getAnzeige(_systemObject, 1), AnzeigeElementTyp.BLINKER));
  	  	  elemente.add (new VersorgungsElement((Label) tm.getABlinkerBC(s.getIndex()).getB(),        s.getAnzeige(_systemObject, 2), AnzeigeElementTyp.WZG_B));
  	  	  elemente.add (new VersorgungsElement((Label) tm.getABlinkerBC(s.getIndex()).getC(),        s.getAnzeige(_systemObject, 3), AnzeigeElementTyp.WZG_C));
  	  	}

  	  	if (s.getEva() == EVA.T)
  	  	{
  	      elemente.add (new VersorgungsElement((Label) tm.getTAQ (s.getIndex()).getTAQ(), s.getAnzeige(_systemObject, 0), AnzeigeElementTyp.WZG_TAQ));
  	  	}

  	  	if (s.getEva() == EVA.BLINKER_T)
  	  	{
  	      elemente.add (new VersorgungsElement((Label) tm.getBlinkerTAQ(s.getIndex()).getBlinker(), s.getAnzeige(_systemObject, 0), AnzeigeElementTyp.BLINKER));
   	      elemente.add (new VersorgungsElement((Label) tm.getBlinkerTAQ(s.getIndex()).getTAQ(),     s.getAnzeige(_systemObject, 1), AnzeigeElementTyp.WZG_TAQ));
   	    }
  	  }

  	  for (VersorgungsElement e : elemente)
  	  {
    	  WVZInhalt inhalt = aktuell.getVerriegelung (e.getSystemObject().getPid());
    	  if (inhalt == null)
    	  	inhalt = VerwaltungWvzInhalte.getInstance().getBeliebig();

    	  Tools.setzeBildInhalte(e.getLabel(), inhalt, e.getTyp(), true);
  	  }
    }
  }

  /**
   * Methode erzeugt ein Tabellenmodell einer bestimmten Gre. Dabei werden bereits vorhandene
   * Composite in der Tabelle weiter verwendet
   * @param anzahlParameter Gre des erzeugten Tabellenmodells
   */
  private void erzeugeTabellenModell (int anzahlParameter)
  {
  	/*
  	 * Hat sich die Gre gendert
  	 */
  	if (_tableModel.length != anzahlParameter)
  	{
  		/*
  		 * Tabelle erweitern
  		 */
  		if (_tableModel.length < anzahlParameter)
  		{
  		  Vector<TableModelVerriegelung> v = new Vector<TableModelVerriegelung>();
  		  
  		  for (int i=0; i<_tableModel.length; ++i)
  		  	v.add(_tableModel [i]);
  		  
  		  for (int i=_tableModel.length; i<anzahlParameter; ++i)
  		  	v.add (erzeugeZeileInTabelle(_tvAnzeige.getTable()));
  		  
  		  _tableModel = new TableModelVerriegelung [anzahlParameter];
  		  for (int i=0; i<v.size(); ++i)
  		  	_tableModel [i] = v.get(i);
  		}
  		/*
  		 * Tabelle reduzieren
  		 */
  		else if (_tableModel.length > anzahlParameter)
  		{
  			/*
  			 * Nicht mehr bentigte Elemente lschen
  			 */
  			
  			for (int i = _tableModel.length - 1; i > anzahlParameter - 1; i--)
  			{
  				for (int j=_design.getSpalten().length - 1; j >= 0; j--)
  				{
  					Spalte s = _design.getSpalten()[j];
  					
  					if (s.getEva() == EVA.A)
  	  				_tableModel [i].getA(s.getIndex()).dispose();

  					if (s.getEva() == EVA.AD)
  	  				_tableModel [i].getAD(s.getIndex()).dispose();

  					if (s.getEva() == EVA.BC)
  						_tableModel [i].getBC(s.getIndex()).dispose();

  					if (s.getEva() == EVA.BLINKER_BC)
  						_tableModel [i].getBlinkerBC(s.getIndex()).dispose();

  					if (s.getEva() == EVA.A_BLINKER_BC)
  						_tableModel [i].getABlinkerBC(s.getIndex()).dispose();
  					
  					if (s.getEva() == EVA.T)
  	  				_tableModel [i].getTAQ(s.getIndex()).dispose();

  					if (s.getEva() == EVA.BLINKER_T)
  	  				_tableModel [i].getBlinkerTAQ(s.getIndex()).dispose();

  				}
  				
  				_tableModel [i].getSchaltgrund().dispose();
  				_tableModel [i].getLoeschen().dispose();
  			}

  		  Vector<TableModelVerriegelung> v = new Vector<TableModelVerriegelung>();
  		  for (int i=0; i<anzahlParameter; ++i)
  		  	v.add(_tableModel [i]);

  		  _tableModel = new TableModelVerriegelung [anzahlParameter];
  		  for (int i=0; i<v.size(); ++i)
  		  	_tableModel [i] = v.get(i);
  		}
  		
  	  _tvAnzeige.setInput(_tableModel);
  	  _tvAnzeige.getTable().layout(true);
  	}
  }
  
  /**
   * Methode erzeugt die Gruppe mit den Regeln
   */
  private void erzeugeGruppeRegeln()
  {
    FillLayout fillLayout1 = new FillLayout();
    fillLayout1.marginHeight = 5;
    fillLayout1.marginWidth = 5;
    fillLayout1.type = org.eclipse.swt.SWT.HORIZONTAL;
    
    GridData gridData2 = new GridData();
    gridData2.horizontalAlignment = GridData.FILL;
    gridData2.grabExcessHorizontalSpace = true;
    gridData2.grabExcessVerticalSpace = true;
    gridData2.verticalAlignment = GridData.FILL;
    
    _groupRegeln = new Group(_composite, SWT.NONE);
    _groupRegeln.setText("Regeln");
    
    _groupRegeln.setLayout(fillLayout1);
    _groupRegeln.setLayoutData(gridData2);

    erzeugeTabelle();
  }

  /**
   * Methode erzeugt das Composite mit den Buttons
   */
  private void createButtons()
  {
    RowLayout rowLayout = new RowLayout();
    rowLayout.pack = false;
    GridData gridData3 = new GridData();
    gridData3.horizontalAlignment = GridData.END;
    gridData3.grabExcessHorizontalSpace = true;
    gridData3.verticalAlignment = GridData.CENTER;
    
    _compositeButtons = new Composite( _composite, SWT.NONE );
    _compositeButtons.setLayoutData( gridData3 );
    _compositeButtons.setLayout( rowLayout );

    _buttonHinzufuegen = new Button( _compositeButtons, SWT.NONE );
    _buttonHinzufuegen.setText( "Regel hinzufgen" );
    _buttonHinzufuegen.addMouseListener( new MouseAdapter()
    {
      @Override
      public void mouseDown( MouseEvent e )
      {
        super.mouseDown( e );
        aktionRegelHinzufuegen();
      }
    } );

    _buttonLoeschen = new Button( _compositeButtons, SWT.NONE );
    _buttonLoeschen.setText( "Selektierte Regeln loeschen" );
    _buttonLoeschen.addMouseListener( new MouseAdapter()
    {
      @Override
      public void mouseDown( MouseEvent e )
      {
        super.mouseDown( e );
        aktionRegelLoeschen();
      }

    } );
    _buttonLoeschen.setEnabled(false);

    _buttonAlleLoeschen = new Button( _compositeButtons, SWT.NONE );
    _buttonAlleLoeschen.setText( "Alle Regeln loeschen" );
    _buttonAlleLoeschen.addMouseListener( new MouseAdapter()
    {
      @Override
      public void mouseDown( MouseEvent e )
      {
        aktionAlleRegelLoeschen();
      }
    } );

  }

	/**
   * Methode zum Lschen aller Meldungen
   */
  protected void aktionAlleRegelLoeschen()
  {
		Vector<RegelSpezielleVerriegelungsMatrix> regeln = new Vector<RegelSpezielleVerriegelungsMatrix>();
    _aktuelleParameter.setParameter(regeln);
    
    updateData(_aktuelleParameter);
  }

  /**
   * Methode prft ob Regeln zum Lschen ausgewhlt sind
   */
  private void pruefeObLoeschenAngewaehlt ()
  {
  	boolean angewaehlt = false;
  	
		for (TableModelVerriegelung tm : _tableModel)
			if (tm.getSelectedLoeschen().equals("true"))
				angewaehlt = true;
		
		_buttonLoeschen.setEnabled(angewaehlt);
  }
  
  /**
   * Methode zum Lschen der Regeln
   */
	private void aktionRegelLoeschen()
  {
		Vector<RegelSpezielleVerriegelungsMatrix> regeln = leseAktuelleEinstellungen().getParameter();
    Vector<RegelSpezielleVerriegelungsMatrix> loeschen = new Vector<RegelSpezielleVerriegelungsMatrix>();
    
    for (int i=0; i<_tableModel.length; ++i)
    	if (!_tableModel [i].getSelectedLoeschen().equals("false"))
    		loeschen.add(regeln.get(i));

    for (RegelSpezielleVerriegelungsMatrix r : loeschen)
    {
    	regeln.remove(r);
    }
    
    _aktuelleParameter.setParameter(regeln);
    
    updateData(_aktuelleParameter);
  }

	/**
	 * Aktion Regel hinzufgen
	 */
	private void aktionRegelHinzufuegen()
  {
		Vector<RegelSpezielleVerriegelungsMatrix> regeln = leseAktuelleEinstellungen().getParameter();
    _aktuelleParameter.setParameter(regeln);

		Aspect a = VerwaltungParaSpezielleVerriegelungsMatrix.getInstance().getSchaltgrundAllgemein();
		
		List<Verriegelung> v = new ArrayList<Verriegelung>();

		for (Spalte s : _design.getSpalten())
		{
			if (s.getEva() == EVA.A)
				v.add(new Verriegelung(s.getAnzeige(_systemObject, 0), _beliebig));

			if (s.getEva() == EVA.AD)
			{
				v.add(new Verriegelung(s.getAnzeige(_systemObject, 0), _beliebig));
				v.add(new Verriegelung(s.getAnzeige(_systemObject, 1), _beliebig));
			}
			
			if (s.getEva() == EVA.BC)
			{
				v.add(new Verriegelung(s.getAnzeige(_systemObject, 0), _beliebig));
				v.add(new Verriegelung(s.getAnzeige(_systemObject, 1), _beliebig));
			}

			if (s.getEva() == EVA.BLINKER_BC)
			{
				v.add(new Verriegelung(s.getAnzeige(_systemObject, 0), _beliebig));
				v.add(new Verriegelung(s.getAnzeige(_systemObject, 1), _beliebig));
				v.add(new Verriegelung(s.getAnzeige(_systemObject, 2), _beliebig));
			}

			if (s.getEva() == EVA.A_BLINKER_BC)
			{
				v.add(new Verriegelung(s.getAnzeige(_systemObject, 0), _beliebig));
				v.add(new Verriegelung(s.getAnzeige(_systemObject, 1), _beliebig));
				v.add(new Verriegelung(s.getAnzeige(_systemObject, 2), _beliebig));
				v.add(new Verriegelung(s.getAnzeige(_systemObject, 3), _beliebig));
			}

			if (s.getEva() == EVA.T)
				v.add(new Verriegelung(s.getAnzeige(_systemObject, 0), _beliebig));

			if (s.getEva() == EVA.BLINKER_T)
			{
				v.add(new Verriegelung(s.getAnzeige(_systemObject, 0), _beliebig));
				v.add(new Verriegelung(s.getAnzeige(_systemObject, 1), _beliebig));
			}
		}
		
		_aktuelleParameter.addRegel(v, a);
		
		updateData(_aktuelleParameter);
  }

	/**
	 * Methode erzeugt das Composite mit der Tabelle
	 */
  private void erzeugeTabelle ()
  {
    FillLayout fillLayout1 = new FillLayout();
    fillLayout1.type = org.eclipse.swt.SWT.VERTICAL;
    
    _compositeTabelle = new Composite(_groupRegeln, SWT.None);
    _compositeTabelle.setLayout(fillLayout1);
    
    _tvAnzeige = new TableViewer(_compositeTabelle, SWT.HIDE_SELECTION | SWT.H_SCROLL | SWT.V_SCROLL);
    _tvAnzeige.setContentProvider(new TableContentProvider());

    TableViewerColumn column0 = new TableViewerColumn(_tvAnzeige, SWT.NONE);
    column0.getColumn().setWidth(70);
    column0.getColumn().setText("Lschen");
    column0.setLabelProvider(new MyCellLabelProvider());

    TableViewerColumn column1 = new TableViewerColumn(_tvAnzeige, SWT.NONE);
    column1.getColumn().setWidth(150);
    column1.getColumn().setText("Schaltgrund");
    column1.setLabelProvider(new MyCellLabelProvider());

    for (int i=0; i<_design.getSpalten().length; ++i)
    {
    	Spalte s = _design.getSpalten()[i];
    	
	    TableViewerColumn column3 = new TableViewerColumn(_tvAnzeige, SWT.NONE);
	    column3.getColumn().setWidth(_breiteSpalte);
	    column3.getColumn().setText(s.getText());
	    column3.setLabelProvider(new MyCellLabelProvider());
    }
    
    // resize the row height using a MeasureItem listener
    
    Listener listener = new Listener() {
      @Override
      public void handleEvent(Event event)
      {
        switch (event.type)
        {
          case SWT.MeasureItem:
          	
          	int hoehe = 90;  // Default
          	
          	for (Spalte s : _design.getSpalten())
          		if (s.getEva() == EVA.A_BLINKER_BC)
          			hoehe = 140;
          	
            event.height = hoehe;
            break;

          default:
        }

      }
    };
    
    _tvAnzeige.getTable().addListener(SWT.MeasureItem, listener);
    _tvAnzeige.getTable().setLinesVisible(true);
    _tvAnzeige.getTable().setHeaderVisible(true);
  }

  /**
   * Klasse realsiert den TableContentProvider fr die Tabelle
   * @author ObertM
   */
  private class TableContentProvider implements IStructuredContentProvider, Observer
  {
  	/**
  	 * Tabelviewer
  	 */
    private TableViewer tableViewer;

    /**
     * Methode liefert die Elemente der Tabelle
     */
    public Object[] getElements(Object inputElement)
    {
			Object[] re = null;

			if (inputElement instanceof TableModelVerriegelung [])
			{
        re = (TableModelVerriegelung[]) inputElement;
			}
			
			return re;
    }

    /**
     * Dispose
     */
    public void dispose()
    {
    }

    /**
     * Methode wird aufgerufen wenn sich der Inhalt der Tabelle gendert hat
     */
    public void inputChanged(Viewer viewer, Object oldInput, Object newInput)
    {
      tableViewer = (TableViewer)viewer;

      if (oldInput != null)
      {
        TableModelVerriegelung[] tms = (TableModelVerriegelung[])newInput;

        if (tms != null)
        {
          for (TableModelVerriegelung tm : tms)
            tm.deleteObserver(this);
        }
      }
      
      if (newInput != null)
      {
        TableModelVerriegelung[] tms = (TableModelVerriegelung[])newInput;
        if (tms != null)
        {
          for (TableModelVerriegelung tm : tms)
            tm.addObserver(this);
        }
      }
    }

    @Override
    public void update(Observable arg0, Object arg1)
    {
      if (tableViewer != null)
      {
        tableViewer.refresh();
      }
    }
  }

  /**
   * Erzeugt ein TabellenModell fr den Inhalt der Tabellen
   * @param table
   * @return TabellenModell
   */
  private TableModelVerriegelung[] createModel1 (Table table)
  {
    int tabLength = getAnzahlParameter();
    int elIndex   = 0;
    
    TableModelVerriegelung[] elements = new TableModelVerriegelung [tabLength];
    
    if (elements.length == 0)
    	return elements;

    for (int x=0; x<getAnzahlParameter(); ++x)
    {
	    elements[elIndex] = erzeugeZeileInTabelle(table);
	    elIndex++;
    }
    
    return elements;
  }

  /**
   * Methode erzeugt ein Tabellenmodell fr eine Zeile in der Tabelle
   * @param table Tabelle 
   * @return Tabellenmodell fr eine Zeile
   */
  private TableModelVerriegelung erzeugeZeileInTabelle (Table table)
  {
    /*
     * Layout festlegen
     */
  	
    GridData gd0 = new GridData();
    gd0.horizontalAlignment = GridData.CENTER;
    gd0.verticalAlignment = GridData.CENTER;
    gd0.grabExcessHorizontalSpace = true;
    gd0.grabExcessVerticalSpace = true;

    GridData gd1 = new GridData();
    gd1.horizontalAlignment = GridData.CENTER;
    gd1.verticalAlignment = GridData.CENTER;
    gd1.grabExcessHorizontalSpace = true;
    gd1.grabExcessVerticalSpace = true;

    GridData gd2 = new GridData();
    gd2.horizontalAlignment = GridData.CENTER;
    gd2.verticalAlignment = GridData.CENTER;
    gd2.grabExcessHorizontalSpace = true;
    gd2.grabExcessVerticalSpace = true;
    
    GridData gd3 = new GridData();
    gd3.horizontalAlignment = GridData.CENTER;
    gd3.verticalAlignment = GridData.CENTER;
    gd3.grabExcessHorizontalSpace = true;
    gd3.grabExcessVerticalSpace = true;

    GridData gd4 = new GridData();
    gd4.horizontalAlignment = GridData.CENTER;
    gd4.verticalAlignment = GridData.CENTER;
    gd4.grabExcessHorizontalSpace = true;
    gd4.grabExcessVerticalSpace = true;

    GridData gd5 = new GridData();
    gd5.horizontalAlignment = GridData.CENTER;
    gd5.verticalAlignment = GridData.CENTER;
    gd5.grabExcessHorizontalSpace = true;
    gd5.grabExcessVerticalSpace = true;

    GridData gdTableItem = new GridData();
    gdTableItem.horizontalAlignment = GridData.FILL;
    gdTableItem.grabExcessHorizontalSpace = true;
    gdTableItem.verticalAlignment = GridData.CENTER;

    /*
     * Button Lschen
     */
    Composite comp0 = new Composite( table, SWT.NONE );
    comp0.setBackground( table.getBackground() );
    comp0.setBackgroundMode( SWT.INHERIT_DEFAULT );
    comp0.setLayoutData( gd1 );
    comp0.setLayout( new GridLayout() );
    Button b = new Button( comp0, SWT.CHECK );
    
    b.addSelectionListener(new SelectionListener()
		{
			@Override
			public void widgetSelected(SelectionEvent e)
			{
				pruefeObLoeschenAngewaehlt();
			}
			
			@Override
			public void widgetDefaultSelected(SelectionEvent e)
			{
			}
		});
    
    /*
     * Combobox Schaltgrund    
     */
    Composite comp1 = new Composite( table, SWT.NONE );
    comp1.setBackground( table.getBackground() );
    comp1.setBackgroundMode( SWT.INHERIT_DEFAULT );
    comp1.setLayoutData( gd1 );
    comp1.setLayout( new GridLayout() );
    
    Combo combo1 = new Combo( comp1, SWT.BORDER );
    combo1.setLayoutData( gdTableItem );
    
    Vector<SystemObject> aspekte = Tools.getAspekte();
    String [] sa = new String [aspekte.size()];
    for (int i=0; i<aspekte.size(); ++i)
      sa [i] = aspekte.get(i).getName();
    
    combo1.setItems(sa);
    combo1.select(0);

    Vector<Composite> composites = new Vector<Composite>();
    
    for (Spalte s : _design.getSpalten())
    {
    	if (s.getEva() == EVA.A)
        composites.add(new CompositeA          (table, SWT.NONE));

    	if (s.getEva() == EVA.AD)
        composites.add(new CompositeAD         (table, SWT.NONE));

    	if (s.getEva() == EVA.BC)
        composites.add(new CompositeBC         (table, SWT.NONE));

    	if (s.getEva() == EVA.BLINKER_BC)
        composites.add(new CompositeBlinkerBC  (table, SWT.NONE));

    	if (s.getEva() == EVA.A_BLINKER_BC)
        composites.add(new CompositeABlinkerBC (table, SWT.NONE));
    	
    	if (s.getEva() == EVA.T)
        composites.add(new CompositeTAQ        (table, SWT.NONE));

    	if (s.getEva() == EVA.BLINKER_T)
        composites.add(new CompositeBlinkerTAQ (table, SWT.NONE));
    }
    
    return new TableModelVerriegelung( comp0, comp1, composites );
  }
  
  /**
   * Methode liefert die Anzahl der Parameter
   * @return Anzahl der Parameter
   */
  public int getAnzahlParameter()
  {
    return _aktuelleParameter.getParameter().size();
  }
  
  /**
   * Methode liefert den Tabelviewer
   * @return
   */
  public TableViewer getTvAnzeige()
  {
    return _tvAnzeige;
  }

  /**
   * Renderer fr die Tabelle
   * @author ObertM
   */
  private class MyCellLabelProvider extends CellLabelProvider 
  {
    @Override
    public void update(ViewerCell cell)
    {
      TableItem item = (TableItem)cell.getItem();

      int cnt = cell.getColumnIndex();

      TableModelVerriegelung model = (TableModelVerriegelung)item.getData();
      Composite comp = null;
      switch (cnt)
      {
        case 0:
          comp = model.getLoeschen();
          break;
          
        case 1:
          comp = model.getSchaltgrund();
          break;
          
        default:
        	if (cnt >= 2 && cnt < 2 + _design.getSpalten().length)
        	{
        		int index = cnt - 2;
        		
        		Spalte s = _design.getSpalten()[index];
        		
        		if (s.getEva() == EVA.A)
        	    comp = model.getA (s.getIndex());		

        		if (s.getEva() == EVA.AD)
        	    comp = model.getAD (s.getIndex());		

        		if (s.getEva() == EVA.BC)
        	    comp = model.getBC (s.getIndex());

        		if (s.getEva() == EVA.BLINKER_BC)
        	    comp = model.getBlinkerBC (s.getIndex());
        		
        		if (s.getEva() == EVA.A_BLINKER_BC)
        	    comp = model.getABlinkerBC (s.getIndex());		

        		if (s.getEva() == EVA.T)
        	    comp = model.getTAQ (s.getIndex());		

        		if (s.getEva() == EVA.BLINKER_T)
        	    comp = model.getBlinkerTAQ (s.getIndex());		
        	}
        	
        	break;
      }
      
      TableEditor editor = new TableEditor(item.getParent());
      editor.grabHorizontal = true;
      editor.setEditor(comp, item, cnt);

    }
  }

  /**
   * Methode liefert die eingestellten Parameter
   * @return eingestellte Parameter
   */
	public ListeMitRegeln getParameter()
  {
 		aktionRegelLoeschen();
 		return leseAktuelleEinstellungen();
  }
	
	/**
	 * Methode liest die aktuell eingestellten Parameter
	 * @return aktuell eingestellte Parameter
	 */
	private ListeMitRegeln leseAktuelleEinstellungen ()
	{
		ListeMitRegeln regeln = new ListeMitRegeln();
		
		for (int j=0; j<_tableModel.length; ++j)
		{
      TableModelVerriegelung tm = _tableModel [j];
      
      /*
       * Schaltgrund
       */
      
      String nameSchaltgrund = tm.getSelectedSchaltgrund();
      Aspect schaltgrund = Tools.getAspekt(nameSchaltgrund);

      /*
       * Verriegelungen
       */
  		List<Verriegelung> v = erzeugeVerriegelungen(tm);

  		regeln.addRegel(v, schaltgrund);
		}

		return regeln;
  }

	/**
	 * Methode bernimmt die Daten eines anderen Folders
	 * @param tvAnzeige Tableviewer der zu bernhmenden Tabelle
	 */
	public void setTvAnzeige (TableViewer tvAnzeige)
	{
    TableModelVerriegelung[] modelSet = (TableModelVerriegelung[]) tvAnzeige.getInput();

    Vector<RegelSpezielleVerriegelungsMatrix> v = new Vector<RegelSpezielleVerriegelungsMatrix>();

    for (int i=0; i<modelSet.length; ++i)
    {
      String nameSchaltgrund = modelSet [i].getSelectedSchaltgrund();
      Aspect a = Tools.getAspekt(nameSchaltgrund);

  		List<Verriegelung> inhalte = erzeugeVerriegelungen(modelSet [i]);

  	  v.add (new RegelSpezielleVerriegelungsMatrix (inhalte, a));
    }
    
    _aktuelleParameter.setParameter(v);
    updateData(_aktuelleParameter);
  }
	
  /**
   * Methode zum Aktualisieren des Folders
   */
  public void aktualisiereFolder ()
  {
    TableViewer tvParameter = _tvAnzeige;
    tvParameter.refresh();
  }
  
  /**
   * Methode erzeugt die Verriegelungen aus dem Modell
   * @param model Modell
   * @return Liste mit Verriegelungen
   */
  private List<Verriegelung> erzeugeVerriegelungen (TableModelVerriegelung model)
  {
    VerwaltungWvzInhalte verw = VerwaltungWvzInhalte.getInstance();

		List<Verriegelung> v = new ArrayList<Verriegelung>();

    for (Spalte s : _design.getSpalten())
    {
    	if (s.getEva() == EVA.A)
    	{
    		WVZInhalt a = verw.getWvzInhalt(AnzeigeElementTyp.WZG_A,   model.getSelectedA(s.getIndex()));
    		v.add(new Verriegelung(s.getAnzeige(_systemObject, 0),  a));
    	}

    	if (s.getEva() == EVA.AD)
    	{
    		WVZInhalt a = verw.getWvzInhalt(AnzeigeElementTyp.WZG_A,   model.getSelectedAD_A (s.getIndex()));
    		WVZInhalt d = verw.getWvzInhalt(AnzeigeElementTyp.WZG_D,   model.getSelectedAD_D (s.getIndex()));
    		
    		v.add(new Verriegelung(s.getAnzeige(_systemObject, 0),  a));
    		v.add(new Verriegelung(s.getAnzeige(_systemObject, 1),  d));
    	}

    	if (s.getEva() == EVA.BC)
    	{
    		WVZInhalt b = verw.getWvzInhalt(AnzeigeElementTyp.WZG_B,   model.getSelectedBC_B (s.getIndex()));
    		WVZInhalt c = verw.getWvzInhalt(AnzeigeElementTyp.WZG_C,   model.getSelectedBC_C (s.getIndex()));
    		
    		v.add(new Verriegelung(s.getAnzeige(_systemObject, 0),  b));
    		v.add(new Verriegelung(s.getAnzeige(_systemObject, 1),  c));
    	}

    	if (s.getEva() == EVA.BLINKER_BC)
    	{
    		WVZInhalt bli = verw.getWvzInhalt(AnzeigeElementTyp.BLINKER, model.getSelectedBlinkerBC_Blinker (s.getIndex()));
    		WVZInhalt b   = verw.getWvzInhalt(AnzeigeElementTyp.WZG_B,   model.getSelectedBlinkerBC_B       (s.getIndex()));
    		WVZInhalt c   = verw.getWvzInhalt(AnzeigeElementTyp.WZG_C,   model.getSelectedBlinkerBC_C       (s.getIndex()));
    		
    		v.add(new Verriegelung(s.getAnzeige(_systemObject, 0),  bli));
    		v.add(new Verriegelung(s.getAnzeige(_systemObject, 1),  b));
    		v.add(new Verriegelung(s.getAnzeige(_systemObject, 2),  c));
    	}
    	
    	if (s.getEva() == EVA.A_BLINKER_BC)
    	{
    		WVZInhalt a   = verw.getWvzInhalt(AnzeigeElementTyp.WZG_A,   model.getSelectedABlinkerBC_A       (s.getIndex()));
    		WVZInhalt bli = verw.getWvzInhalt(AnzeigeElementTyp.BLINKER, model.getSelectedABlinkerBC_Blinker (s.getIndex()));
    		WVZInhalt b   = verw.getWvzInhalt(AnzeigeElementTyp.WZG_B,   model.getSelectedABlinkerBC_B       (s.getIndex()));
    		WVZInhalt c   = verw.getWvzInhalt(AnzeigeElementTyp.WZG_C,   model.getSelectedABlinkerBC_C       (s.getIndex()));
    		
    		v.add(new Verriegelung(s.getAnzeige(_systemObject, 0),  a));
    		v.add(new Verriegelung(s.getAnzeige(_systemObject, 1),  bli));
    		v.add(new Verriegelung(s.getAnzeige(_systemObject, 2),  b));
    		v.add(new Verriegelung(s.getAnzeige(_systemObject, 3),  c));
    	}

    	if (s.getEva() == EVA.T)
    	{
    		WVZInhalt t = verw.getWvzInhalt(AnzeigeElementTyp.WZG_TAQ,   model.getSelectedTAQ (s.getIndex()));
    		v.add(new Verriegelung(s.getAnzeige(_systemObject, 0),  t));
    	}

    	if (s.getEva() == EVA.BLINKER_T)
    	{
    		WVZInhalt bli = verw.getWvzInhalt(AnzeigeElementTyp.BLINKER,   model.getSelectedBlinkerTAQ_Blinker (s.getIndex()));
    		WVZInhalt t   = verw.getWvzInhalt(AnzeigeElementTyp.WZG_TAQ,   model.getSelectedBlinkerTAQ_TAQ     (s.getIndex()));
    		
    		v.add(new Verriegelung(s.getAnzeige(_systemObject, 0),  bli));
    		v.add(new Verriegelung(s.getAnzeige(_systemObject, 1),  t));
    	}
    }

		return v;
  }
}
