package de.bsvrz.sba.plugin.parameter.steuerungskern.parameter.vorgaengerNachfolger;

import java.beans.PropertyChangeListener;
import java.beans.PropertyChangeSupport;

import org.eclipse.swt.SWT;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.events.SelectionListener;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Group;

/**
 * Klasse erzeugt ein Composite mit einer Checkbox
 * @author ObertM
 */
public class AuswahlQuerAbgleich
{
	/**
	 * Parent Composite
	 */
  private Composite _parent;

	/**
	 * Checkbox fr die Auswahl
	 */
	private Button _button1;

	/**
  /**
   * Verwaltung der Listener
   */
  private PropertyChangeSupport _pcs = new PropertyChangeSupport (this);

	/**
	 * Konstruktor der Klasse
	 * @param parent parent Composite
	 */
  public AuswahlQuerAbgleich (Composite parent)
  {
  	_parent = parent;
  	
  	erzeugeEingabeElemente();
  }
	
	/**
	 * Methode erzeugt die Eingabeelemente
	 */
  private void erzeugeEingabeElemente()
  {
    GridData gridDataGroup = new GridData();
    gridDataGroup.horizontalAlignment = GridData.FILL;
    gridDataGroup.grabExcessHorizontalSpace = true;

    Group groupObjekte = new Group(_parent, SWT.NONE);
    groupObjekte.setText("Auswahl");
    groupObjekte.setLayout(new GridLayout(1, false));
    groupObjekte.setLayoutData(gridDataGroup);
    
    GridData gridDataComboBox = new GridData();
    gridDataComboBox.horizontalAlignment = GridData.FILL;
    gridDataComboBox.grabExcessHorizontalSpace = true;
    gridDataComboBox.verticalAlignment = GridData.CENTER;
    
    _button1 = new Button( groupObjekte, SWT.CHECK );
    _button1.setText("Alle Anzeigequerschnitte fr Auswahl zulassen");
    _button1.setSelection(false);
    _button1.setLayoutData( gridDataComboBox );
    _button1.addSelectionListener(new SelectionListener()
		{
			@Override
			public void widgetSelected(SelectionEvent e)
			{
				benachrichtigeListener();
			}
			
			@Override
			public void widgetDefaultSelected(SelectionEvent e)
			{
			}
		});
  }

  /**
   * Methode liefert die Information ob alle Querschnitte verwendet werden sollen
   * @return Information ob alle Querschnitte verwendet werden sollen
   */
  public boolean isAlleQuerschnitte ()
  {
  	return _button1.getSelection();
  }
  
  /**
   * Methode fgt einen Listener der Klasse hinzu
   * @param pcl Listern der Klasse PropertyChangeListener
   */
  public void addPropertyChangeListener (PropertyChangeListener pcl)
  {
    _pcs.addPropertyChangeListener( pcl );  
    benachrichtigeListener();
  }
  
  /**
   * Methode entfernt einen Listener aus der Klasse
   * @param pcl Listern der Klasse PropertyChangeListener
   */
  public void removePropertyChangeListener (PropertyChangeListener pcl)
  {
    _pcs.removePropertyChangeListener( pcl );    
  }

  /**
   * Methode benachrichtigt die Listener
   */
  private void benachrichtigeListener ()
  {
    _pcs.firePropertyChange( "Selektion", null, null );
  }
}
