package de.bsvrz.sba.plugin.parameter.steuerungskern.view.allgemein;

import org.eclipse.swt.widgets.Shell;
import org.eclipse.ui.IViewPart;
import org.eclipse.ui.IViewReference;
import org.eclipse.ui.IWorkbenchPage;
import org.eclipse.ui.IWorkbenchPart;
import org.eclipse.ui.IWorkbenchWindow;
import org.eclipse.ui.PartInitException;
import org.eclipse.ui.PlatformUI;
import org.eclipse.ui.internal.WorkbenchPage;

import de.bsvrz.sba.plugin.parameter.steuerungskern.dav.DaVKommunikationSBA;

/**
 * Mit Hilfe dieser Klasse lsst sich die {@link ViewAuswahlParameter} 
 * ffnen. Sie wird eindeutig ber die ID der View identifiziert.
 * @author MO
 */
public class OpenViewAuswahlParameter
{
  /**
   * Primre ID des zu ffnenden Views
   */
  private static final String _viewID = ViewAuswahlParameter.ID;

  /**
   * Konstruktor der Klasse
   * @param auswahl Auswahl ob welche Parameter versorgt werden sollen (Veroderung von {@link PA})
   */
  public static ViewAuswahlParameter openView (String secId, int auswahl)
  {
  	DaVKommunikationSBA.getInstanz();
  	
  	ViewAuswahlParameter re = null;
    
    IWorkbenchWindow window = PlatformUI.getWorkbench().getActiveWorkbenchWindow();
    IWorkbenchPage page = window.getActivePage();

    try
    {
      page.showView(_viewID, secId, IWorkbenchPage.VIEW_CREATE);
      IViewReference ref = page.findViewReference(_viewID, secId);

      IViewPart view = ref.getView(true);
      if (view instanceof ViewAuswahlParameter)
      {
      	((ViewAuswahlParameter) view).personalisiereView(auswahl);
      	
        re = (ViewAuswahlParameter) view;
        window.getActivePage().activate(re);
      }
      
//      window.getActivePage().showView(_viewID);

      // in eigenem Fenster ffnen
      
      ((WorkbenchPage)page).getActivePerspective().getPresentation().detachPart(ref);
      
      IWorkbenchPart wbPart = ref.getPart(false);
      Shell shell = wbPart.getSite().getShell();
      
      shell.setSize(335, 200);
    }
    catch (PartInitException e)
    {
      String msg = "Die ViewAusgabefenster (ID: " + _viewID + ", SecId: " + secId + ") konnte nicht geffnet werden!.";
      
//          e.printStackTrace();
    }
    
    return re;
  }
}
