/*******************************************************************************
 * This file is part of Rahmenwerk.
 * 
 * Rahmenwerk is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License  as 
 * published by the Free Software Foundation, either version 3 of the
 * License.
 * 
 * Rahmenwerk is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with Rahmenwerk.  If not, see <http://www.gnu.org/licenses/>.
 *  
 *  
 * 
 * Copyright (c) 2012 SWARCO TRAFFIC SYSTEMS GmbH.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 * SWARCO TRAFFIC SYSTEMS GmbH - initial API and implementation
 * 
 * 
 * 
 * Contact Information:
 * SWARCO TRAFFIC SYSTEMS GmbH
 * Adolf-Dambach-Strae 
 * D-76571 Gaggenau
 * Phone: +49-7225-64-03
 * Fax: +49-7225-64-300
 * mailto: office.sts@swarco.de
 ******************************************************************************/
package de.sts.buv.plugin.workflow.tsf.dav;

/**
 * Mit Hilfe dieser Klasse kann man sich darber informieren lassen, ob sich der
 * Argoscan im Ruhezustand befindet. Ist dies der Fall, wird man ber noftifyAll
 * darber informiert. <br>
 * <br>
 * 
 * 
 * @author HofmannJ
 * 
 */
public class GUIModelArgoscanRuhezustand
{
	public static GUIModelArgoscanRuhezustand _instance = null;

	public M_TSFZustandArgoscan _zustandArgoscan = null;

	private GUIModelArgoscanRuhezustand()
	{
	}

	public static GUIModelArgoscanRuhezustand getInstance()
	{
		if (_instance == null)
		{
			synchronized (GUIModelArgoscanRuhezustand.class)
			{
				if (_instance == null)
				{
					_instance = new GUIModelArgoscanRuhezustand();
				}
			}
		}

		return _instance;
	}

	public void setZustandArgoscan(M_TSFZustandArgoscan zustandArgoscan)
	{
		this._zustandArgoscan = zustandArgoscan;

		if (isArgoscanInRuhezustand())
		{
			synchronized (this)
			{
				this.notifyAll();
			}
		}
	}

	public boolean isArgoscanInRuhezustand()
	{
		boolean ruhezustand = false;

		if (_zustandArgoscan != null)
		{
			E_TSFArgoscanZustand zustand = _zustandArgoscan.getZustand();
			if (zustand != null)
			{
				if (zustand == E_TSFArgoscanZustand.Ruhezustand)
				{
					ruhezustand = true;
				}
			}
		}

		return ruhezustand;
	}
}
