/*******************************************************************************
 * This file is part of Rahmenwerk.
 * 
 * Rahmenwerk is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License  as 
 * published by the Free Software Foundation, either version 3 of the
 * License.
 * 
 * Rahmenwerk is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with Rahmenwerk.  If not, see <http://www.gnu.org/licenses/>.
 *  
 *  
 * 
 * Copyright (c) 2012 SWARCO TRAFFIC SYSTEMS GmbH.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 * SWARCO TRAFFIC SYSTEMS GmbH - initial API and implementation
 * 
 * 
 * 
 * Contact Information:
 * SWARCO TRAFFIC SYSTEMS GmbH
 * Adolf-Dambach-Strae 
 * D-76571 Gaggenau
 * Phone: +49-7225-64-03
 * Fax: +49-7225-64-300
 * mailto: office.sts@swarco.de
 ******************************************************************************/
package de.sts.buv.plugin.workflow.tsf.dlg;

import java.awt.Toolkit;
import java.util.Timer;
import java.util.TimerTask;

import org.eclipse.swt.SWT;
import org.eclipse.swt.events.DisposeEvent;
import org.eclipse.swt.events.DisposeListener;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.graphics.Font;
import org.eclipse.swt.graphics.Image;
import org.eclipse.swt.graphics.Point;
import org.eclipse.swt.layout.FillLayout;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.layout.RowLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Dialog;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Group;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.widgets.Text;

import de.bsvrz.dav.daf.main.config.SystemObject;
import de.sts.buv.plugin.workflow.tsf.Activator;
import de.sts.buv.plugin.workflow.tsf.DefsFonts;
import de.sts.buv.plugin.workflow.tsf.PreferenceInit;
import de.sts.buv.plugin.workflow.tsf.dav.DaVKomTSFParaAblaufTSF;
import de.sts.buv.plugin.workflow.tsf.dav.DaVKomTSFWeiterSchaltenAntwort;
import de.sts.buv.plugin.workflow.tsf.dav.E_TSFWeiterSchaltenAntwort;
import de.sts.buv.plugin.workflow.tsf.dav.E_TSFWeiterschaltenZustand;
import de.sts.buv.plugin.workflow.tsf.dav.GUIManager_TSFWeiterschalten;
import de.sts.buv.plugin.workflow.tsf.dav.M_TSFWeiterSchalten;
import de.sts.buv.plugin.workflow.tsf.dav.M_TSFWeiterSchaltenAntwort;
import de.sts.buv.plugin.workflow.tsf.dav.WiedervorlageTSFWeiterschalten;
import de.sts.buv.plugin.workflow.tsf.snd.AePlayWave;

/**
 * Dialog mit dem die Aufforderung zum Weiterschalten erfolgen kann. Versand
 * wird eine Weiterschalten-Antwort ( {@link M_TSFWeiterSchaltenAntwort}). Der
 * Aufruf des Dialogs erfolgt ber eine {@link M_TSFWeiterSchalten}
 * -Aufforderung.
 * 
 * @author HofmannJ
 * 
 */
public class DialogWeiterschalten extends Dialog
{
	/**
	 * Shell
	 */
	private Shell _shell;

	/**
	 * DEF-Breite
	 */
	private static final int DEF_WIDTH = 600;
	private static final int DEF_HEIGHT = 350;

	private M_TSFWeiterSchalten _data = null;

	private Composite _compAbschnitt;

	private Composite _compInfoTxt;

	private Group _groupKommentar;

	private Label _lAbschnitt;

	private Label _lInfoTxt;
	private static final String TEXT_1 = "Ist der Abschnitt\n";
	private static final String TEXT_2 = "\nfrei und kann\ngeschalten werden?";

	private Text _tKommentar;

	/**
	 * Eindeutige Kennung dieses Dialoges.
	 */
	private String _kennung = null;

	private GUIManager_TSFWeiterschalten _guitsfWeiterschaltenManager = null;

	private static Image _achtungImg;

	private static Image _kameraImageLinks;

	private static Image _kameraImageRechts;

	private Timer _sndTimer;

	private Button _bTonAusschalten;

	public DialogWeiterschalten(Shell parent,
			GUIManager_TSFWeiterschalten guitsfWeiterschaltenManager)
	{
		super(parent);
		this._guitsfWeiterschaltenManager = guitsfWeiterschaltenManager;
	}

	public GUIManager_TSFWeiterschalten getGuitsfWeiterschaltenManager()
	{
		return _guitsfWeiterschaltenManager;
	}

	public Object oeffne(M_TSFWeiterSchalten data)
	{
		// this._shell = ShellOnTop.getShell(getParent(), SWT.TITLE | SWT.BORDER |
		// SWT.CLOSE);
		this._shell = ShellOnTop.getShell(getParent(), SWT.TITLE | SWT.BORDER);
		// this._shell = new Shell(getParent(), SWT.ON_TOP | SWT.TITLE | SWT.BORDER
		// | SWT.CLOSE);

		_shell.addDisposeListener(new DisposeListener()
		{
			@Override
			public void widgetDisposed(DisposeEvent e)
			{
				dispose();
			}
		});

		/*
		 * GUI Aufbauen
		 */
		initGui(_shell);

		/*
		 * Daten darstellen
		 */
		setData(data);

		/*
		 * Zentrieren
		 */

		// Grsse Bildschirm
		Toolkit test = java.awt.Toolkit.getDefaultToolkit();

		/*
		 * Auflsung durch 2 subtrahiert durch die Hlfte der in der Shell
		 * angegebenen Horizontalen, damit der Dialog mittig am Bildschirm erscheint
		 */

		int x = test.getScreenSize().width / 2 - DEF_WIDTH / 2;

		/*
		 * Auflsung durch 2 subtrahiert durch die Hlfte der in der Shell
		 * angegebenen Verzikalen
		 */

		int y = test.getScreenSize().height / 2 - DEF_HEIGHT / 2;

		_shell.setBounds(x, y, DEF_WIDTH, DEF_HEIGHT);

		/*
		 * Festdefinierte Positionen wenn mglich bestimmen.
		 */
		if (data != null)
		{
			if ((data.getSo() != null) && (data.getSo().getPid() != null))
			{
				Point location = StaticDialogLocation.getInstance().getDlgLoc(
						this.getClass().getName(), data.getSo().getPid());
				if (location != null)
				{
					_shell.setLocation(location);
				}
			}
		}

		_shell.open();

		startSoundTimer();

		Display display = getParent().getDisplay();
		while (!_shell.isDisposed())
			if (!display.readAndDispatch())
				display.sleep();

		return null;
	}

	public void setData(M_TSFWeiterSchalten data)
	{
		this._data = data;

		if (_data != null)
		{
			_shell.setText(_shell.getText() + " Ziel-Programm=" + data.getProgramm());

			if ((_data.getSo() != null) && (_lAbschnitt != null))
			{
				_lAbschnitt.setText("Abschnitt " + _data.getSo().getNameOrPidOrId());
			}

			long aktStufe = data.getStufe() + 1l;

			int anzStufen = DaVKomTSFParaAblaufTSF.getInstance()
					.bestimmeAnzahlStufen(data.getSo(), data.getProgramm());

			String text = TEXT_1 + "(Stufe " + aktStufe + " von " + anzStufen + ")"
					+ TEXT_2;
			_lInfoTxt.setText(text);

			if (_data.getKommentar() != null)
			{
				_tKommentar.setText(_data.getKommentar());
			} else
			{
				_tKommentar.setText("-");
			}
		}
	}

	public M_TSFWeiterSchalten getData()
	{
		return _data;
	}

	public String getKennung()
	{
		return _kennung;
	}

	private void initGui(Shell parent)
	{
		parent.setText("Abschnitt frei?");
		parent.setLayout(new FillLayout());

		Composite top = new Composite(parent, SWT.NONE);
		top.setLayout(new GridLayout(1, false));

		Composite compositeContent = getCompositeContent(top);
		Composite compositeCtrl = getCompositeCtrl(top);

		GridData gdCompContent = new GridData();
		gdCompContent.grabExcessHorizontalSpace = true;
		gdCompContent.grabExcessVerticalSpace = true;
		gdCompContent.verticalAlignment = GridData.FILL;
		gdCompContent.horizontalAlignment = GridData.FILL;
		compositeContent.setLayoutData(gdCompContent);

		GridData gdCompCtrl = new GridData();
		gdCompCtrl.grabExcessHorizontalSpace = true;
		gdCompCtrl.grabExcessVerticalSpace = false;
		gdCompCtrl.horizontalAlignment = GridData.CENTER;
		compositeCtrl.setLayoutData(gdCompCtrl);
	}

	private Composite getCompositeContent(Composite parent)
	{
		Composite compContent = new Composite(parent, SWT.BORDER);

		getCompositeAbschnitt(compContent);
		getCompositeInfotext(compContent);
		getCompositeKommentar(compContent);

		compContent.setLayout(new GridLayout(1, false));

		GridData gdLAbs = new GridData();
		gdLAbs.horizontalSpan = 1;
		gdLAbs.grabExcessHorizontalSpace = true;
		gdLAbs.horizontalAlignment = GridData.FILL;
		getCompositeAbschnitt(compContent).setLayoutData(gdLAbs);

		GridData gdCompInfoText = new GridData();
		gdCompInfoText.grabExcessHorizontalSpace = true;
		gdCompInfoText.grabExcessVerticalSpace = true;
		gdCompInfoText.horizontalAlignment = GridData.FILL;
		gdCompInfoText.verticalAlignment = GridData.FILL;
		getCompositeInfotext(compContent).setLayoutData(gdCompInfoText);

		GridData gdTKommentar = new GridData();
		gdTKommentar.grabExcessHorizontalSpace = true;
		gdTKommentar.horizontalAlignment = GridData.FILL;
		gdTKommentar.heightHint = 50;
		gdTKommentar.verticalAlignment = GridData.FILL;
		getCompositeKommentar(compContent).setLayoutData(gdTKommentar);

		return compContent;
	}

	private Composite getCompositeAbschnitt(Composite parent)
	{
		if (_compAbschnitt == null)
		{
			_compAbschnitt = new Composite(parent, SWT.BORDER);

			_lAbschnitt = new Label(_compAbschnitt, SWT.NONE);
//			Font fontAbschnitt = new Font(null, "Arial", 12, SWT.BOLD);
			_lAbschnitt.setFont(DefsFonts.FONT_ARIAL_12_PKT_BOLD);
			_lAbschnitt.setText("Abschnitt: ");

			_compAbschnitt.setLayout(new GridLayout(1, false));

			GridData gdLAbschnitt = new GridData();
			gdLAbschnitt.grabExcessHorizontalSpace = true;
			gdLAbschnitt.horizontalAlignment = GridData.CENTER;
			_lAbschnitt.setLayoutData(gdLAbschnitt);
		}

		return _compAbschnitt;
	}

	private Composite getCompositeInfotext(Composite parent)
	{
		if (_compInfoTxt == null)
		{
			_compInfoTxt = new Composite(parent, SWT.BORDER);

			Label lFrag1 = new Label(_compInfoTxt, SWT.None);
			// lFrag1.setImage(getAchtungImage());
			lFrag1.setImage(getKameraImageRechts());

			_lInfoTxt = new Label(_compInfoTxt, SWT.CENTER);
//			Font fontInfoTxt = new Font(null, "Arial", 18, SWT.BOLD);
			_lInfoTxt.setFont(DefsFonts.FONT_ARIAL_18_PKT_BOLD);
			_lInfoTxt.setText("Ist der Abschnitt frei und\nkann geschalten werden?");

			Label lFrag2 = new Label(_compInfoTxt, SWT.None);
			// lFrag2.setImage(getAchtungImage());
			lFrag2.setImage(getKameraImageLinks());

			_compInfoTxt.setLayout(new GridLayout(3, false));

			GridData gdLFrag1 = new GridData();
			gdLFrag1.grabExcessHorizontalSpace = true;
			gdLFrag1.grabExcessVerticalSpace = true;
			gdLFrag1.horizontalAlignment = GridData.CENTER;
			gdLFrag1.verticalAlignment = GridData.CENTER;
			lFrag1.setLayoutData(gdLFrag1);

			GridData gdLInfoTxt = new GridData();
			gdLInfoTxt.grabExcessHorizontalSpace = true;
			gdLInfoTxt.horizontalAlignment = GridData.CENTER;
			_lInfoTxt.setLayoutData(gdLInfoTxt);

			GridData gdLFrag2 = new GridData();
			gdLFrag2.grabExcessHorizontalSpace = true;
			gdLFrag2.grabExcessVerticalSpace = true;
			gdLFrag2.horizontalAlignment = GridData.CENTER;
			gdLFrag2.verticalAlignment = GridData.CENTER;
			lFrag2.setLayoutData(gdLFrag2);
		}

		return _compInfoTxt;
	}

	private static Image getAchtungImage()
	{
		if (_achtungImg == null)
		{
			_achtungImg = Activator
					.getImageDescriptor("icons/fragezeichen_96x96.png").createImage();
		}

		return _achtungImg;
	}

	private static Image getKameraImageLinks()
	{
		if (_kameraImageLinks == null)
		{
			_kameraImageLinks = Activator.getImageDescriptor(
					"icons/Camera_links_96x96.png").createImage();
		}

		return _kameraImageLinks;
	}

	private static Image getKameraImageRechts()
	{
		if (_kameraImageRechts == null)
		{
			_kameraImageRechts = Activator.getImageDescriptor(
					"icons/Camera_rechts_96x96.png").createImage();
		}

		return _kameraImageRechts;
	}

	private Composite getCompositeKommentar(Composite parent)
	{
		if (_groupKommentar == null)
		{
			_groupKommentar = new Group(parent, SWT.NONE);
			_groupKommentar.setText("Kommentar:");

			_tKommentar = new Text(_groupKommentar, SWT.MULTI | SWT.WRAP
					| SWT.H_SCROLL | SWT.V_SCROLL);
			_tKommentar.setEditable(false);

			_groupKommentar.setLayout(new FillLayout());
		}
		return _groupKommentar;
	}

	private Composite getCompositeCtrl(Composite parent)
	{
		Composite compCtrl = new Composite(parent, SWT.NONE);

		Button bSchalten = new Button(compCtrl, SWT.PUSH);
		bSchalten.setText("&Schalten");
		bSchalten.addSelectionListener(new SelectionAdapter()
		{

			@Override
			public void widgetSelected(SelectionEvent e)
			{
				aktionSchalten();
			}

		});

		// Button bNichtSchalten = new Button(compCtrl, SWT.PUSH);
		// bNichtSchalten.setText("&Nicht Schalten");
		// bNichtSchalten.addSelectionListener(new SelectionAdapter()
		// {
		//
		// @Override
		// public void widgetSelected(SelectionEvent e)
		// {
		// aktionNichtSchalten();
		// }
		//
		// });

		Button bAbbrechen = new Button(compCtrl, SWT.PUSH);
		bAbbrechen.setText("&Abbrechen");
		bAbbrechen.addSelectionListener(new SelectionAdapter()
		{

			@Override
			public void widgetSelected(SelectionEvent e)
			{
				aktionAbbrechen();
			}

		});

		Button bHilfe = new Button(compCtrl, SWT.PUSH);
		bHilfe.setText("&Hilfe");
		bHilfe.addSelectionListener(new SelectionAdapter()
		{
			@Override
			public void widgetSelected(SelectionEvent e)
			{
				System.out
						.println("Hilfe-Integration muss noch implementiert werden...");
			}
		});

		Button bWiedervorlage = new Button(compCtrl, SWT.PUSH);
		bWiedervorlage.setText("&Wiedervorlage");
		bWiedervorlage.addSelectionListener(new SelectionAdapter()
		{
			@Override
			public void widgetSelected(SelectionEvent e)
			{
				if (_data != null)
				{
					new WiedervorlageTSFWeiterschalten(_data);
					DialogWeiterschalten.this.dispose();
				}
			}
		});

		_bTonAusschalten = new Button(compCtrl, SWT.PUSH);
		_bTonAusschalten.setText("&Ton ausschalten");
		_bTonAusschalten.addSelectionListener(new SelectionAdapter()
		{
			@Override
			public void widgetSelected(SelectionEvent e)
			{
				if (_sndTimer != null)
				{
					schalteTonAus();
					_bTonAusschalten.setText("&Ton einschalten");
				} else
				{
					startSoundTimer();
					if (_sndTimer != null)
					{
						_bTonAusschalten.setText("&Ton ausschalten");
					}
				}
			}
		});
		_bTonAusschalten.setEnabled(PreferenceInit.isSndWeiterschaltenAktiv());

		compCtrl.setLayout(new RowLayout(SWT.HORIZONTAL));

		return compCtrl;
	}

	private void aktionSchalten()
	{
		if (getData() != null)
		{
			SystemObject so = getData().getSo();
			M_TSFWeiterSchaltenAntwort antwort = new M_TSFWeiterSchaltenAntwort(so);
			antwort.setBefehl(E_TSFWeiterSchaltenAntwort.Schalten);
			antwort.setKennung(getKennung());
			String sendeWeiterschaltenAntwort = DaVKomTSFWeiterSchaltenAntwort
					.getInstance().sendeWeiterschaltenAntwort(antwort);

			// Nur wenn erfolgreich versandt Dialog schlieen.
			if (sendeWeiterschaltenAntwort == null)
			{
				dispose();
			}
		}
	}

	private void aktionNichtSchalten()
	{
		if (getData() != null)
		{
			SystemObject so = getData().getSo();
			M_TSFWeiterSchaltenAntwort antwort = new M_TSFWeiterSchaltenAntwort(so);
			antwort.setBefehl(E_TSFWeiterSchaltenAntwort.Nicht_schalten);
			antwort.setKennung(getKennung());
			String sendeWeiterschaltenAntwort = DaVKomTSFWeiterSchaltenAntwort
					.getInstance().sendeWeiterschaltenAntwort(antwort);

			// Nur wenn erfolgreich versandt Dialog schlieen.
			if (sendeWeiterschaltenAntwort == null)
			{
				dispose();
			}
		}
	}

	private void aktionAbbrechen()
	{
		if (getData() != null)
		{
			SystemObject so = getData().getSo();
			M_TSFWeiterSchaltenAntwort antwort = new M_TSFWeiterSchaltenAntwort(so);
			antwort.setBefehl(E_TSFWeiterSchaltenAntwort.Abbrechen);
			antwort.setKennung(getKennung());
			String sendeWeiterschaltenAntwort = DaVKomTSFWeiterSchaltenAntwort
					.getInstance().sendeWeiterschaltenAntwort(antwort);

			// Nur wenn erfolgreich versandt Dialog schlieen.
			if (sendeWeiterschaltenAntwort == null)
			{
				InfoWeiterschaltenAbgebrochen.getInstance().benachrichtigeUeberAbgebrochenesWeiterschnalten(so.getPid());
				dispose();
			}
		}
	}

	public void dispose()
	{
		if (getGuitsfWeiterschaltenManager() != null)
		{
			getGuitsfWeiterschaltenManager().removeDialog(this);
		}

		// Sound abstellen
		schalteTonAus();

		if (!_shell.isDisposed())
		{
			_shell.dispose();
		}
	}

	private Timer startSoundTimer()
	{
		if (PreferenceInit.isSndWeiterschaltenAktiv())
		{
			if (_sndTimer == null)
			{
				int delaySndWf = PreferenceInit.getDelaySndWeiterschalten();
				final String pathSndWf = PreferenceInit.getPathSndWeiterschalten();

				TimerTask sndTask = new TimerTask()
				{
					@Override
					public void run()
					{
						new AePlayWave(pathSndWf).start();
					}
				};

				_sndTimer = new Timer("WF Weiterschalten Timer");
				_sndTimer.schedule(sndTask, 0l, delaySndWf * 1000l);
			}
		}

		return _sndTimer;
	}

	private void schalteTonAus()
	{
		if (_sndTimer != null)
		{
			_sndTimer.cancel();
			_sndTimer = null;
		}
	}

	public static void main(String[] args)
	{
		M_TSFWeiterSchalten w = new M_TSFWeiterSchalten();
		w.setZustand(E_TSFWeiterschaltenZustand.OEFFNEN);
		w.setKommentar("Hier der Test-Kommentar");
		w.setClientId("456");
		w.setKennung("123");
		new DialogWeiterschalten(new Shell(), null).oeffne(w);
	}
}
