/*******************************************************************************
 * This file is part of Rahmenwerk.
 * 
 * Rahmenwerk is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License  as 
 * published by the Free Software Foundation, either version 3 of the
 * License.
 * 
 * Rahmenwerk is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with Rahmenwerk.  If not, see <http://www.gnu.org/licenses/>.
 *  
 *  
 * 
 * Copyright (c) 2012 SWARCO TRAFFIC SYSTEMS GmbH.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 * SWARCO TRAFFIC SYSTEMS GmbH - initial API and implementation
 * 
 * 
 * 
 * Contact Information:
 * SWARCO TRAFFIC SYSTEMS GmbH
 * Adolf-Dambach-Strae 
 * D-76571 Gaggenau
 * Phone: +49-7225-64-03
 * Fax: +49-7225-64-300
 * mailto: office.sts@swarco.de
 ******************************************************************************/
package de.sts.buv.plugin.workflow.tsf.dlg;

import java.util.Timer;
import java.util.TimerTask;

import org.eclipse.core.runtime.IProgressMonitor;
import org.eclipse.core.runtime.IStatus;
import org.eclipse.swt.SWT;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.graphics.Font;
import org.eclipse.swt.graphics.Image;
import org.eclipse.swt.graphics.Point;
import org.eclipse.swt.layout.FillLayout;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Group;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.widgets.Text;
import org.eclipse.ui.ISaveablePart2;
import org.eclipse.ui.IViewPart;
import org.eclipse.ui.IViewReference;
import org.eclipse.ui.IWorkbench;
import org.eclipse.ui.IWorkbenchListener;
import org.eclipse.ui.IWorkbenchPage;
import org.eclipse.ui.IWorkbenchPart;
import org.eclipse.ui.IWorkbenchPartConstants;
import org.eclipse.ui.IWorkbenchWindow;
import org.eclipse.ui.PartInitException;
import org.eclipse.ui.PlatformUI;
import org.eclipse.ui.internal.ViewPane;
import org.eclipse.ui.internal.WorkbenchPage;
import org.eclipse.ui.internal.WorkbenchPartReference;
import org.eclipse.ui.part.ViewPart;

import de.bsvrz.dav.daf.main.config.SystemObject;
import de.sts.buv.plugin.workflow.tsf.Activator;
import de.sts.buv.plugin.workflow.tsf.DefsFonts;
import de.sts.buv.plugin.workflow.tsf.PreferenceInit;
import de.sts.buv.plugin.workflow.tsf.dav.DaVKomTSFParaAblaufTSF;
import de.sts.buv.plugin.workflow.tsf.dav.DaVKomTSFWeiterSchaltenAntwort;
import de.sts.buv.plugin.workflow.tsf.dav.E_TSFWeiterSchaltenAntwort;
import de.sts.buv.plugin.workflow.tsf.dav.GUIManager_TSFWeiterschalten;
import de.sts.buv.plugin.workflow.tsf.dav.M_TSFWeiterSchalten;
import de.sts.buv.plugin.workflow.tsf.dav.M_TSFWeiterSchaltenAntwort;
import de.sts.buv.plugin.workflow.tsf.dav.WiedervorlageTSFWeiterschalten;
import de.sts.buv.plugin.workflow.tsf.snd.AePlayWave;

public class ViewSchnellsperrung extends ViewPart implements ISaveablePart2,
		IWorkbenchListener
{
	public static final String ID = "de.sts.buv.plugin.workflow.tsf.dlg.ViewSchnellsperrung";
	private static final int BREITE = 650;
	private static final int HOEHE = 375;

	/**
	 * Flag das Anzeigt, dass diese View geschlossen werden darf.
	 */
	private boolean _schliessenErlaubt = false;

	private M_TSFWeiterSchalten _data = null;

	private Composite _compAbschnitt;

	private Composite _compInfoTxt;

	private Group _groupKommentar;

	private Label _lAbschnitt;

	private Label _lInfoTxt;
	private static final String TEXT_1 = "Soll der Ende-Zustand fr den\n";
	private static final String TEXT_2 = "\nAbschnitt geschaltet werden?";

	private Text _tKommentar;

	/**
	 * Eindeutige Kennung dieses Dialoges.
	 */
	private String _kennung = null;

	private GUIManager_TSFWeiterschalten _guitsfWeiterschaltenManager = null;

	private static Image _achtungImg;

	private static Image _kameraImageLinks;

	private static Image _kameraImageRechts;

	private Timer _sndTimer;

	private Button _bTonAusschalten;
	
	private Composite _parent; 

	@Override
	public void createPartControl(Composite parent)
	{
		_parent = parent;
		 //Fr die F1 Taste
	    PlatformUI.getWorkbench().getHelpSystem().setHelp( parent, 
	    		Activator.PLUGIN_ID + ".workflowschnellsperren" );
		
		/*
		 * GUI Aufbauen
		 */
		Composite top = new Composite(parent, SWT.NONE);
		top.setLayout(new FillLayout());
		initGui(top);

		startSoundTimer();
		PlatformUI.getWorkbench().addWorkbenchListener(this);
	}

	@Override
	public void setFocus()
	{
		if (_parent != null)
			_parent.setFocus();
	}

	public void setData(M_TSFWeiterSchalten data)
	{
		this._data = data;

		if (_data != null)
		{
			this.setPartName(" Ziel-Programm=" + data.getProgramm());

			if ((_data.getSo() != null) && (_lAbschnitt != null))
			{
				_lAbschnitt.setText(_data.getSo().getNameOrPidOrId());
				_lAbschnitt.getParent().layout(true);
			}

			long aktStufe = data.getStufe() + 1l;

			int anzStufen = DaVKomTSFParaAblaufTSF.getInstance()
					.bestimmeAnzahlStufen(data.getSo(), data.getProgramm());

//			String text = TEXT_1 + "(Stufe " + aktStufe + " von " + anzStufen + ")"
//					+ TEXT_2;
//			_lInfoTxt.setText(text);
			_lInfoTxt.setText(TEXT_1 + "" + TEXT_2);

			if (_data.getKommentar() != null)
			{
				_tKommentar.setText(_data.getKommentar());
			} else
			{
				_tKommentar.setText("-");
			}
		}
	}

	public M_TSFWeiterSchalten getData()
	{
//	  System.out.println("ViewWeiterschalten.setData(): " + _data.getKennung() + " -> " + _data.getProgramm().toString());
	  
		return _data;
	}

	public String getKennung()
	{
		return _kennung;
	}

	private void initGui(Composite parent)
	{
		Composite top = new Composite(parent, SWT.NONE);
		top.setLayout(new GridLayout(1, false));

		Composite compositeContent = getCompositeContent(top);
		Composite compositeCtrl = getCompositeCtrl(top);

		GridData gdCompContent = new GridData();
		gdCompContent.grabExcessHorizontalSpace = true;
		gdCompContent.grabExcessVerticalSpace = true;
		gdCompContent.verticalAlignment = GridData.FILL;
		gdCompContent.horizontalAlignment = GridData.FILL;
		compositeContent.setLayoutData(gdCompContent);

		GridData gdCompCtrl = new GridData();
		gdCompCtrl.grabExcessHorizontalSpace = true;
		gdCompCtrl.grabExcessVerticalSpace = false;
		gdCompCtrl.horizontalAlignment = GridData.FILL;
		compositeCtrl.setLayoutData(gdCompCtrl);
	}

	private Composite getCompositeContent(Composite parent)
	{
		Composite compContent = new Composite(parent, SWT.BORDER);

		getCompositeAbschnitt(compContent);
		getCompositeInfotext(compContent);
		getCompositeKommentar(compContent);

		compContent.setLayout(new GridLayout(1, false));

		GridData gdLAbs = new GridData();
		gdLAbs.horizontalSpan = 1;
		gdLAbs.grabExcessHorizontalSpace = true;
		gdLAbs.horizontalAlignment = GridData.FILL;
		getCompositeAbschnitt(compContent).setLayoutData(gdLAbs);

		GridData gdCompInfoText = new GridData();
		gdCompInfoText.grabExcessHorizontalSpace = true;
		gdCompInfoText.grabExcessVerticalSpace = true;
		gdCompInfoText.horizontalAlignment = GridData.FILL;
		gdCompInfoText.verticalAlignment = GridData.FILL;
		getCompositeInfotext(compContent).setLayoutData(gdCompInfoText);

		GridData gdTKommentar = new GridData();
		gdTKommentar.grabExcessHorizontalSpace = true;
		gdTKommentar.horizontalAlignment = GridData.FILL;
		gdTKommentar.heightHint = 50;
		gdTKommentar.verticalAlignment = GridData.FILL;
		getCompositeKommentar(compContent).setLayoutData(gdTKommentar);

		return compContent;
	}

	private Composite getCompositeAbschnitt(Composite parent)
	{
		if (_compAbschnitt == null)
		{
			_compAbschnitt = new Composite(parent, SWT.BORDER);

			_lAbschnitt = new Label(_compAbschnitt, SWT.NONE);
//			Font fontAbschnitt = new Font(null, "Arial", 12, SWT.BOLD);
			_lAbschnitt.setFont(DefsFonts.FONT_ARIAL_12_PKT_BOLD);
			_lAbschnitt
					.setText("Abschnitt: _____________________________________________");

			_compAbschnitt.setLayout(new GridLayout(1, false));

			GridData gdLAbschnitt = new GridData();
			gdLAbschnitt.grabExcessHorizontalSpace = true;
			gdLAbschnitt.horizontalAlignment = GridData.CENTER;
			_lAbschnitt.setLayoutData(gdLAbschnitt);
		}

		return _compAbschnitt;
	}

	private Composite getCompositeInfotext(Composite parent)
	{
		if (_compInfoTxt == null)
		{
			_compInfoTxt = new Composite(parent, SWT.BORDER);

			Label lFrag1 = new Label(_compInfoTxt, SWT.None);
			lFrag1.setImage(getAchtungImage());
//			lFrag1.setImage(getKameraImageRechts());

			_lInfoTxt = new Label(_compInfoTxt, SWT.CENTER);
//			Font fontInfoTxt = new Font(null, "Arial", 18, SWT.BOLD);
			_lInfoTxt.setFont(DefsFonts.FONT_ARIAL_18_PKT_BOLD);
			_lInfoTxt.setText("Ist der Abschnitt frei und\nkann geschalten werden?");

			Label lFrag2 = new Label(_compInfoTxt, SWT.None);
		  lFrag2.setImage(getAchtungImage());
//			lFrag2.setImage(getKameraImageLinks());

			_compInfoTxt.setLayout(new GridLayout(3, false));

			GridData gdLFrag1 = new GridData();
			gdLFrag1.grabExcessHorizontalSpace = true;
			gdLFrag1.grabExcessVerticalSpace = true;
			gdLFrag1.horizontalAlignment = GridData.CENTER;
			gdLFrag1.verticalAlignment = GridData.CENTER;
			lFrag1.setLayoutData(gdLFrag1);

			GridData gdLInfoTxt = new GridData();
			gdLInfoTxt.grabExcessHorizontalSpace = true;
			gdLInfoTxt.horizontalAlignment = GridData.CENTER;
			_lInfoTxt.setLayoutData(gdLInfoTxt);
			_lInfoTxt
					.setText("______________________________\n______________________________\n______________________________");

			GridData gdLFrag2 = new GridData();
			gdLFrag2.grabExcessHorizontalSpace = true;
			gdLFrag2.grabExcessVerticalSpace = true;
			gdLFrag2.horizontalAlignment = GridData.CENTER;
			gdLFrag2.verticalAlignment = GridData.CENTER;
			lFrag2.setLayoutData(gdLFrag2);
		}

		return _compInfoTxt;
	}

	private static Image getAchtungImage()
	{
		if (_achtungImg == null)
		{
			_achtungImg = Activator
					.getImageDescriptor("icons/fragezeichen_96x96.png").createImage();
		}

		return _achtungImg;
	}

	private static Image getKameraImageLinks()
	{
		if (_kameraImageLinks == null)
		{
			_kameraImageLinks = Activator.getImageDescriptor(
					"icons/Camera_links_96x96.png").createImage();
		}

		return _kameraImageLinks;
	}

	private static Image getKameraImageRechts()
	{
		if (_kameraImageRechts == null)
		{
			_kameraImageRechts = Activator.getImageDescriptor(
					"icons/Camera_rechts_96x96.png").createImage();
		}

		return _kameraImageRechts;
	}

	private Composite getCompositeKommentar(Composite parent)
	{
		if (_groupKommentar == null)
		{
			_groupKommentar = new Group(parent, SWT.NONE);
			_groupKommentar.setText("Kommentar:");

			_tKommentar = new Text(_groupKommentar, SWT.MULTI | SWT.WRAP
					| SWT.H_SCROLL | SWT.V_SCROLL);
			_tKommentar.setEditable(false);

			_groupKommentar.setLayout(new FillLayout());
		}
		return _groupKommentar;
	}

	private Composite getCompositeCtrl(Composite parent)
	{
		Composite compCtrl = new Composite(parent, SWT.BORDER);

		GridData gridDataButton = new GridData();
		gridDataButton.horizontalAlignment = GridData.CENTER;
		gridDataButton.grabExcessHorizontalSpace = true;
		gridDataButton.grabExcessVerticalSpace = true;
		gridDataButton.verticalAlignment = GridData.CENTER;
		gridDataButton.minimumWidth = 100;

		Button bSchalten = new Button(compCtrl, SWT.PUSH);
		bSchalten.setLayoutData(gridDataButton);
		bSchalten.setText("&Schalten");
		bSchalten.addSelectionListener(new SelectionAdapter()
		{

			@Override
			public void widgetSelected(SelectionEvent e)
			{
				aktionSchalten();
			}

		});

		// Button bNichtSchalten = new Button(compCtrl, SWT.PUSH);
		// bNichtSchalten.setText("&Nicht Schalten");
		// bNichtSchalten.addSelectionListener(new SelectionAdapter()
		// {
		//
		// @Override
		// public void widgetSelected(SelectionEvent e)
		// {
		// aktionNichtSchalten();
		// }
		//
		// });

		Button bAbbrechen = new Button(compCtrl, SWT.PUSH);
		bAbbrechen.setLayoutData(gridDataButton);
		bAbbrechen.setText("&Abbrechen");
		bAbbrechen.addSelectionListener(new SelectionAdapter()
		{

			@Override
			public void widgetSelected(SelectionEvent e)
			{
//				aktionAbbrechen();
			}

		});
		// Im Fall der Schnellsperrung macht Abbrechen keinen Sinn...
		bAbbrechen.setEnabled(false);
		
		Button bHilfe = new Button(compCtrl, SWT.PUSH);
		bHilfe.setLayoutData(gridDataButton);
		bHilfe.setText("&Hilfe");
		bHilfe.addSelectionListener(new SelectionAdapter()
		{
			@Override
			public void widgetSelected(SelectionEvent e)
			{
				aktionHilfe();
			}
		});

		Button bWiedervorlage = new Button(compCtrl, SWT.PUSH);
		bWiedervorlage.setLayoutData(gridDataButton);
		bWiedervorlage.setText("&Wiedervorlage");
		bWiedervorlage.addSelectionListener(new SelectionAdapter()
		{
			@Override
			public void widgetSelected(SelectionEvent e)
			{
				if (_data != null)
				{
					new WiedervorlageTSFWeiterschalten(_data);
					// DialogWeiterschalten.this.dispose();
					// TODO SCHLIESSEN
					setSchliessenErlaubt(true);
					schliesseViewWeiterschalten(ViewSchnellsperrung.this.getViewSite()
							.getSecondaryId());
				}
			}
		});

		_bTonAusschalten = new Button(compCtrl, SWT.PUSH);
		_bTonAusschalten.setLayoutData(gridDataButton);
		_bTonAusschalten.setText("&Ton ausschalten");
		_bTonAusschalten.addSelectionListener(new SelectionAdapter()
		{
			@Override
			public void widgetSelected(SelectionEvent e)
			{
				if (_sndTimer != null)
				{
					schalteTonAus();
					_bTonAusschalten.setText("&Ton einschalten");
				} else
				{
					startSoundTimer();
					if (_sndTimer != null)
					{
						_bTonAusschalten.setText("&Ton ausschalten");
					}
				}
			}
		});
		_bTonAusschalten.setEnabled(PreferenceInit.isSndWeiterschaltenAktiv());

		// compCtrl.setLayout(new RowLayout(SWT.HORIZONTAL));
		compCtrl.setLayout(new GridLayout(5, false));
		// compCtrl.pack();

		return compCtrl;
	}

	private void aktionSchalten()
	{
		if (getData() != null)
		{
			SystemObject so = getData().getSo();
			M_TSFWeiterSchaltenAntwort antwort = new M_TSFWeiterSchaltenAntwort(so);
			antwort.setBefehl(E_TSFWeiterSchaltenAntwort.Schalten);
			antwort.setKennung(getKennung());
			String sendeWeiterschaltenAntwort = DaVKomTSFWeiterSchaltenAntwort
					.getInstance().sendeWeiterschaltenAntwort(antwort);

			// Nur wenn erfolgreich versandt Dialog schlieen.
			if (sendeWeiterschaltenAntwort == null)
			{
				// dispose();
				// TODO SCHLIESSEN
				setSchliessenErlaubt(true);
				schliesseViewWeiterschalten(this.getViewSite().getSecondaryId());
			}
		}
	}

	private void aktionNichtSchalten()
	{
		if (getData() != null)
		{
			SystemObject so = getData().getSo();
			M_TSFWeiterSchaltenAntwort antwort = new M_TSFWeiterSchaltenAntwort(so);
			antwort.setBefehl(E_TSFWeiterSchaltenAntwort.Nicht_schalten);
			antwort.setKennung(getKennung());
			String sendeWeiterschaltenAntwort = DaVKomTSFWeiterSchaltenAntwort
					.getInstance().sendeWeiterschaltenAntwort(antwort);

			// Nur wenn erfolgreich versandt Dialog schlieen.
			if (sendeWeiterschaltenAntwort == null)
			{
				// dispose();
				// TODO SCHLIESSEN
				setSchliessenErlaubt(true);
				schliesseViewWeiterschalten(this.getViewSite().getSecondaryId());
			}
		}
	}

	private void aktionAbbrechen()
	{
		if (getData() != null)
		{
			SystemObject so = getData().getSo();
			M_TSFWeiterSchaltenAntwort antwort = new M_TSFWeiterSchaltenAntwort(so);
			antwort.setBefehl(E_TSFWeiterSchaltenAntwort.Abbrechen);
			antwort.setKennung(getKennung());
			String sendeWeiterschaltenAntwort = DaVKomTSFWeiterSchaltenAntwort
					.getInstance().sendeWeiterschaltenAntwort(antwort);

			// Nur wenn erfolgreich versandt Dialog schlieen.
			if (sendeWeiterschaltenAntwort == null)
			{
				InfoWeiterschaltenAbgebrochen.getInstance()
						.benachrichtigeUeberAbgebrochenesWeiterschnalten(so.getPid());
				// dispose();
				// TODO SCHLIESSEN
				setSchliessenErlaubt(true);
				schliesseViewWeiterschalten(this.getViewSite().getSecondaryId());
			}
		}
	}

	@Override
	public void dispose()
	{
		super.dispose();

		// Sound abstellen
		schalteTonAus();

		PlatformUI.getWorkbench().removeWorkbenchListener(this);

	}

	private Timer startSoundTimer()
	{
		if (PreferenceInit.isSndWeiterschaltenAktiv())
		{
			if (_sndTimer == null)
			{
				int delaySndWf = PreferenceInit.getDelaySndWeiterschalten();
				final String pathSndWf = PreferenceInit.getPathSndWeiterschalten();

				TimerTask sndTask = new TimerTask()
				{
					@Override
					public void run()
					{
						new AePlayWave(pathSndWf).start();
					}
				};

				_sndTimer = new Timer("WF Weiterschalten Timer");
				_sndTimer.schedule(sndTask, 0l, delaySndWf * 1000l);
			}
		}

		return _sndTimer;
	}

	private void schalteTonAus()
	{
		if (_sndTimer != null)
		{
			_sndTimer.cancel();
			_sndTimer = null;
		}
	}

	public static ViewSchnellsperrung zeigeViewWeiterschalten(String pidAbschnitt)
	{
		ViewSchnellsperrung re = null;

		if (pidAbschnitt != null)
		{
			IWorkbenchWindow dw = PlatformUI.getWorkbench()
					.getActiveWorkbenchWindow();
			IWorkbenchPage page = dw.getActivePage();
			IViewReference ref = page.findViewReference(ViewSchnellsperrung.ID,
					pidAbschnitt);

			if (ref == null)
			{
				/*
				 * View erstellen und anzeigen.
				 */
				try
				{
					page.showView(ViewSchnellsperrung.ID, pidAbschnitt,
							IWorkbenchPage.VIEW_ACTIVATE);
					ref = page.findViewReference(ViewSchnellsperrung.ID, pidAbschnitt);
				} catch (PartInitException e)
				{
					e.printStackTrace();
				}

				if (ref != null)
				{
					((WorkbenchPage) page).getActivePerspective().getPresentation()
							.detachPart(ref);
					IWorkbenchPart wbPart = ref.getPart(false);

					IViewPart viewPart = ref.getView(false);
					if (viewPart instanceof ViewSchnellsperrung)
					{
						ViewSchnellsperrung viewWeiterschalten = (ViewSchnellsperrung) viewPart;
						re = viewWeiterschalten;
					}

					Shell shell = wbPart.getSite().getShell();
					shell.setSize(BREITE, HOEHE);

					/*
					 * Statische Anordnung des Dialoges auf dem Bildschirm
					 */
					if (pidAbschnitt != null)
					{
						Point location = StaticDialogLocation.getInstance().getDlgLoc(
								ViewSchnellsperrung.class.getName(), pidAbschnitt);
						if (location != null)
						{
							shell.setLocation(location);
						}
					}

				}
			} else
			{
				/*
				 * Existierender View den Focus geben.
				 */
				try
				{
					page.showView(ViewSchnellsperrung.ID, pidAbschnitt,
							IWorkbenchPage.VIEW_ACTIVATE);
					IViewPart viewPart = ref.getView(false);
					if (viewPart instanceof ViewSchnellsperrung)
					{
						ViewSchnellsperrung viewWeiterschalten = (ViewSchnellsperrung) viewPart;
						re = viewWeiterschalten;
					}
				} catch (PartInitException e)
				{
					e.printStackTrace();
				}
			}
		}

		return re;
	}

	/**
	 * Prft ob eine View zur Darstellung des Weiterschaltens existiert.
	 * 
	 * @param pidAbschnitt
	 *          PID des TSF-Abschnitts, fr den geprft werden soll.
	 * @return Liefert <code>true</code> wenn die View bereits existiert, sonst
	 *         <code>false</code>.
	 */
	public static boolean existiertViewWeiterschalten(String pidAbschnitt)
	{
		boolean re = false;

		if (pidAbschnitt != null)
		{
			IWorkbenchWindow dw = PlatformUI.getWorkbench()
					.getActiveWorkbenchWindow();
			IWorkbenchPage page = dw.getActivePage();
			IViewReference ref = page.findViewReference(ViewSchnellsperrung.ID,
					pidAbschnitt);
			if (ref != null)
			{
				re = true;
			}
		}

		return re;
	}

	/**
	 * Schliet die View zum Weiterschalten an Hand der PID des jeweiligen
	 * TSF-Abschnitts.
	 * 
	 * @param pidAbschnitt
	 *          PID des jeweiligen TSF-Abschnitts.
	 * @return Liefert <code>true</code> wenn die View erfolgreich geschlossen
	 *         werden konnte, sonst <code>false</code>.
	 */
	public static boolean schliesseViewWeiterschalten(String pidAbschnitt)
	{
		boolean viewKonnteGeschlossenWerden = true;

		if (pidAbschnitt != null)
		{
			if (existiertViewWeiterschalten(pidAbschnitt))
			{
				IWorkbenchWindow dw = PlatformUI.getWorkbench()
						.getActiveWorkbenchWindow();
				IWorkbenchPage page = dw.getActivePage();
				IViewReference ref = page.findViewReference(ViewSchnellsperrung.ID,
						pidAbschnitt);
				IViewPart view = ref.getView(false);
				if (view instanceof ViewSchnellsperrung)
				{
					ViewSchnellsperrung viewWeiterschalten = (ViewSchnellsperrung) view;
					viewWeiterschalten.setSchliessenErlaubt(true);
				}

				if ((view != null) && (view.getViewSite() != null)
						&& (view.getViewSite().getPage() != null))
				{
					view.getViewSite().getPage().hideView(view);
				}

			} else
			{
				/*
				 * View existiert nicht und kann nicht geschlossen werden.
				 */
				// String msg = "ViewWeiterschalten fr Abschnitt(-PID) " + pidAbschnitt
				// + " existiert nicht und kann nicht geschlossen werden!";
				// ViewTools.log(msg, IStatus.WARNING, null);
			}
		}

		return viewKonnteGeschlossenWerden;
	}

	public void setSchliessenErlaubt(boolean schliessenErlaubt)
	{
		this._schliessenErlaubt = schliessenErlaubt;
		firePropertyChange(IWorkbenchPartConstants.PROP_DIRTY);
	}

	public boolean isSchliessenErlaubt()
	{
		return _schliessenErlaubt;
	}

	@Override
	public int promptToSaveOnClose()
	{
		return ISaveablePart2.CANCEL;
	}

	@Override
	public void doSave(IProgressMonitor monitor)
	{
	}

	@Override
	public void doSaveAs()
	{
	}

	@Override
	public boolean isDirty()
	{
		return !isSchliessenErlaubt();
	}

	@Override
	public boolean isSaveAsAllowed()
	{
		return false;
	}

	@Override
	public boolean isSaveOnCloseNeeded()
	{
		return true;
	}

	@Override
	public void postShutdown(IWorkbench workbench)
	{
		// TODO Auto-generated method stub

	}

	@Override
	public boolean preShutdown(IWorkbench workbench, boolean forced)
	{
		/*
		 * Detachte Darstellung wieder attachen.
		 */
		String secondaryId = getViewSite().getSecondaryId();
		IViewReference ref = ViewTools.searchViewReference(ViewSchnellsperrung.ID,
				secondaryId);

		IWorkbenchWindow dw = PlatformUI.getWorkbench().getActiveWorkbenchWindow();
		IWorkbenchPage page = dw.getActivePage();

		if (ref != null)
		{
			ViewPane pane = (ViewPane) ((WorkbenchPartReference) ref).getPane();
			((WorkbenchPage) page).getActivePerspective().getPresentation()
					.attachPart(ref);
		} else
		{

			String msg = "ViewWeiterschalten::preShutdown -> Es ist keine View mit ID="
					+ ViewSchnellsperrung.ID
					+ " und Secondary-ID "
					+ secondaryId
					+ " auffindbar.";

			System.err.println(msg);
			ViewTools.log(msg, IStatus.WARNING, null);
		}

		schliesseViewWeiterschalten(secondaryId);
		return true;
	}
	
	private void aktionHilfe()
	{
		PlatformUI.getWorkbench().getHelpSystem().displayHelp(Activator.PLUGIN_ID + ".workflowschnellsperren");
	}
}
