/*******************************************************************************
 * This file is part of Rahmenwerk.
 * 
 * Rahmenwerk is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License  as 
 * published by the Free Software Foundation, either version 3 of the
 * License.
 * 
 * Rahmenwerk is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with Rahmenwerk.  If not, see <http://www.gnu.org/licenses/>.
 *  
 *  
 * 
 * Copyright (c) 2012 SWARCO TRAFFIC SYSTEMS GmbH.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 * SWARCO TRAFFIC SYSTEMS GmbH - initial API and implementation
 * 
 * 
 * 
 * Contact Information:
 * SWARCO TRAFFIC SYSTEMS GmbH
 * Adolf-Dambach-Strae 
 * D-76571 Gaggenau
 * Phone: +49-7225-64-03
 * Fax: +49-7225-64-300
 * mailto: office.sts@swarco.de
 ******************************************************************************/
package de.sts.buv.plugin.workflow.tsf.jface;

import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.Timer;
import java.util.TimerTask;

import org.eclipse.swt.SWT;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.layout.FillLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Event;
import org.eclipse.swt.widgets.Listener;
import org.eclipse.swt.widgets.MessageBox;
import org.eclipse.swt.widgets.Shell;

public class ShellTest
{

	public ShellTest(Shell parentShell)
	{
		Shell shell = null;
		Display display = null;

		if (parentShell == null)
		{
			display = new Display();
			shell = new Shell(display);
			shell.setText("Shell");
			shell.setSize(200, 200);
			shell.setLocation(10, 10);

			shell.open();
		} else
		{
			shell = parentShell;
		}

		createChildWindow(shell, "Subwindow #1", 10, 220);
		createChildWindow(shell, "Subwindow #2", 220, 220);
		createChildWindow(shell, "Subwindow #3", 430, 220);
		createChildWindowWithChilds(shell, "ChildGener", 400, 10);

		new OpenRanWindLtr(shell);

		if (parentShell == null)
		{
			while (!shell.isDisposed())
			{
				if (!display.readAndDispatch())
					display.sleep();
			}
			display.dispose();
		}
	}

	public static void createChildWindow(Shell parentShell, String txt, int x,
			int y)
	{
		Shell dialog = new Shell(parentShell);
		dialog.setText(txt);
		dialog.setSize(200, 200);
		dialog.setLocation(x, y);

		final Shell sh = dialog;

		dialog.addListener(SWT.Close, new Listener()
		{
			public void handleEvent(Event event)
			{
				int style = SWT.APPLICATION_MODAL | SWT.YES | SWT.NO
						| SWT.ICON_QUESTION;
				MessageBox messageBox = new MessageBox(sh, style);
				messageBox.setText("Information");
				messageBox.setMessage("Close the shell?");
				event.doit = messageBox.open() == SWT.YES;
			}
		});

		dialog.setLayout(new FillLayout());

		final Button bu = new Button(dialog, SWT.PUSH);
		bu.setText("Klick mich");
		bu.addSelectionListener(new SelectionAdapter()
		{
			@Override
			public void widgetSelected(SelectionEvent e)
			{
				SimpleDateFormat sdf = new SimpleDateFormat("HH:mm:ss,SSS");
				bu.setText("Angeklickt @ " + sdf.format(new Date()));
			}

		});

		dialog.open();
	}

	public static void createChildWindowWithChilds(Shell parentShell, String txt,
			int x, int y)
	{
		Shell dialog = new Shell(parentShell);
		dialog.setText(txt);
		dialog.setSize(200, 200);
		dialog.setLocation(x, y);

		final Shell sh = dialog;

		dialog.addListener(SWT.Close, new Listener()
		{
			public void handleEvent(Event event)
			{
				int style = SWT.APPLICATION_MODAL | SWT.YES | SWT.NO
						| SWT.ICON_QUESTION;
				MessageBox messageBox = new MessageBox(sh, style);
				messageBox.setText("Information");
				messageBox.setMessage("Close the shell?");
				event.doit = messageBox.open() == SWT.YES;
			}
		});

		dialog.setLayout(new FillLayout());

		final Button bu = new Button(dialog, SWT.PUSH);
		bu.setText("Klick mich");
		bu.addSelectionListener(new SelectionAdapter()
		{
			@Override
			public void widgetSelected(SelectionEvent e)
			{
				SimpleDateFormat sdf = new SimpleDateFormat("HH:mm:ss,SSS");
				bu.setText("Angeklickt @ " + sdf.format(new Date()));
				System.out.println("HERE!");
				for (int i = 0; i < 3; i++)
				{
					String txt = "SubSubChild #" + i;
					createChildWindow(sh, txt, 10 + (i * 200), 500);
				}

			}

		});

		dialog.open();
	}

	public class OpenRanWindLtr
	{
		public OpenRanWindLtr(final Shell parentShell)
		{
			TimerTask task = new TimerTask()
			{
				@Override
				public void run()
				{
					Runnable run = new Runnable()
					{

						@Override
						public void run()
						{
							DialogTest dlg = new DialogTest(parentShell);
							dlg.open();
						}
					};
					parentShell.getDisplay().asyncExec(run);

				}
			};

			Timer timer = new Timer("Dlg Opener");
			timer.schedule(task, 5000l);
		}
	}

	public static void main(String[] args)
	{
		new ShellTest(null);
	}

}
